#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <fcntl.h>
#include <unistd.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <sys/times.h>
#include <signal.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <sys/wait.h>
#include <mpi.h>


#define FALSE	0
#define TRUE	1


/* 
 * Definicio de tipos de datos.
 */

typedef	char	firma_t[64];

/* Parametros que define el usuario para controlar la ejecucion. */
typedef struct {
	char	nombre_solver[50];
	int	n_resul;
	char	flag_ent[2][16];
} parametros_t;

/* Estadisticas de ejecucion */
typedef struct {
	double	exetotal;
	double	systotal;
	double	cputotal;
	double	comtotal;
	double	exenodo;
	double	sysnodo;
	double	cpunodo;
	double	comnodo;
} tiempos_t;

/* Datos auxiliares para calcular los tiempos de comunicacion. */
typedef struct {
	clock_t ini1;
	clock_t fin1;
	clock_t ini2;
	clock_t *fin2;
} tiempos_aux_t;

/* Datos asociados al fichero */
typedef struct {
	char	name[32];
	int	size;
	char	*contenido;
} file_t;

/* Resultados que devuelve el slave */
typedef struct {
	firma_t	*firmas;
	float	*semejanzas;
} resultados_t;

/* 
 * Funciones del master.c 
 */
void Leer_parametros (parametros_t *);
void Leer_firma (file_t *);
void Enviar_parametros (parametros_t);
void Enviar_firma (file_t);
int Recibir_resultados (resultados_t  *, parametros_t, int, clock_t *);
void Seleccionar_mejores (resultados_t, parametros_t, int, resultados_t *, int);
void Recibir_tiempos (tiempos_t *, tiempos_aux_t, int);

/* 
 * Funciones auxiliares del master.c 
 */
void Esc_firma (file_t);

/* 
 * Funciones del slave.c 
 */
void Recibir_parametros (parametros_t *);
void Recibir_firma (file_t *, clock_t *);
void Ejecutar_solver (char *, parametros_t);
void Leer_resultados (resultados_t *, parametros_t);
void Enviar_resultados (resultados_t, parametros_t, clock_t *);
void Enviar_tiempos (double, double, double, clock_t, clock_t);

/* 
 * Funciones auxiliares del slave.c.c 
 */
void Esc_param (parametros_t);
void Resultados (int *, parametros_t);
void seleccionar (int *, int *);
