/************************** SECCION DE MACROS *****************************
**************************************************************************/
#ifndef DEFINICIONES
#define DEFINICIONES
#define max(x,y) x>y?x:y
#define min(x,y) x<y?x:y
#define EQ     1
#define NEQ    0
#define MEDIA  22
#define VARIANZA 23

/* Niveles que se tienen en cuenta en el metodo de Jacobs */
#define NIVEL 6

/* 
  Identificacion de los cuatro cuadrantes de coeficientes de cada nivel y
 de las formas de combinarlos
*/
#define V  0   /* Cuadrante de detalle vertical */
#define D  1   /* Cuadrante de detalle diagonal */
#define H  2   /* Cuadrante de detalle horizontal */
#define A  3   /* Cuadrante de analisis */
#define M  4   /* Cuadrantes diagonal y analisis como una sola region */
#define U  5   /* Cuadrantes horizontal y vertical como una sola region */
#define C  6   /* Combinacin de cuadrantes horizontal y vertical mediante la
		  sqrt de la suma de los cuadrados */


#ifndef NORMALIZAR
#define NORMALIZAR
#endif

/* Definicion del tipo que se va a utilizar */
#define TIPO float

/******************** SECCION DE DEFINICION DE TIPOS **********************
**************************************************************************/
typedef struct /*Celda*/
{
  TIPO val;
  int x;
  int y;
  int z;
} Celda;

#endif
