#ifndef QUERYING
#define QUERYING
#include <math.h>
#include "../libpgm/libpgm.h"
#include "transformadas.h"
#include "comun.h"


/********************** SECCION DE PROTOTIPOS *****************************
**************************************************************************/

/*
   Conversio'n de un puntero a TIPO a un puntero a Celda
*/
void Convertir2D (TIPO *in, Celda **out, int tam_x, int tam_y);

/* Lo mismo pero quedandose con una imagen de tamano tam_final*/
void CortarYConvertir2D (TIPO *in, Celda **out, int tam_final);


void Lee_pnm_TIPO (int *alto, int *ancho, char *nombre,
                    TIPO **img1, TIPO **img2, TIPO **img3);

void Lee_pgm_TIPO (int *alto, int *ancho, char *nombre,
                    TIPO **img1, TIPO **img2, TIPO **img3);

/* Paso de RGB a YIQ */
void ToYIQ(int tam_x, int tam_y, TIPO **img, TIPO **y, TIPO **i, TIPO **q);

int DeterminarTamano(int x, int y);

void Cambiar_Tamano(int ancho,int alto, TIPO *img, int tamano_final, 
		    TIPO **img_salida);

int EscribirTres (Celda **tres, int tam, FILE *ffsal, char *nombre);

int LeerTres (Celda *tres[], int tam, FILE *ffent, char *nombre);

void DescomponerTres (TIPO **tres, int filas, int col, int e_filas, int e_col);

TIPO **CalcularEnergias(TIPO *plano, int filas, int columnas);

TIPO ***CalcularCovarianzas(TIPO *plano1, TIPO *plano2, TIPO *plano3,
			     int filas, int columnas);

TIPO ***NormalizarCov(TIPO **e1, TIPO **e2, TIPO **e3,
                       TIPO ****cov, int filas, int columnas);

int EscribirCorrelaciones (TIPO ***corr, int filas, int columnas, 
                           char *nombre);

TIPO ***LeerCorrelaciones (char *nombre, int tamano);

void Liberar (TIPO ****correlaciones, int tamano);

void CalcularEnergiaTotal(TIPO *plano, int filas, int columnas, 
			  TIPO *energ);

void Escribe_pgm (int alto, int ancho, char *nombre, TIPO *img, int conv);

void Umbralizar (TIPO **plano, int filas, int columnas, int tipo_umbral);

void UmbralizarUser (TIPO **plano, int filas, int columnas,
                     TIPO e_umbral, int tipo_umbral);


/**************** Momentos de orden 1 y 2 en cada cuadrante *****************
****************************************************************************/
TIPO ***CalcularMomentos(TIPO *plano, int filas, int columnas);

int EscribirMomentos (TIPO ***m, int filas, int columnas, char *nombre);

TIPO ***LeerMomentos (char *nombre, int tamano);


/******** Momentos de orden 1, 2 y 3 en todo el nivel de resolucion ********* 
****************************************************************************/
TIPO **CalcularMomentosTres (TIPO *plano, int filas, int columnas);

int EscribirMomentosTres (TIPO ***m, int filas, int columnas, char *nombre);

TIPO ***LeerMomentosTres (char *nombre, int tamano);

void LiberarMomentosTres (TIPO ***momentos, int tamano);


/**************** Momentos de orden 1,2 y 3 en cada cuadrante ***************
****************************************************************************/
TIPO ***CalcularMTres_S(TIPO *plano, int filas, int columnas);

int EscribirMTres_S (TIPO ****m, int filas, int columnas, char *nombre);

TIPO ****LeerMTres_S (char *nombre, int tamano);

void LiberarMomentos (TIPO ****momentos, int tamano);

/**************** Momentos de orden 1,2 y 3 en la transformada *************
****************************************************************************/
TIPO  **DescYMom (TIPO *c, int tamano, int hay_umbral, TIPO umbral_user);

/**************** Momentos de orden 1,2 y 3 en la transformada *************
****************************************************************************/
TIPO  ***DescYMom2 (TIPO *c, int tamano, int hay_umbral, TIPO umbral_user,
                      int umbraliz_equiv);

int EscribirMomAnalDet (TIPO ****m, int filas, int columnas, char *nombre);

TIPO ****LeerMomAnalDet (char *nombre, int tamano);

void LiberarMomAnalDet (TIPO ****momentos, int tamano);




int EscribirE_Total (TIPO e1, TIPO e2, TIPO e3, char *nombre);

int LeerE_Total (char *nombre, TIPO *e1, TIPO *e2, TIPO *e3);


/************** Energias en los coeficientes de analisis *******************
****************************************************************************/
TIPO **NormalizarCovAnal(TIPO **e, TIPO ***cov, int tamano);

TIPO  **DescYEnerg (TIPO *c, TIPO *c2, TIPO *c3, int tamano, 
		      TIPO ***covs); 

int EscribirCorrAnal (TIPO **corr, int tamano, char *nombre);

TIPO **LeerCorrAnal (char *nombre, int tamano);

void LiberarCorrAnal (TIPO ***correlaciones, int tamano);

/****** Energias sobre los coefs. de analisis y el cuadrante diagonal ******
****************************************************************************/
TIPO ***NormalizarCovA_2(TIPO ***e, TIPO ****cov, int tamano);

TIPO  ***DescYEnerg2 (TIPO *c, TIPO *c2, TIPO *c3, int tamano, 
			TIPO ****covs);

int EscribirCorrA_2 (TIPO ***corr, int tamano, char *nombre);

TIPO ***LeerCorrA_2 (char *nombre, int tamano);

void LiberarCorrA_2 (TIPO ****correlaciones, int tamano);

/**************** Momentos de orden 1,2 y 3 en la transformada *************
#######################################MONOCROMO############################
****************************************************************************/
TIPO *ToMonocromo(TIPO **img,int tamano);

int EscribirMomentosTGrises (TIPO **m, int filas, int columnas,
                             char *nombre);

TIPO **LeerMomentosTGrises (char *nombre, int tamano);

void LiberarMomentosTGrises (TIPO ***momentos, int tamano);


/*** Momentos de orden 1,2 y 3 en coefs de analisis y cuadrante D ***********
#######################################MONOCROMO############################
****************************************************************************/
int EscribirMomentosTDGrises (TIPO ***m, int filas, int columnas, 
			      char *nombre);

TIPO ***LeerMomentosTDGrises (char *nombre, int tamano);

void LiberarMomentosTDGrises(TIPO ****momentos, int tamano);

/**************** Momentos de orden 1,2 y 3 en la transformada *************
#######################################MONOCROMO############################
****************************************************************************/
TIPO  **DescYMom1_2 (TIPO *c, int tamano, TIPO umbral_user);

int EscribirMomentos2Grises (TIPO **m, int filas, int columnas,
			     char *nombre);

TIPO **LeerMomentos2Grises (char *nombre, int tamano);

TIPO  ***DescYMom1_2D (TIPO *c, int tamano, int hay_umbral, 
		       TIPO umbral_user, int umbraliz_equiv);

int EscribirMomentos2DGrises (TIPO ***m, int filas, int columnas, 
			      char *nombre);

TIPO ***LeerMomentos2DGrises (char *nombre, int tamano);

/*
**************************** NUEVA TECNICA ********************************
   Calculo de energias en los coeficientes de analisis y de momentos en
los coeficientes de detalle del cuadrante diagonal.
***************************************************************************
*/
TIPO **CalcularMomTres_D(TIPO *plano, int filas, int columnas);

int EscribirEn_Mom (TIPO ***em, int tamano, char *nombre);

TIPO ***LeerEn_Mom (char *nombre, int tamano);

void LiberarEn_Mom (TIPO ****en_mom, int tamano);
 
/*
**************************** NUEVA TECNICA ********************************
   Calculo de momentos en los coeficientes de analisis y de detalle del 
cuadrante diagonal como si fueran una sola region (COLOR).
***************************************************************************
*/

TIPO  **DescYMom2AD (TIPO *c, int tamano, int hay_umbral, TIPO umbral_user,
	             int umbraliz_equiv); 
TIPO  **DescYMom3AD (TIPO *c, int tamano, int hay_umbral, TIPO umbral_user,
		     int umbraliz_equiv); 

/*************************** NUEVA TECNICA ********************************
**************************************************************************/

/**************************************************************************
** Calculo de los momentos de orden 2 o 3 sobre los cuadrantes diagonal  **
** y horizontal como si fueran una sola region, ademas de los de         **
** analisis y diagonales como si fueran una sola region                  **
**************************************************************************/
TIPO ***DescYMomTodos (TIPO *c, int tamano, int orden, int hay_umbral, 
		       TIPO umbral_user, int combinacion);

int EscribirMomTodos (TIPO ****m, int filas, int columnas,
			char *nombre, int orden);

TIPO ****LeerMomTodos (char *nombre, int tamano, int orden);





void DescomponerDebug (TIPO *tres,int filas,int col,int e_filas,int e_col);
int EscribirMomentosDebug (TIPO ***m, int filas, int columnas, char *nombre);
TIPO ***LeerMomentosDebug (char *nombre, int tamano);
void LiberarMomentosDebug (TIPO ***momentos, int tamano);

#endif
