#include "../include/querying2D.h"
#define NORMALIZAR



void Calcular_firma (imagen, firma)
     char *imagen;
     char *firma;
{

  int tam_x, tam_y, tam_unico;
  int retonno,i,j, resolucion, seguir;
  TIPO tonta;

  TIPO ***energa_2;
  TIPO ***covarianzas, ***correlaciones;

  TIPO *v[3];



  Lee_pnm_TIPO(&tam_x, &tam_y, imagen, &v[0], &v[1], &v[2]);
      
  tam_unico = DeterminarTamano(tam_x, tam_y);
  if (tam_unico)
  {
    printf("\nLa imagen debe ser cuadrada y de dimensiones potencia"
	   " de 2\n");
  } /* if tam_unico */
  else
  {
    if (tam_x != tam_y)
    {
      printf("\nSe requiere que la imagen sea cuadrada.\n");
    }
    else
    {
      tonta=(TIPO)(log((TIPO)tam_x)/log(2.0));
      resolucion=tonta;
      
      /* Reserva de energia para las covarianzas */
      covarianzas=(TIPO ***)calloc(resolucion, sizeof(TIPO **));
      if (covarianzas)
      {
	seguir=1;
	for (i=0; (i<resolucion) && (seguir); i++)
	{
	  covarianzas[i]=(TIPO **)calloc(2,sizeof(TIPO *));
	  seguir=(covarianzas[i] != NULL);
	  for (j=0; j<2; j++)
	  {
	    covarianzas[i][j]=(TIPO *)calloc(3,sizeof(TIPO));
	    seguir=(covarianzas[i][j] != NULL);
	  } /* for j */
	} /* for i */
      }
      if (!seguir)
      {
	perror("No se pudo reservar memoria para calcular "
	       "covarianzas");
	exit(1);
      }
      
      energa_2=DescYEnerg2 (v[0],v[1],v[2],tam_y, &covarianzas);
      
      /* Liberamos memoria */
      free(v[0]);
      v[0]=NULL;
      free(v[1]);
      v[1]=NULL;
      free(v[2]);
      v[2]=NULL;
      
      /* Normalizamos y conseguimos los coefs. de correlacion */
      /*printf("\nCorrelaciones: \n");*/
      correlaciones=NormalizarCovA_2(energa_2, &covarianzas, 
				     resolucion);
      
      /* Se supone que se ha liberado la memoria que ocupaban las 
	 covarianzas */
      
      retonno=EscribirCorrA_2(correlaciones, resolucion, firma);
    } /* else => if tam_x != tam_y */
  } /* else => if tam_unico */
} /* Calcular_Firma */
