#include "../include/querying2D.h"
#include "../include/bdd.h"

#ifndef NORMALIZAR
#define NORMALIZAR
#endif

#define DSIMPLE 33
#define DVALUADA 34
#define SEMEJANZA 35
#define CORRELACION 36
#define DPESOS 37
#define FIRMA_UMBRAL 1e-10
#define FILAS 128
#define COLUMNAS 128


TIPO *u[3], *v[3], *t[3], *w[3], *z;
Celda *vector[3], *imgbase[3];

/*
 * Variables globales para medir los tiempos de sistema y cpu.
 */

	struct tms tini, tend;

/* coefs no sirve para nada por el momento */
int ScoreQueryJacobs (TIPO **img,int filas, int columnas)
{
  TIPO scores;
  FILE *lista, *fent;
  char nombre[128];
  int retonno=333, tam_x, tam_y, tam_unico, lineas, cols, i;
  int coefs,cont,k;
  TIPO *vec[3],tonta;
  Celda *aux[3];
  int n_pasos_c, n_pasos_f, j;
  
  /* Pesos w para "scanned" en el espacio IYQ*/
  TIPO ws[3][6]={{5.0, 0.83, 1.01, 0.52, 0.47, 0.3},
		 {19.21, 1.26, 0.44, 0.53, 0.28, 0.14},
		 {34.37, 0.36, 0.45, 0.14, 0.18, 0.27}};


  int row=0,color=0,rowbase=0,seguir=1;
  

  lista = fopen("firmas.jac", "rb");
  if (lista == NULL)
  {
    perror("Error al abrir firmas.jac");
    return(-1);
  }
  retonno = fscanf(lista, "%s %d %d %d %d", nombre, &tam_x, &tam_y,
		     &n_pasos_c, &n_pasos_f);
  if ((retonno != 5) || (retonno == EOF))
  {
    perror("Formato incorrecto en firmas.jac");
    return(-1);
  }
  /* Determinacion de la voxelizacion */
  tam_unico = DeterminarTamano(filas,columnas);
  if (tam_unico)
  {
    Cambiar_Tamano (filas, columnas, img[0], tam_unico, &vec[0]);
    Cambiar_Tamano (filas, columnas, img[1], tam_unico, &vec[1]);
    Cambiar_Tamano (filas, columnas, img[2], tam_unico, &vec[2]);

    DescomponerTres (vec, tam_unico, tam_unico, n_pasos_c, n_pasos_f);

  }
  else
  {
    vec[0] = (TIPO *)malloc (filas*columnas*sizeof(TIPO));
    memcpy (vec[0],img[0],filas*columnas*sizeof(TIPO));
    vec[1] = (TIPO *)malloc (filas*columnas*sizeof(TIPO));
    memcpy (vec[1],img[1],filas*columnas*sizeof(TIPO));
    vec[2] = (TIPO *)malloc (filas*columnas*sizeof(TIPO));
    memcpy (vec[2],img[2],filas*columnas*sizeof(TIPO));

    DescomponerTres (vec, filas, columnas,n_pasos_c, n_pasos_f); 

  }



  /* SEA u LA MATRIZ QUE TENEMOS YA DESCOMPUESTA EN LA BASE DE DATOS */
  cont=0;
  while (retonno != EOF)
  {
    scores=0;
    if ((retonno != 5) && (retonno != EOF))
    {
      printf("\nError raro leyendo transformadas2D.sort\n");
      fclose(lista);
    }
    else if (retonno == 5)
    {
      coefs = tam_x-1; /* El tam_x de la firma es el n de coefs + 1 */
      
      if (cont == 0)
      {
	aux[0] = (Celda *)calloc(tam_x, sizeof(Celda));
	aux[1] = (Celda *)calloc(tam_x, sizeof(Celda));
	aux[2] = (Celda *)calloc(tam_x, sizeof(Celda));
	
	lineas=pow(2,(NIVEL-1));
	cols=lineas;
    
	CortarYConvertir2D (vec[0], &vector[0], lineas);
	CortarYConvertir2D (vec[1], &vector[1], lineas);
	CortarYConvertir2D (vec[2], &vector[2], lineas);

       	free(vec[0]);
	vec[0]=NULL;
	vector[0]=vector[0]+1;
	free(vec[1]);
	vec[1]=NULL;
	vector[1]=vector[1]+1;
	free(vec[2]);
	vec[2]=NULL;
	vector[2]=vector[2]+1;
	
	for (color=0; color <3; color++)
	{
	  k=SelectMayores(coefs/2, lineas*cols-1, &vector[color]);
	  vector[color]=vector[color]-1;
	  for (i=0; i<=k+1; i++) /* Incluimos el valor medio */
	  {
	    aux[color][i].val=vector[color][i].val;
	    aux[color][i].x=vector[color][i].x;
	    aux[color][i].y=vector[color][i].y;
	  }
	  vector[color]=vector[color]+1;
	  vector[color]=vector[color]+coefs/2;
	  
	  k=SelectMenores(coefs/2, lineas*cols-1-coefs/2, &vector[color]);
	  for (i=0; i<=k; i++) /* No incluimos el valor medio */
	  {
	    aux[color][coefs/2+1+i].val=vector[color][i].val;
	    aux[color][coefs/2+1+i].x=vector[color][i].x;
	    aux[color][coefs/2+1+i].y=vector[color][i].y;
	  }

	  vector[color] = vector[color]-coefs/2-1;
	  free(vector[color]);
	  vector[color]=NULL;
	  cont=1;
	}
      }/* if cont == 0 */
      fent = fopen(nombre, "rb");
      if (!fent)
      {
	printf("\nError al abrir %s\n",nombre);
	perror("");
	exit(1);
      }
      retonno=LeerTres(imgbase,coefs+1,fent,nombre);
	
      if (!retonno)
      {
	for (color=0; color<=2; color++)      
        {
	  scores = ws[color][0] * fabs(aux[color][0].val - imgbase[color][0].val);
  
          /* Buscamos los 60 Coefs. de de diferencias */
	  for (row=1; row<=coefs+1; row++)
	  {
	    seguir=1;
	    for (rowbase=1; (seguir) && (rowbase<=coefs+1); rowbase ++)
	    {
	      if (aux[color][row].val != 0)
              {
		if (imgbase[color][rowbase].val != 0)
	        {
		  if ((aux[color][row].x == imgbase[color][rowbase].x) &&
		    (aux[color][row].y == imgbase[color][rowbase].y))
		  {
		    /* Han de tener identico signo */
		    if ((aux[color][row].val * imgbase[color][rowbase].val)>0)
		    {
		      i=(aux[color][row].x>0?aux[color][row].x:1);
		      tonta=(log((TIPO)i)/log(2.0));
		      i=tonta;
		      j=(aux[color][row].y>0?aux[color][row].y:1);
		      tonta=(log((TIPO)j)/log(2.0));
		      j=tonta;
		      
		      scores -= ws[color][min(max(i,j),5)];

		      seguir=0;
		    }		
		  } /* if x == x && y == y */  
		} /* if imgbase */
	      } /* if aux */
	    } /* for rowbase */
	  } /* for row */
	}/* for color */
	fclose(fent);
      } /* if !retonno */
      printf("Semejanza con %s: %.12f\n",nombre,scores);
    } /* retonno == 5 */
    retonno = fscanf(lista, "%s %d %d %d %d", nombre, &tam_x, &tam_y,
		     &n_pasos_c, &n_pasos_f);

  }/* while */
  fclose(lista);
  free(imgbase[0]);
  free(imgbase[1]);
  free(imgbase[2]);
  free(aux[0]);
  free(aux[1]);
  free(aux[2]);
  return(0);
} /* ScoreQuery2DJacobs */



int ScoreQuery2DUmbral (TIPO **img,int filas, int columnas, TIPO umbral)
{
  TIPO scores,tonta;
  FILE *lista, *fent;
  char nombre[128];
  int retonno=333, tam_x, tam_y, tam_unico, lineas, cols, i,j;
  int coefs,cont,k;
  TIPO *vec[3];
  Celda *aux[3];
  int n_pasos_c, n_pasos_f;
  
  /* Pesos w para "scanned" */
  TIPO ws[3][6]={{5.0, 0.83, 1.01, 0.52, 0.47, 0.3},
		 {19.21, 1.26, 0.44, 0.53, 0.28, 0.14},
		 {34.37, 0.36, 0.45, 0.14, 0.18, 0.27}};
  

  int row=0,color=0;
  

  lista = fopen("transformadas2D.sort", "rb");
  if (lista == NULL)
  {
    perror("Error al abrir transformadas2D.sort");
    return(-1);
  }
  retonno = fscanf(lista, "%s %d %d %d %d", nombre, &tam_x, &tam_y,
		     &n_pasos_c, &n_pasos_f);
  if ((retonno != 5) || (retonno == EOF))
  {
    perror("Formato incorrecto en transformadas2D.sort");
    return(-1);
  }
  /* Determinacion de la voxelizacion */
  tam_unico = DeterminarTamano(filas,columnas);
  if (tam_unico)
  {
    Cambiar_Tamano (filas, columnas, img[0], tam_unico, &vec[0]);
    Cambiar_Tamano (filas, columnas, img[1], tam_unico, &vec[1]);
    Cambiar_Tamano (filas, columnas, img[2], tam_unico, &vec[2]);

    DescomponerTres (vec, tam_unico, tam_unico, n_pasos_c, n_pasos_f);

    lineas=tam_unico;
    cols=tam_unico;

  }
  else
  {
    vec[0] = (TIPO *)malloc (filas*columnas*sizeof(TIPO));
    memcpy (vec[0],img[0],filas*columnas*sizeof(TIPO));
    vec[1] = (TIPO *)malloc (filas*columnas*sizeof(TIPO));
    memcpy (vec[1],img[1],filas*columnas*sizeof(TIPO));
    vec[2] = (TIPO *)malloc (filas*columnas*sizeof(TIPO));
    memcpy (vec[2],img[2],filas*columnas*sizeof(TIPO));

    DescomponerTres (vec, filas, columnas,n_pasos_c, n_pasos_f); 

    lineas=filas;
    cols=columnas;
  }



  /* SEA u LA MATRIZ QUE TENEMOS YA DESCOMPUESTA EN LA BASE DE DATOS */
  cont=0;
  while (retonno != EOF)
  {
    scores=0;
    if ((retonno != 5) && (retonno != EOF))
    {
      printf("\nError raro leyendo transformadas2D.sort\n");
      fclose(lista);
    }
    else if (retonno == 5)
    {
      coefs = tam_x-1; /* El tam_x de la firma es el n de coefs + 1 */
      
      if (cont == 0)
      {
	aux[0] = (Celda *)calloc(tam_x, sizeof(Celda));
	aux[1] = (Celda *)calloc(tam_x, sizeof(Celda));
	aux[2] = (Celda *)calloc(tam_x, sizeof(Celda));

	CortarYConvertir2D (vec[0], &vector[0], lineas);
	CortarYConvertir2D (vec[1], &vector[1], lineas);
	CortarYConvertir2D (vec[2], &vector[2], lineas);

       	free(vec[0]);
	vec[0]=NULL;
	vector[0]=vector[0]+1;
	free(vec[1]);
	vec[1]=NULL;
	vector[1]=vector[1]+1;
	free(vec[2]);
	vec[2]=NULL;
	vector[2]=vector[2]+1;
	
	for (color=0; color <3; color++)
	{
	  k=SelectMayores(coefs/2, lineas*cols-1, &vector[color]);
	  vector[color]=vector[color]-1;
	  for (i=0; i<=k+1; i++) /* Incluimos el valor medio */
	  {
	    aux[color][i].val=vector[color][i].val;
	    aux[color][i].x=vector[color][i].x;
	    aux[color][i].y=vector[color][i].y;
	  }
	  vector[color]=vector[color]+1;
	  vector[color]=vector[color]+coefs/2;
	  
	  k=SelectMenores(coefs/2, lineas*cols-1-coefs/2, &vector[color]);
	  for (i=0; i<=k; i++) /* No incluimos el valor medio */
	  {
	    aux[color][coefs/2+1+i].val=vector[color][i].val;
	    aux[color][coefs/2+1+i].x=vector[color][i].x;
	    aux[color][coefs/2+1+i].y=vector[color][i].y;
	  }

	  vector[color] = vector[color]-coefs/2-1;
	  free(vector[color]);
	  vector[color]=NULL;
	  cont=1;
	}
      }/* if cont == 0 */
      fent = fopen(nombre, "rb");
      if (!fent)
      {
	printf("\nError al abrir %s\n",nombre);
	perror("");
	exit(1);
      }
      retonno=LeerTres(imgbase,coefs+1,fent,nombre);
	
      if (!retonno)
      {
	for (color=0; color<=2; color++)      
        {
	  scores = ws[color][0] * fabs(aux[color][0].val - imgbase[color][0].val);
  
          /* Buscamos los 60 Coefs. de de diferencias */
	  for (row=1; row<=coefs+1; row++)
          {
	    if (aux[color][row].val != 0)
            {
	      if (imgbase[color][row].val != 0)
	      {
	        if (umbral)
		{
		  if ((aux[color][row].x == imgbase[color][row].x) &&
                      (aux[color][row].y == imgbase[color][row].y) &&
		      (fabs(aux[color][row].val-imgbase[color][row].val) 
		       <= umbral))
		  {
		    i=(aux[color][row].x>0?aux[color][row].x:1);
		    tonta=(log((TIPO)i)/log(2.0));
		    i=tonta;
		    j=(aux[color][row].y>0?aux[color][row].y:1);
		    tonta=(log((TIPO)j)/log(2.0));
		    j=tonta;
		      
		    scores -= ws[color][min(max(i,j),5)];
		    /*
		    scores -= ws[color][min(row,5)];
		    */
		  }
		} /* if umbral */
		else
		{
		  if ((aux[color][row].x == imgbase[color][row].x) &&
		      (aux[color][row].y == imgbase[color][row].y))
		  {
		    i=(aux[color][row].x>0?aux[color][row].x:1);
		    tonta=(log((TIPO)i)/log(2.0));
		    i=tonta;
		    j=(aux[color][row].y>0?aux[color][row].y:1);
		    tonta=(log((TIPO)j)/log(2.0));
		    j=tonta;
		      
		    scores -= ws[color][min(max(i,j),5)];
		    /*
		      scores -= ws[color][min(row,5)];
		    */
		  }
		}
	      }
	    }  
	  }
	}/* for color */
	fclose(fent);
      } /* if !retonno */
      printf("Semejanza con %s: %.12f\n",nombre,scores);
    } /* retonno == 5 */
    retonno = fscanf(lista, "%s %d %d %d %d", nombre, &tam_x, &tam_y,
		     &n_pasos_c, &n_pasos_f);

  }/* while */
  fclose(lista);
  free(imgbase[0]);
  free(imgbase[1]);
  free(imgbase[2]);
  free(aux[0]);
  free(aux[1]);
  free(aux[2]);
  return(0);
} /* ScoreQuery2DUmbral */





int *GenerarVecinos(int x_origen,int y_origen, int dist_vecin,
		    int *num_vecin,int lineas,int cols)
{
  Celda *list=NULL;
  int *listavecinos=NULL, i, j, inf, sup, tamano=0, actual=0;

  for (i=0; i<=dist_vecin; i++)
    tamano=8*(i+1);

  list = (Celda *)calloc(tamano, sizeof(Celda));
  sup=dist_vecin+1;
  inf = -sup;

  for (i=inf; i<=sup; i++)
  {
    for (j=inf; j<= sup; j++)
    {
      if ((x_origen-i >= 0) && (y_origen-j >= 0))
	if ((i != 0) && (j != 0))
	{
	  list[actual].x=x_origen-i;
	  list[actual].y=y_origen-j;
	  actual++;
	}
    } /* for j */
  } /* for i */

  /* 
     Ahora vamos a transformar las coordenadas de los vecinos en la adecuada
   indexacion al puntero que empleamos para almacenar la imagen 
  */
  
  listavecinos= (int *)calloc(actual+1, sizeof(int));

  for (i=0; i<=actual; i++)
    listavecinos[i]=cols*list[i].x+list[i].y;

  *num_vecin=actual+1;
  free(list);
  list=NULL;
  return(listavecinos);
} /* GenerarVecinos */


int ScoreQuery2DVecinos (TIPO **img,int filas, int columnas, TIPO umbral, 
			 int dist_vecin)
{
  TIPO scores,tonta;
  FILE *lista, *fent;
  char nombre[128];
  int retonno=333, tam_x, tam_y, tam_unico, lineas, cols, i,j;
  int coefs,cont,k;
  TIPO *vec[3];
  Celda *aux[3];
  int n_pasos_c, n_pasos_f, num_vecin, index, comparado;
  
  /* Pesos w para "scanned" */
  TIPO ws[3][6]={{5.0, 0.83, 1.01, 0.52, 0.47, 0.3},
		 {19.21, 1.26, 0.44, 0.53, 0.28, 0.14},
		 {34.37, 0.36, 0.45, 0.14, 0.18, 0.27}};


  int row=0,color=0,num_vecinos=0;
  int *listavecinos=NULL;
  

  lista = fopen("transformadas2D.sort", "rb");
  if (lista == NULL)
  {
    perror("Error al abrir transformadas2D.sort");
    return(-1);
  }
  retonno = fscanf(lista, "%s %d %d %d %d", nombre, &tam_x, &tam_y,
		     &n_pasos_c, &n_pasos_f);

  if ((retonno != 5) || (retonno == EOF))
  {
    perror("Formato incorrecto en transformadas2D.sort");
    return(-1);
  }

  /* Determinacion de la voxelizacion */
  tam_unico = DeterminarTamano(filas,columnas);
  if (tam_unico)
  {
    Cambiar_Tamano (filas, columnas, img[0], tam_unico, &vec[0]);
    Cambiar_Tamano (filas, columnas, img[1], tam_unico, &vec[1]);
    Cambiar_Tamano (filas, columnas, img[2], tam_unico, &vec[2]);

    DescomponerTres (vec, tam_unico, tam_unico, n_pasos_c, n_pasos_f);

    lineas=tam_unico;
    cols=tam_unico;

  }
  else
  {
    vec[0] = (TIPO *)malloc (filas*columnas*sizeof(TIPO));
    memcpy (vec[0],img[0],filas*columnas*sizeof(TIPO));
    vec[1] = (TIPO *)malloc (filas*columnas*sizeof(TIPO));
    memcpy (vec[1],img[1],filas*columnas*sizeof(TIPO));
    vec[2] = (TIPO *)malloc (filas*columnas*sizeof(TIPO));
    memcpy (vec[2],img[2],filas*columnas*sizeof(TIPO));

    DescomponerTres (vec, filas, columnas, n_pasos_c, n_pasos_f); 

    lineas=filas;
    cols=columnas;
  }



  /* SEA u LA MATRIZ QUE TENEMOS YA DESCOMPUESTA EN LA BASE DE DATOS */
  cont=0;
  while (retonno != EOF)
  {
    scores=0;
    if ((retonno != 5) && (retonno != EOF))
    {
      printf("\nError raro leyendo transformadas2D.sort\n");
      fclose(lista);
    }
    else if (retonno == 5)
    {
      coefs = tam_x-1; /* El tam_x de la firma es el n de coefs + 1 */
      
      if (cont == 0)
      {
	aux[0] = (Celda *)calloc(tam_x, sizeof(Celda));
	aux[1] = (Celda *)calloc(tam_x, sizeof(Celda));
	aux[2] = (Celda *)calloc(tam_x, sizeof(Celda));

	CortarYConvertir2D (vec[0], &vector[0], lineas);
	CortarYConvertir2D (vec[1], &vector[1], lineas);
	CortarYConvertir2D (vec[2], &vector[2], lineas);

       	free(vec[0]);
	vec[0]=NULL;
	vector[0]=vector[0]+1;
	free(vec[1]);
	vec[1]=NULL;
	vector[1]=vector[1]+1;
	free(vec[2]);
	vec[2]=NULL;
	vector[2]=vector[2]+1;
	
	for (color=0; color <3; color++)
	{
	  k=SelectMayores(coefs/2, lineas*cols-1, &vector[color]);
	  vector[color]=vector[color]-1;
	  for (i=0; i<=k+1; i++) /* Incluimos el valor medio */
	  {
	    aux[color][i].val=vector[color][i].val;
	    aux[color][i].x=vector[color][i].x;
	    aux[color][i].y=vector[color][i].y;
	  }
	  vector[color]=vector[color]+1;
	  vector[color]=vector[color]+coefs/2;
	  
	  k=SelectMenores(coefs/2, lineas*cols-1-coefs/2, &vector[color]);
	  for (i=0; i<=k; i++) /* No incluimos el valor medio */
	  {
	    aux[color][coefs/2+1+i].val=vector[color][i].val;
	    aux[color][coefs/2+1+i].x=vector[color][i].x;
	    aux[color][coefs/2+1+i].y=vector[color][i].y;
	  }

	  vector[color] = vector[color]-coefs/2-1;
	  free(vector[color]);
	  vector[color]=NULL;
	  cont=1;
	}
      }/* if cont == 0 */
      fent = fopen(nombre, "rb");
      if (!fent)
      {
	printf("\nError al abrir %s\n",nombre);
	perror("");
	exit(1);
      }
      retonno=LeerTres(imgbase,coefs+1,fent,nombre);
	
      if (!retonno)
      {
	for (color=0; color<=2; color++)      
        {
	  scores = ws[color][0] * fabs(aux[color][0].val - imgbase[color][0].val);
  
          /* Buscamos los 60 Coefs. de de diferencias */
	  for (row=1; row<=coefs+1; row++)
          {
	    if (aux[color][row].val != 0)
            {
	      if (imgbase[color][row].val != 0)
	      {
		if ((aux[color][row].x == imgbase[color][row].x) &&
		    (aux[color][row].y == imgbase[color][row].y))
		{
		  /*
		  if (aux[color][row].val == imgbase[color][row].val)
		  */
		  scores -= ws[color][min(row,5)];
		    /* Esta es la comparacion "exacta" */
		}
		else
		{ /* Esta es la comparacion "por vecindad" */
		  listavecinos=GenerarVecinos(aux[color][row].x,
					      aux[color][row].y,dist_vecin,
					      &num_vecin,lineas,cols);
		  
		  comparado=0;
		  for (index=0; (index<num_vecinos) && (!comparado);
		       index++)
		  {
		    if (umbral)
		    {
		      if (fabs(aux[color][listavecinos[index]].val-
				   imgbase[color][row].val) <= umbral)
		      {

			i=(aux[color][row].x>0?aux[color][row].x:1);
			tonta=(log((TIPO)i)/log(2.0));
			i=tonta;
			j=(aux[color][row].y>0?aux[color][row].y:1);
			tonta=(log((TIPO)j)/log(2.0));
			j=tonta;
			
			scores -= ws[color][min(max(i,j),5)];
			/*
			  scores -= ws[color][min(row,5)];
			*/
			comparado=1;
		      }
		    } /* if umbral */
		    else
		    {
		      if (aux[color][listavecinos[index]].val == 
			  imgbase[color][row].val)
		      {
			
			i=(aux[color][row].x>0?aux[color][row].x:1);
			tonta=(log((TIPO)i)/log(2.0));
			i=tonta;
			j=(aux[color][row].y>0?aux[color][row].y:1);
			tonta=(log((TIPO)j)/log(2.0));
			j=tonta;
			
			scores -= ws[color][min(max(i,j),5)];
			/*
			  scores -= ws[color][min(row,5)];
			*/
			comparado=1;
		      }
		    } /* else => if umbral */
		  } /* for */
		} /* else => if "exacta" */
	      }
	    }  
	  }
	}/* for color */
	fclose(fent);
      } /* if !retonno */
      printf("Semejanza con %s: %.12f\n",nombre,scores);
    } /* retonno == 5 */
    retonno = fscanf(lista, "%s %d %d %d %d", nombre, &tam_x, &tam_y,
		     &n_pasos_c, &n_pasos_f);

  }/* while */
  fclose(lista);
  free(imgbase[0]);
  free(imgbase[1]);
  free(imgbase[2]);
  free(aux[0]);
  free(aux[1]);
  free(aux[2]);
  return(0);
} /* ScoreQuery2DVecinos */


/*
**************************************************************************
*   Funciones que se utilizan para valuar la distacia simple a traves de *
* unos pesos que se calculan dividiendo la energia de cada nivel de      *
* resolucion entre la energia total de la imagen.                        *
**************************************************************************
*/

int AbrirFicheros (char *nombre1, char *nombre2, FILE **ffich1, 
		   FILE **ffich2)
{
  int retonno=0;

  *ffich1 = fopen(nombre1, "r");
  if (*ffich1== NULL)
  {
    printf("\nError al abrir el fichero %s\n",nombre1);
    perror(" ");
    retonno = -1;
  }  
  else
  {
    *ffich2 = fopen(nombre2, "r");
    if (*ffich2== NULL)
    {
      printf("\nError al abrir el fichero %s\n",nombre2);
      perror(" ");
      retonno = -1;
    }
  }
  return(retonno);
} /* AbrirFicheros */


TIPO **CalcularPesos(FILE *etotal, FILE *energ)
{
  int retonno,tamano,i,seguir,j,k,res;
  char nombre[128];
  TIPO **pesos=NULL,et[3],***correl=NULL,en_nivel,en_acumulada;

  retonno = fscanf(etotal, "%s", nombre);
  if ((retonno != 1) || (retonno == EOF))
  {
    perror("Formato incorrecto en firmas.et");
  }
  else
  {
    retonno = LeerE_Total(nombre, &et[0], &et[1], &et[2]);
    if (!retonno)
    {
      retonno = fscanf(energ, "%s %d", nombre, &tamano);
      if ((retonno != 2) || (retonno == EOF))
      {
	perror("Formato incorrecto en firmas.enr");
      }
      else
      {
	correl = LeerCorrelaciones (nombre, tamano);
	if (correl)
	{
	  pesos=(TIPO **)calloc(3,sizeof(TIPO *));
	  if (pesos)
	  {
	    seguir=1;
	    for (i=0; (i<3) && (seguir); i++)
	    {
	      /*
		Aqui reservamos tamano+1 porque tambien se calculara, por
		si acaso, el peso que corresponde al coeficiente de analisis.
	      */
	      pesos[i]=(TIPO *)calloc(tamano+1, sizeof(TIPO));
	      seguir = (pesos[i] != NULL);
	    }
	    if (seguir)
	    {
	      en_nivel=0;
	      en_acumulada=0;
	      for (i=0; i<3; i++)
	      {
		if (i == 0)
		  k=0;
		else if (i == 1)
		  k=3;
		else
		  k=5;
		
		for (res=0; res < tamano; res++)
		{
		  for (j=0; j<3; j++)
		    en_nivel+=correl[res][j][k];
		  
		  pesos[i][res]=en_nivel/et[i];
		  en_acumulada+=en_nivel;
		  en_nivel=0;
		}
		
		pesos[i][tamano]=(et[i]-en_acumulada)/et[i];
		en_acumulada=0;
	      } /* for i */
	    } /* if (seguir) */
	    else
	      perror("Insuficiente memoria para el vector de pesos.");
	  } /* if (pesos) */
	  else
	    perror("Insuficiente memoria para el vector de pesos.");
	} /* if (correl) */
      } /* else => retonno de energ */
    } /* if !(retonno) */
  } /* else => retonno de e_total */
  return(pesos);
} /* CalcularPesos */


TIPO *CalcularPesosEnerg (FILE *et, FILE *en)
{
  TIPO ***correl, *pesos_e=NULL;
  int retonno,i,j,tamano;
  char nombre[128];
  TIPO total, etotal[3], en_acumulada;

  retonno = fscanf(et, "%s", nombre);
  if ((retonno != 1) || (retonno == EOF))
  {
    perror("Formato incorrecto en firmas.et");    
  }
  else
  {
    retonno = LeerE_Total(nombre, &etotal[0], &etotal[1], &etotal[2]);
    total=etotal[0]+etotal[1]+etotal[2];
    if (!retonno)
    {
      retonno = fscanf(en, "%s %d", nombre, &tamano);
      if ((retonno != 2) || (retonno == EOF))
      {
	perror("Formato incorrecto en firmas.et");   
      }
      else
      {
	correl = LeerCorrelaciones (nombre, tamano);
        if (correl)
        {
	  /* Primero las energias */
	  
	  pesos_e=(TIPO *)calloc(tamano,sizeof(TIPO));
	  if (pesos_e)
	  {
	    en_acumulada=0;
	    for (i=0; i<tamano;i++)
            {
	      for (j=0; j<3; j++)
	      {
		pesos_e[i] += (correl[i][j][0] + correl[i][j][3] +
                            correl[i][j][5]);
	      } /* for j */
	      en_acumulada += pesos_e[i];
	      pesos_e[i] = pesos_e[i]/total;
	    } /* for i */
	  } /* if pesos_e */
	} /* if (correl) */
      } /* else => if fscanf en */
    } /* if (!retonno) */
  } /* else if  fscanf et */
  return(pesos_e);
} /* CalcularPesosEnerg */

void LiberarPesos (TIPO **vector, int tamano)
{
  int plano;
  TIPO **aux=vector;
  
  for (plano=0; plano <3; plano++)
  {
    free (aux[plano]);
    aux[plano]=NULL;
  }
  free(aux);
  aux=NULL;
} /* LiberarPesos */


		
/***************************** Energias **********************************
*************************************************************************/
int DPesosEnerg(TIPO ***correlaciones,TIPO ***corr_base,int tamano,
		TIPO *scores, FILE *etotal)
{
  int i,j,k,retonno;
  char nombre[128];
  TIPO et[3], *vecpesos,total,num,den,en_acumulada;

  retonno = fscanf(etotal, "%s", nombre);
  if ((retonno != 1) || (retonno == EOF))
  {
    perror("Formato incorrecto en firmas.et");    
  }
  else
  {
    retonno = LeerE_Total(nombre, &et[0], &et[1], &et[2]);
    total=et[0]+et[1]+et[2];
    if (!retonno)
    {
      vecpesos=(TIPO *)calloc(tamano,sizeof(TIPO));
      if (vecpesos)
      {
	en_acumulada=0;
	for (i=0; i<tamano;i++)
	{
	  for (j=0; j<3; j++)
	  {
	    vecpesos[i] += (corr_base[i][j][0] + corr_base[i][j][3] +
			    corr_base[i][j][5]);
	  } /* for j */
	  en_acumulada += vecpesos[i];
	  vecpesos[i] = vecpesos[i]/total;
	} /* for i */
       

	for (i=0; i<tamano; i++)
	{
	  for (j=0; j<3; j++)
	  {
	    for (k=0; k<6; k++)
	    {
	      if ((correlaciones[i][j][k] != 0) && 
		  (corr_base[i][j][k] != 0 ))
	      {
		num=fabs(correlaciones[i][j][k]-corr_base[i][j][k]);
		den=max(fabs(correlaciones[i][j][k]),
			fabs(corr_base[i][j][k]));

		*scores += (num/den)*vecpesos[i];
	      } /* if correlaciones... */
	    } /* for k */  
	  } /* for j */
	}/* for i */
      } /* if vecpesos */
      else
      {
	perror ("No se pudo reservar memoria para el vector de pesos de "
		"energias.");
	retonno=-1;
      }
    } /* if (!retonno) */
    else
      retonno = -1;
  } /* else => if retonno != 1 */
  return(retonno);
} /* DpesosEnerg */


void CompEnergSimple(TIPO ***correlaciones,TIPO ***corr_base,int tamano,
		     TIPO *scores)
{
  int i,j,k;
  TIPO num,den,parcial;

  for (i=0; i<tamano; i++)
  {
    for (j=0; j<3; j++)
    {
      for (k=0; k<6; k++)
      {
	if ((correlaciones[i][j][k] != 0) && (corr_base[i][j][k] != 0 ))
        {
           num=fabs(correlaciones[i][j][k]-corr_base[i][j][k]);
           den=max(fabs(correlaciones[i][j][k]),fabs(corr_base[i][j][k]));
           parcial= (num/den);
           *scores += parcial;
           /*
	   *scores+=(fabs(correlaciones[i][j][k]-corr_base[i][j][k])/
	 	    max(fabs(correlaciones[i][j][k]),
                         fabs(corr_base[i][j][k])));
           */
        }
      } /* for k */  
    } /* for j */
  }/* for i */
} /* CompEnergSimple */

void CompEnergPesos(TIPO ***correlaciones,TIPO ***corr_base,int tamano,
		    TIPO *scores)
{
  int i,j,k;
  TIPO normas[3]={0,0,0},num,den,prod;

  /* CALCULO DE LAS NORMAS AL CUADRADO*/
  /* Nos debemos olvidar de las dos resoluciones de cada extremo: las dos
     mayores y las dos menores */
  for (i=0; i<tamano; i++)
    for (j=0; j<3; j++)
      for (k=0; k<6; k++)
	normas[j]+=correlaciones[i][j][k]*correlaciones[i][j][k];
  
  /* normas contendra' las normas al cuadrado */

  /* BUCLE DE COMPARACION */
  for (j=0; j<3; j++)
  {
    for (i=0; i<tamano; i++)
    {
      for (k=0; k<6; k++)
      {
       
	if ((correlaciones[i][j][k] != 0) && (corr_base[i][j][k] != 0 ))
	{
	  num=fabs(correlaciones[i][j][k]-corr_base[i][j][k]);
	  den=max(fabs(correlaciones[i][j][k]),fabs(corr_base[i][j][k]));
	  prod=(correlaciones[i][j][k]*correlaciones[i][j][k])/normas[j];

	  *scores+=(num/den)*prod;
	}
      } /* for k */  
    } /* for j */
  }/* for i */
} /* CompEnergPesos */


TIPO EnergEscalar(TIPO ***correlaciones,TIPO ***corr_base,int tamano)
{
  int i,j,k;
  TIPO prod=0;

  for (i=0; i<tamano; i++)
  {
    for (j=0; j<3; j++)
    {
      for (k=0; k<6; k++)
      {
	prod+=correlaciones[i][j][k]*corr_base[i][j][k];
      } /* for k */  
    } /* for j */
  }/* for i */
  return (prod);
} /* EnergEscalar */

void SemejanzaEnerg(TIPO ***correlaciones,TIPO ***corr_base,int tamano,
		    TIPO *scores)
{
  TIPO num,den;

  num=EnergEscalar(correlaciones,corr_base,tamano);
  den=(EnergEscalar(correlaciones,correlaciones,tamano)+
       EnergEscalar(corr_base,corr_base,tamano)-num);

  *scores=num/den;
  *scores=1-(*scores);
} /* SemejanzaEnerg */

void CorrNormEnerg(TIPO ***correlaciones,TIPO ***corr_base,int tamano,
		   TIPO *scores)
{
  TIPO num,den,parcial;

  num=EnergEscalar(correlaciones,corr_base,tamano);
  den=EnergEscalar(correlaciones,correlaciones,tamano);

  parcial=num/sqrt(den);

  den=EnergEscalar(corr_base,corr_base,tamano);

  *scores=parcial/sqrt(den);
  *scores=1-(*scores);
} /* CorrNormEnerg */

int ScoreQueryEnerg (TIPO **img,int filas,int columnas,int distancia)
{
  TIPO scores;
  FILE *lista=NULL,*fetotal=NULL;
  char nombre[128];
  int retonno=333, tam_unico, lineas, cols;
  TIPO *vec[3], **energias1, **energias2, **energias3;
  TIPO ***covarianzas, ***correlaciones, ***corr_base,tonta;
  int tamano, auxiliar,seguir,ret;
  
  lista = fopen("firmas.enr", "rb");
  if (lista == NULL)
  {
    perror("Error al abrir firmas.enr");
    return(-1);
  }
  retonno = fscanf(lista, "%s %d", nombre, &tamano);
  if ((retonno != 2) || (retonno == EOF))
  {
    perror("Formato incorrecto en firmas.enr");
    return(-1);
  }
  /* Determinacion de la voxelizacion */
  tam_unico = DeterminarTamano(filas,columnas);
  if (tam_unico)
  {
    Cambiar_Tamano (filas, columnas, img[0], tam_unico, &vec[0]);
    Cambiar_Tamano (filas, columnas, img[1], tam_unico, &vec[1]);
    Cambiar_Tamano (filas, columnas, img[2], tam_unico, &vec[2]);

    lineas=tam_unico;
    cols=tam_unico;
  }
  else
  {
    vec[0] = (TIPO *)malloc (filas*columnas*sizeof(TIPO));
    memcpy (vec[0],img[0],filas*columnas*sizeof(TIPO));
    vec[1] = (TIPO *)malloc (filas*columnas*sizeof(TIPO));
    memcpy (vec[1],img[1],filas*columnas*sizeof(TIPO));
    vec[2] = (TIPO *)malloc (filas*columnas*sizeof(TIPO));
    memcpy (vec[2],img[2],filas*columnas*sizeof(TIPO));

    lineas=filas;
    cols=columnas;
  }

  tonta = (TIPO)(log(lineas)/log(2.0));
  auxiliar = tonta;
  if (tamano != (auxiliar-1))
  {
    printf("\n tamano=%d y el de la img es %d\n", tamano, auxiliar-1);
    printf("\nImagenes de distinto tamano: imposible comparacion\n");
    Tiempos ();
    exit(0);
  }

  DescomponerTres (vec, lineas, cols, 0, 0); 

  /* Calculo de las energias */
  energias1=CalcularEnergias(vec[0], lineas, cols);
  energias2=CalcularEnergias(vec[1], lineas, cols);
  energias3=CalcularEnergias(vec[2], lineas, cols);
            
  /* Calculo de los coefs. de covarianza */
  covarianzas=CalcularCovarianzas(vec[0], vec[1], vec[2], lineas, cols);
    
    
  /* Liberamos memoria */
  free(vec[0]);
  vec[0]=NULL;
  free(vec[1]);
  vec[1]=NULL;
  free(vec[2]);
  vec[2]=NULL;
    
  /* Normalizamos y conseguimos los coefs. de correlacion */
  correlaciones=NormalizarCov(energias1, energias2, energias3,
			      &covarianzas, lineas, cols);

  /* Se supone que se ha liberado la memoria que ocupaban las 
     covarianzas */
  
  seguir=1;

  if (distancia == DPESOS)
  {
    fetotal = fopen("firmas.et", "r");
    if (fetotal== NULL)
    {
      perror("Error al abrir el fichero firmas.et");
      seguir=0;
    }
  }

  while ((retonno != EOF) && (seguir))
  {
    scores=0;
    if ((retonno != 2) && (retonno != EOF))
    {
      printf("\nError raro leyendo firmas.enr\n");
      fclose(lista);
    }
    else if (retonno == 2)
    {
      corr_base = LeerCorrelaciones (nombre, tamano);
	
      if (corr_base)
      {
	/* Comparamos los coeficientes de correlacion */

	if (distancia == DSIMPLE)
	  CompEnergSimple(correlaciones,corr_base,tamano,&scores);
	
	else if (distancia == DVALUADA)
	  CompEnergPesos(correlaciones,corr_base,tamano,&scores);
	
	else if (distancia == SEMEJANZA)
	  SemejanzaEnerg(correlaciones,corr_base,tamano,&scores);

	else if (distancia == CORRELACION)
	  CorrNormEnerg(correlaciones,corr_base,tamano,&scores);
	
	else /* if (distancia == DPESOS) */
	{
	  ret=DPesosEnerg(correlaciones,corr_base,tamano,&scores,fetotal);
	  seguir=(ret == 0);
	}

	if (seguir)
	  printf("Semejanza con %s: %.12f\n",nombre,scores);

	Liberar(&corr_base,tamano);
	corr_base=NULL;
      } /* if corr_base */
      else
	return(1);
    } /* retonno == 2 */
    retonno = fscanf(lista, "%s %d", nombre, &tamano);
  }/* while */
  fclose(lista);
  Liberar(&correlaciones,tamano);
  return(0);
} /* ScoreQueryEnerg */

/*********** Energias en coeficientes de analisis ************************
*************************************************************************/
void DPesosAnal(TIPO **corr_anal,TIPO **corr_base,int hasta,
		TIPO *scores, TIPO *vecpesos)
{
  int i,k;
  TIPO num,den;
  
  for (i=0; i<hasta; i++)
  {
    for (k=0; k<6; k++)
    {
      if ((corr_anal[i][k] != 0) && (corr_base[i][k] != 0))
      {
	num=fabs(corr_anal[i][k]-corr_base[i][k]);
	den=max(fabs(corr_anal[i][k]),fabs(corr_base[i][k]));

	*scores+= (num/den)*vecpesos[i];
      }
    } /* for k */  
  }/* for i */
} /* DPesosAnal */


/* Considerando solo las energias: sin correlaciones */
void DPesosAnalSC(TIPO **corr_anal,TIPO **corr_base,int hasta,
		  TIPO *scores, TIPO **vecpesos)
{
  int i;
  TIPO num,den,parcial;
  
  for (i=0; i<hasta; i++)
  {
    if ((corr_anal[i][0] != 0) && (corr_base[i][0] != 0))
    {
      num=fabs(corr_anal[i][0]-corr_base[i][0]);
      den=max(fabs(corr_anal[i][0]),fabs(corr_base[i][0]));
      
      parcial = ((num/den)*vecpesos[0][i]);
      
      *scores += parcial;
    }

    if ((corr_anal[i][3] != 0) && (corr_base[i][3] != 0))
    {
      num=fabs(corr_anal[i][3]-corr_base[i][3]);
      den=max(fabs(corr_anal[i][3]),fabs(corr_base[i][3]));
      
      parcial = ((num/den)*vecpesos[1][i]);
      
      *scores += parcial;
    }

    if ((corr_anal[i][5] != 0) && (corr_base[i][5] != 0))
    {
      num=fabs(corr_anal[i][5]-corr_base[i][5]);
      den=max(fabs(corr_anal[i][5]),fabs(corr_base[i][5]));
      
      parcial = ((num/den)*vecpesos[2][i]);
      
      *scores += parcial;
    }
    
  }/* for i */
} /* DPesosAnalSC */


void CompAnalSimple(TIPO **corr_anal,TIPO **corr_base,int hasta,
		    TIPO *scores)
{
  int i,k;
  TIPO num,den;
  
  for (i=0; i<hasta; i++)
  {
    for (k=0; k<6; k++)
    {
      if ((corr_anal[i][k] != 0) && (corr_base[i][k] != 0))
      {
	num=fabs(corr_anal[i][k]-corr_base[i][k]);
	den=max(fabs(corr_anal[i][k]),fabs(corr_base[i][k]));

	*scores += (num/den);

	/*
	*scores+=(fabs(corr_anal[i][k]-corr_base[i][k])/
		  max(fabs(corr_anal[i][k]),fabs(corr_base[i][k])));
	*/
      }
    } /* for k */  
  }/* for i */
} /* CompAnalSimple */


/* Sin correlaciones: solo energias */
void CompAnalSimpleSC(TIPO **corr_anal,TIPO **corr_base,int hasta,
		      TIPO *scores)
{
  int i;
  TIPO num,den;
  
  for (i=0; i<hasta; i++)
  {
    if ((corr_anal[i][0] != 0) && (corr_base[i][0] != 0))
    {
      num=fabs(corr_anal[i][0]-corr_base[i][0]);
      den=max(fabs(corr_anal[i][0]),fabs(corr_base[i][0]));
      *scores+=num/den;
    }
    if ((corr_anal[i][3] != 0) && (corr_base[i][3] != 0))
    {  
      num=fabs(corr_anal[i][3]-corr_base[i][3]);
      den=max(fabs(corr_anal[i][3]),fabs(corr_base[i][3]));
      *scores+=num/den;
    }
    if ((corr_anal[i][5] != 0) && (corr_base[i][5] != 0))
    {  
      num=fabs(corr_anal[i][5]-corr_base[i][5]);
      den=max(fabs(corr_anal[i][5]),fabs(corr_base[i][5]));
      *scores+=num/den;
    }
  }/* for i */
} /* CompAnalSimpleSC */



void CompAnalPesos(TIPO **corr_anal,TIPO **corr_base,int hasta,
		   TIPO *scores)
{
  int i,k;
  TIPO norma=0,num,den,prod;

  /* CALCULO DE LA NORMA AL CUADRADO*/
  for (i=0; i<hasta; i++)
    for (k=0; k<6; k++)
      norma+=corr_anal[i][k]*corr_anal[i][k];

  for (i=0; i<hasta; i++)
  {
    for (k=0; k<6; k++)
    {
      if ((corr_anal[i][k] != 0) && (corr_base[i][k] != 0))
      {
	num=fabs(corr_anal[i][k]-corr_base[i][k]);
	den=max(fabs(corr_anal[i][k]),fabs(corr_base[i][k]));
	prod=(corr_anal[i][k]*corr_anal[i][k])/norma;

	*scores+=(num/den)*prod;
      }
    } /* for k */  
  }/* for i */
} /* CompAnalPesos */



/* Sin correlaciones: Solo energias */
void CompAnalPesosSC(TIPO **corr_anal,TIPO **corr_base,int hasta,
		     TIPO *scores)
{
  int i;
  TIPO norma=0,num,den,prod;

  /* CALCULO DE LA NORMA AL CUADRADO*/
  for (i=0; i<hasta; i++)
  {
    norma+=corr_anal[i][0]*corr_anal[i][0];
    norma+=corr_anal[i][3]*corr_anal[i][3];
    norma+=corr_anal[i][5]*corr_anal[i][5];
  }

  for (i=0; i<hasta; i++)
  {
 
    if ((corr_anal[i][0] != 0) && (corr_base[i][0] != 0))
    {
      num=fabs(corr_anal[i][0]-corr_base[i][0]);
      den=max(fabs(corr_anal[i][0]),fabs(corr_base[i][0]));
      prod=(corr_anal[i][0]*corr_anal[i][0])/norma;
      
      *scores+=(num/den)*prod;
    }

    if ((corr_anal[i][3] != 0) && (corr_base[i][3] != 0))
    {
      num=fabs(corr_anal[i][3]-corr_base[i][3]);
      den=max(fabs(corr_anal[i][3]),fabs(corr_base[i][3]));
      prod=(corr_anal[i][3]*corr_anal[i][3])/norma;
      
      *scores+=(num/den)*prod;
    }
    
    if ((corr_anal[i][5] != 0) && (corr_base[i][5] != 0))
    {
      num=fabs(corr_anal[i][5]-corr_base[i][5]);
      den=max(fabs(corr_anal[i][5]),fabs(corr_base[i][5]));
      prod=(corr_anal[i][5]*corr_anal[i][5])/norma;
      
      *scores+=(num/den)*prod;
    }

  }/* for i */
} /* CompAnalPesosSC */


TIPO AnalEscalar (TIPO **corr_anal,TIPO **corr_base,int hasta)
{
  int i,k;
  TIPO prod=0;
  
  for (i=0; i<hasta; i++)
  {
    for (k=0; k<6; k++)
    {
      prod+=corr_anal[i][k]*corr_base[i][k];
    } /* for k */  
  }/* for i */
  return(prod);
} /* AnalEscalar */


/* Sin correlaciones: solo energias */
TIPO AnalEscalarSC (TIPO **corr_anal,TIPO **corr_base,int hasta)
{
  int i;
  TIPO prod=0;
  
  for (i=0; i<hasta; i++)
  {
      prod+=corr_anal[i][0]*corr_base[i][0];
      prod+=corr_anal[i][3]*corr_base[i][3];
      prod+=corr_anal[i][5]*corr_base[i][5];
  }/* for i */
  return(prod);
} /* AnalEscalarSC */


void SemejanzaAnal(TIPO **corr_anal,TIPO **corr_base,int hasta,
		   TIPO *scores)
{
  TIPO num,den;

  num=AnalEscalar(corr_anal,corr_base,hasta);
  den=(AnalEscalar(corr_anal,corr_anal,hasta)+
       AnalEscalar(corr_base,corr_base,hasta)-num);

  *scores=num/den;
  *scores=1-(*scores);
} /* SemejanzaAnal */


/* Sin correlaciones: solo energias */
void SemejanzaAnalSC(TIPO **corr_anal,TIPO **corr_base,int hasta,
		     TIPO *scores)
{
  TIPO num,den;

  num=AnalEscalarSC(corr_anal,corr_base,hasta);
  den=(AnalEscalarSC(corr_anal,corr_anal,hasta)+
       AnalEscalarSC(corr_base,corr_base,hasta)-num);

  *scores=num/den;
  *scores=1-(*scores);
} /* SemejanzaAnalSC */


void CorrNormAnal(TIPO **corr_anal,TIPO **corr_base,int hasta,
		  TIPO *scores)
{
  TIPO num,den,parcial;

  num=AnalEscalar(corr_anal,corr_base,hasta);
  den=AnalEscalar(corr_anal,corr_anal,hasta);
  
  parcial=num/sqrt(den);

  den=AnalEscalar(corr_base,corr_base,hasta);

  *scores=parcial/sqrt(den);
  *scores=1-(*scores);
} /* CorrNormAnal */


/* Sin correlaciones: solo energias */
void CorrNormAnalSC(TIPO **corr_anal,TIPO **corr_base,int hasta,
		    TIPO *scores)
{
  TIPO num,den,parcial;

  num=AnalEscalarSC(corr_anal,corr_base,hasta);
  den=AnalEscalarSC(corr_anal,corr_anal,hasta);
  
  parcial=num/sqrt(den);

  den=AnalEscalarSC(corr_base,corr_base,hasta);

  *scores=parcial/sqrt(den);
  *scores=1-(*scores);
} /* CorrNormAnalSC */


int ScoreQueryEnerg_A (TIPO **img,int filas,int columnas, int hasta,
		       int distancia)
{
  TIPO scores;
  FILE *lista, *et=NULL, *en=NULL;
  char nombre[128];
  int retonno=333, tam_unico, lineas, i;
  TIPO *vec[3], **energia, **corr_anal=NULL;
  TIPO  **corr_base, **cov_anal=NULL, tonta;
  int tamano, auxiliar,ret;
  int resolucion,seguir;

  
  TIPO *vecpesos=NULL; /* PARA CORRELACIONES

 
  
    TIPO **vecpesos=NULL; PARA ENERGIAS SIN CORRELACIONES
  */

  lista = fopen("firmas.ena", "rb");
  if (lista == NULL)
  {
    perror("Error al abrir firmas.ena");
    return(-1);
  }
  retonno = fscanf(lista, "%s %d", nombre, &tamano);
  if ((retonno != 2) || (retonno == EOF))
  {
    perror("Formato incorrecto en firmas.ena");
    return(-1);
  }
  /* Determinacion de la voxelizacion */
  tam_unico = DeterminarTamano(filas,columnas);
  if (tam_unico)
  {
    printf("\nLa imagen debe ser cuadrada y de dimensiones potencia"
                   " de 2\n");
  }
  else
  {
    vec[0] = (TIPO *)malloc (filas*columnas*sizeof(TIPO));
    memcpy (vec[0],img[0],filas*columnas*sizeof(TIPO));
    vec[1] = (TIPO *)malloc (filas*columnas*sizeof(TIPO));
    memcpy (vec[1],img[1],filas*columnas*sizeof(TIPO));
    vec[2] = (TIPO *)malloc (filas*columnas*sizeof(TIPO));
    memcpy (vec[2],img[2],filas*columnas*sizeof(TIPO));

    lineas=filas;
  }
  
  tonta= (TIPO)(log(lineas)/log(2.0));
  auxiliar = tonta;
  if (tamano != auxiliar)
  {
    printf("\n tamano=%d y el de la img es %d\n", tamano, auxiliar);
    printf("\nImagenes de distinto tamano: imposible comparacion\n");
    return(0);
  }
  resolucion=tonta;

  /* Reserva de energia para las covarianzas */
  cov_anal=(TIPO **)calloc(resolucion, sizeof(TIPO *));
  if (cov_anal)
  {
    seguir=1;
    for (i=0; (i<resolucion) && (seguir); i++)
    {
      cov_anal[i]=(TIPO *)calloc(3,sizeof(TIPO));
      seguir=(cov_anal[i] != NULL);
    } /* for i */
  }
  if (!seguir)
  {
    perror("No se pudo reservar memoria para calcular "
	   "covarianzas");
    Tiempos ();
    exit(1);
  }

  energia=DescYEnerg (vec[0],vec[1],vec[2],lineas, &cov_anal);
  
  /* Liberamos memoria */
  free(vec[0]);
  vec[0]=NULL;
  free(vec[1]);
  vec[1]=NULL;
  free(vec[2]);
  vec[2]=NULL;
  
  /* Normalizamos y conseguimos los coefs. de correlacion */
  /*printf("\nCorrelaciones: \n");*/
  corr_anal=NormalizarCovAnal(energia, &cov_anal, resolucion);
  
  /* Se supone que se ha liberado la memoria que ocupaban las 
     covarianzas */


  seguir=1;

  if (distancia == DPESOS)
  {
    if ((!et) && (!en))
    {
      ret=AbrirFicheros("firmas.et","firmas.enr",&et,&en);
      if (ret)
        seguir=0;
    }
  }

  while ((retonno != EOF) && seguir)
  {
    scores=0;
    if ((retonno != 2) && (retonno != EOF))
    {
      printf("\nError raro leyendo firmas.ena\n");
      fclose(lista);
      seguir=0;
    }
    else if (retonno == 2)
    {
      corr_base = LeerCorrAnal(nombre, tamano);
      
      if (corr_base)
      {
	if (hasta == 0)
	  hasta=tamano;

	/* Comparamos los vectores de momentos */

	if (distancia == DSIMPLE)
	{
	  CompAnalSimple(corr_anal,corr_base,hasta,&scores); 

/*	  CompAnalSimpleSC(corr_anal,corr_base,hasta,&scores); */

	}	
	else if (distancia == DVALUADA)
	{ 
	  /*	  CompAnalPesosSC(corr_anal,corr_base,hasta,&scores);
	   */
         
	  CompAnalPesos(corr_anal,corr_base,hasta,&scores); 
	}	
	else if (distancia == SEMEJANZA)
	{
	  /*  SemejanzaAnalSC(corr_anal,corr_base,hasta,&scores);
	   */
	
	  SemejanzaAnal(corr_anal,corr_base,hasta,&scores);
	}
	else if (distancia == CORRELACION)
	{  /*CorrNormAnalSC(corr_anal,corr_base,hasta,&scores);
	   */
	
	  CorrNormAnal(corr_anal,corr_base,hasta,&scores);
	}
	else /* if (distancia == DPESOS) */
        {
	  
          vecpesos=CalcularPesosEnerg(et,en);
	  /*
	  vecpesos=CalcularPesos(et,en);
	  */
          if (vecpesos)
          {
	    /*
	       Con correlaciones.
	       */
            DPesosAnal(corr_anal,corr_base,hasta,&scores,vecpesos);
            free(vecpesos);
	    


	    /* Sin correlaciones 
	    DPesosAnalSC(corr_anal,corr_base,hasta,&scores,vecpesos);
	    LiberarPesos(vecpesos,hasta);
	    */
            vecpesos=NULL;
          }
          else
            seguir=0;
        } /* else => if distancia == DPESOS */

        if (seguir) 
	  printf("Semejanza con %s: %.12f\n",nombre,scores);

	LiberarCorrAnal(&corr_base,tamano);
	corr_base=NULL;
      } /* if mom_base */
    } /* retonno == 2 */
    retonno = fscanf(lista, "%s %d", nombre, &tamano);
  } /* while */
  fclose(lista);
  LiberarCorrAnal(&corr_anal,tamano);
  return(0);
} /* ScoreQueryEnerg_A */

/**************************************************************************
*Energias en coefs de analisis y coefs. de detalle del cuadrante diagonal.*
**************************************************************************/
void DPesosAnal2(TIPO ***corr_anal,TIPO ***corr_base, int tamano,
		 TIPO *scores, TIPO *vecpesos)
{
  int i,j,k;
  TIPO num,den;
  
  for (i=0; i<tamano; i++)
  {
    for (j=0; j<2; j++)
    {
      for (k=0; k<6; k++)
      {
	if ((corr_anal[i][j][k] != 0) && (corr_base[i][j][k] != 0))
	{
	  num=fabs(corr_anal[i][j][k]-corr_base[i][j][k]);
	  den=max(fabs(corr_anal[i][j][k]),fabs(corr_base[i][j][k]));

	  *scores+= (num/den)*vecpesos[i];
	}
      } /* for k */ 
    } /* for j */
  }/* for i */
} /* DPesosAnal2 */


/* Sin correlaciones: solo energias */
void DPesosAnal2SC(TIPO ***corr_anal,TIPO ***corr_base, int tamano,
		   TIPO *scores, TIPO **vecpesos)
{
  int i,j;
  TIPO num,den,parcial;
  
  for (i=0; i<tamano; i++)
  {
    for (j=0; j<2; j++)
    {
	if ((corr_anal[i][j][0] != 0) && (corr_base[i][j][0] != 0))
	{
	  num=fabs(corr_anal[i][j][0]-corr_base[i][j][0]);
	  den=max(fabs(corr_anal[i][j][0]),fabs(corr_base[i][j][0]));

	  parcial= (num/den)*vecpesos[0][i];

	  *scores+= parcial;
	}

	if ((corr_anal[i][j][3] != 0) && (corr_base[i][j][3] != 0))
	{
	  num=fabs(corr_anal[i][j][3]-corr_base[i][j][3]);
	  den=max(fabs(corr_anal[i][j][3]),fabs(corr_base[i][j][3]));

	  parcial= (num/den)*vecpesos[0][i];

	  *scores+= parcial;
	}


	if ((corr_anal[i][j][5] != 0) && (corr_base[i][j][5] != 0))
	{
	  num=fabs(corr_anal[i][j][5]-corr_base[i][j][5]);
	  den=max(fabs(corr_anal[i][j][5]),fabs(corr_base[i][j][5]));

	  parcial= (num/den)*vecpesos[0][i];

	  *scores+= parcial;
	}

    } /* for j */
  }/* for i */
} /* DPesosAnal2SC */




void CompA2Simple(TIPO ***corr_anal,TIPO ***corr_base, int tamano,
		  TIPO *scores)
{
  int i,j,k;
  TIPO num, den;

  for (i=0; i<tamano; i++)
  {
    for (j=0; j<2; j++)
    {
      for (k=0; k<6; k++)
      {
	if ((corr_anal[i][j][k] != 0) && (corr_base[i][j][k] != 0))
	{
	  num=fabs(corr_anal[i][j][k]-corr_base[i][j][k]);
	  den=max(fabs(corr_anal[i][j][k]),fabs(corr_base[i][j][k]));
	  *scores += (num/den);
	  /*
	  *scores+=(fabs(corr_anal[i][j][k]-corr_base[i][j][k])/
		    max(fabs(corr_anal[i][j][k]),
			fabs(corr_base[i][j][k])));
	  */
	}
      } /* for k */  
    } /* for j */
  }/* for i */
} /* CompA2Simple */



/* Sin correlaciones: solo energias */
void CompA2SimpleSC(TIPO ***corr_anal,TIPO ***corr_base, int tamano,
		    TIPO *scores)
{
  int i,j;
  TIPO num, den;

  for (i=0; i<tamano; i++)
  {
    for (j=0; j<2; j++)
    {
      if ((corr_anal[i][j][0] != 0) && (corr_base[i][j][0] != 0))
      {
	num=fabs(corr_anal[i][j][0]-corr_base[i][j][0]);
	den=max(fabs(corr_anal[i][j][0]),fabs(corr_base[i][j][0]));
	*scores += (num/den);
      }
      if ((corr_anal[i][j][3] != 0) && (corr_base[i][j][3] != 0))
      {
	num=fabs(corr_anal[i][j][3]-corr_base[i][j][3]);
	den=max(fabs(corr_anal[i][j][3]),fabs(corr_base[i][j][3]));
	*scores += (num/den);
      }
      if ((corr_anal[i][j][5] != 0) && (corr_base[i][j][5] != 0))
      {
	num=fabs(corr_anal[i][j][5]-corr_base[i][j][5]);
	den=max(fabs(corr_anal[i][j][5]),fabs(corr_base[i][j][5]));
	*scores += (num/den);
      }
    } /* for j */
  }/* for i */
} /* CompA2SimpleSC */




void CompA2Pesos(TIPO ***corr_anal,TIPO ***corr_base, int tamano,
		 TIPO *scores)
{
  int i,j,k;
  TIPO norma[2]={0,0},num,den,prod;

  /* CALCULO DE LAS NORMAS */
  for (j=0; j<2; j++)
    for (i=0; i<tamano; i++)
      for (k=0; k<6; k++)
	norma[j]+=corr_anal[i][j][k]*corr_anal[i][j][k];



  for (i=0; i<tamano; i++)
  {
    for (j=0; j<2; j++)
    {
      for (k=0; k<6; k++)
      {
	if ((corr_anal[i][j][k] != 0) && (corr_base[i][j][k] != 0))
	{
	  num=fabs(corr_anal[i][j][k]-corr_base[i][j][k]);
	  den=max(fabs(corr_anal[i][j][k]),fabs(corr_base[i][j][k]));
	  prod=(corr_anal[i][j][k]*corr_anal[i][j][k])/norma[j];

	  *scores+=(num/den)*prod;
	}
      } /* for k */  
    } /* for j */
  }/* for i */
} /* CompA2Pesos */



/* Sin correlaciones: solo energias */
void CompA2PesosSC(TIPO ***corr_anal,TIPO ***corr_base, int tamano,
		   TIPO *scores)
{
  int i,j;
  TIPO norma[2]={0,0},num,den,prod;

  /* CALCULO DE LAS NORMAS */
  for (j=0; j<2; j++)
    for (i=0; i<tamano; i++)
    {
	norma[j]+=corr_anal[i][j][0]*corr_anal[i][j][0];
	norma[j]+=corr_anal[i][j][3]*corr_anal[i][j][3];
	norma[j]+=corr_anal[i][j][5]*corr_anal[i][j][5];
    }


  for (i=0; i<tamano; i++)
  {
    for (j=0; j<2; j++)
    {
      if ((corr_anal[i][j][0] != 0) && (corr_base[i][j][0] != 0))
      {
	num=fabs(corr_anal[i][j][0]-corr_base[i][j][0]);
	den=max(fabs(corr_anal[i][j][0]),fabs(corr_base[i][j][0]));
	prod=(corr_anal[i][j][0]*corr_anal[i][j][0])/norma[j];
	
	*scores+=(num/den)*prod;
      }

      if ((corr_anal[i][j][3] != 0) && (corr_base[i][j][3] != 0))
      {
	num=fabs(corr_anal[i][j][3]-corr_base[i][j][3]);
	den=max(fabs(corr_anal[i][j][3]),fabs(corr_base[i][j][3]));
	prod=(corr_anal[i][j][3]*corr_anal[i][j][3])/norma[j];
	
	*scores+=(num/den)*prod;
      }

      if ((corr_anal[i][j][5] != 0) && (corr_base[i][j][5] != 0))
      {
	num=fabs(corr_anal[i][j][5]-corr_base[i][j][5]);
	den=max(fabs(corr_anal[i][j][5]),fabs(corr_base[i][j][5]));
	prod=(corr_anal[i][j][5]*corr_anal[i][j][5])/norma[j];
	
	*scores+=(num/den)*prod;
      }

    } /* for j */
  }/* for i */
} /* CompA2PesosSC */




TIPO EscalarA2(TIPO ***corr_anal,TIPO ***corr_base, int tamano)
{
  int i,j,k;
  TIPO prod=0;

  for (i=0; i<tamano; i++)
  {
    for (j=0; j<2; j++)
    {
      for (k=0; k<6; k++)
      {
	prod+=corr_anal[i][j][k]*corr_base[i][j][k];
      } /* for k */  
    } /* for j */
  }/* for i */
  return(prod);
} /* EscalarA2 */


/* Sin correlaciones: solo energias */
TIPO EscalarA2SC(TIPO ***corr_anal,TIPO ***corr_base, int tamano)
{
  int i,j;
  TIPO prod=0;

  for (i=0; i<tamano; i++)
  {
    for (j=0; j<2; j++)
    {
      prod+=corr_anal[i][j][0]*corr_base[i][j][0];  
      prod+=corr_anal[i][j][3]*corr_base[i][j][3];  
      prod+=corr_anal[i][j][5]*corr_base[i][j][5];  
    } /* for j */
  }/* for i */
  return(prod);
} /* EscalarA2SC */


void SemejanzaA2(TIPO ***corr_anal,TIPO ***corr_base, int tamano,
		 TIPO *scores)
{
  TIPO num,den;

  num=EscalarA2(corr_anal,corr_base,tamano);
  den=(EscalarA2(corr_anal,corr_anal,tamano)+
       EscalarA2(corr_base,corr_base,tamano)-num);

  *scores=num/den;
  *scores=1-(*scores);
} /* SemejanzaA2 */


/* Sin correlaciones: Solo energias */
void SemejanzaA2SC(TIPO ***corr_anal,TIPO ***corr_base, int tamano,
		   TIPO *scores)
{
  TIPO num,den;

  num=EscalarA2SC(corr_anal,corr_base,tamano);
  den=(EscalarA2SC(corr_anal,corr_anal,tamano)+
       EscalarA2SC(corr_base,corr_base,tamano)-num);

  *scores=num/den;
  *scores=1-(*scores);
} /* SemejanzaA2SC */


void CorrNormA2(TIPO ***corr_anal,TIPO ***corr_base, int tamano,
		TIPO *scores)
{
  TIPO num,den,parcial;

  num=EscalarA2(corr_anal,corr_base,tamano);
  den=EscalarA2(corr_anal,corr_anal,tamano);

  parcial=num/sqrt(den);

  den=EscalarA2(corr_base,corr_base,tamano);

  *scores=parcial/sqrt(den);
  *scores=1-(*scores);
} /* CorrNormA2 */



/* Sin correlaciones: solo energias */
void CorrNormA2SC(TIPO ***corr_anal,TIPO ***corr_base, int tamano,
		 TIPO *scores)
{
  TIPO num,den,parcial;

  num=EscalarA2SC(corr_anal,corr_base,tamano);
  den=EscalarA2SC(corr_anal,corr_anal,tamano);

  parcial=num/sqrt(den);

  den=EscalarA2SC(corr_base,corr_base,tamano);

  *scores=parcial/sqrt(den);
  *scores=1-(*scores);
} /* CorrNormA2SC */


int ScoreQueryEnerg_A2 (int distancia)
{
  TIPO scores;
  FILE *lista, *et=NULL,*en=NULL, *fsalida=NULL;
  char nombre[128], *host;
  int retonno=333, lineas, cols;
  TIPO  ***corr_base, ***corr_anal=NULL, tonta;
  int tamano, auxiliar,ret;
  int resolucion,seguir;
  long numfir; //DIEGO: numero de firma por la que va comparando
  FILE *fd; //DIEGO: para el fichero que va a leer, para totfir
  long totfir; //DIEGO: total de firmas que debe comparar
  
  /*  TIPO *vecpesos=NULL; CON CORRELACIONES  */

  TIPO **vecpesos=NULL; /* Solo energias: SIN CORRELACIONES */
  
  /* Obtencion del nombre del host */
  host=getenv("HOSTNAME");
  lista = fopen("/var/tmp/distribuidoDiego/exe/firmas.en2", "rb");
  if (lista == NULL)
  {
    perror("Error al abrir firmas.en2");
    return(-1);
  }

  fsalida = fopen("/var/tmp/distribuidoDiego/exe/solver.out", "w");
  if (fsalida == NULL)
  {
    perror("Error al abrir solver.out");
    return(-1);
  }


  retonno = fscanf(lista, "%s %d", nombre, &tamano);
  if ((retonno != 2) || (retonno == EOF))
  {
    perror("Formato incorrecto en firmas.en2");
    return(-1);
  }
  lineas=FILAS;
  cols=COLUMNAS;
  
  tonta= (TIPO)(log(lineas)/log(2.0));
  auxiliar = tonta;
  if (tamano != auxiliar)
  {
    printf("\n tamano=%d y el de la img es %d\n", tamano, auxiliar);
    printf("\nImagenes de distinto tamano: imposible comparacion\n");
    return(0);
  }
  resolucion=tonta;



  seguir=1;

  if (distancia == DPESOS)
  {
    if ((!et) && (!en))
    {
      ret=AbrirFicheros("firmas.et","firmas.enr",&et,&en);
      if (ret)
        seguir=0;
    }
  }

  numfir = 1; // DIEGO: Numero de firma que esta comparando
  corr_anal = LeerCorrA_2("firma.dat", tamano);
  if (corr_anal)
  {
    while ((retonno != EOF) && seguir)
    {
      scores=0;
      if ((retonno != 2) && (retonno != EOF))
      {
	printf("\nError raro leyendo firmas.ena\n");
	fclose(lista);
	seguir=0;
      }
      else if (retonno == 2)
      {
	corr_base = LeerCorrA_2(nombre, tamano);
      
	if (corr_base)
        {

	  /* Comparamos los vectores de momentos */

	  if (distancia == DSIMPLE)
	    CompA2SimpleSC(corr_anal,corr_base,tamano,&scores);

	  else if (distancia == DVALUADA)
	    CompA2PesosSC(corr_anal,corr_base,tamano,&scores);

	  else if (distancia == SEMEJANZA)
	    SemejanzaA2SC(corr_anal,corr_base,tamano,&scores);

	  else if (distancia == CORRELACION)
	    CorrNormA2SC(corr_anal,corr_base,tamano,&scores);

	  else /* if (distancia == DPESOS) */
          {

	    vecpesos=CalcularPesos(et,en);
	    if (vecpesos)
            {
	      
	      DPesosAnal2SC(corr_anal,corr_base,tamano,&scores,vecpesos);
	      LiberarPesos(vecpesos,tamano);
	      vecpesos=NULL;
	    }
	    else
	      seguir=0;
	  } /* else => if distancia == DPESOS */

	  if (seguir) 
	    fprintf(fsalida,"%s: %.12f\n",nombre,scores);

	  LiberarCorrA_2(&corr_base,tamano);
	  corr_base=NULL;
	} /* if corr_base */
       
	else
	  return(1);
      } /* retonno == 2 */
      retonno = fscanf(lista, "%s %d", nombre, &tamano);
      numfir++;
      if ((numfir % 1000) == 0) {
	      fd = fopen ("/var/tmp/distribuidoDiego/exe/totalfirmas", "r");
	      fscanf (fd, "%ld", &totfir);
	      fclose (fd);
	      fd = fopen ("/var/tmp/distribuidoDiego/exe/firmasreali", "w");
	      fprintf (fd, "%ld", numfir);
	      fclose (fd);
      }
      if (numfir > totfir) retonno = EOF;
    } /* while */
  fclose(lista);
  fclose(fsalida);
  LiberarCorrA_2(&corr_anal,tamano);
  corr_anal=NULL;
  } /* if corr_anal */
  return(0);
} /* ScoreQueryEnerg_A2 */



/********************** Momentos de ordenes 1 y 2 *************************
**************************************************************************/
void DPesosMom (TIPO ***momentos,TIPO ***mom_base,int tamano,
		TIPO *scores, TIPO **vecpesos)
{
  int plano,i,k;
  TIPO num,den;

  for (plano=0; plano<3; plano++)
  {
    for (i=0; i<tamano-1; i++)
    {
      for (k=0; k<2; k++)
      {
	if ((momentos[plano][i][k] != 0) &&
	    (mom_base[plano][i][k] != 0))
	{
	  num=fabs(momentos[plano][i][k]-mom_base[plano][i][k]);
	  den=max(fabs(momentos[plano][i][k]),fabs(mom_base[plano][i][k]));

	  *scores += (num/den)*vecpesos[plano][i];
	  
	  /*
	  *scores+=((fabs(momentos[plano][i][k]-
			  mom_base[plano][i][k])/
		     max(fabs(momentos[plano][i][k]),
			 fabs(mom_base[plano][i][k])))*
		    vecpesos[plano][i]);
	  */
	}
      } /* for k */
    } /* for i */
  } /* for plano */
} /* DPesosMom */
		      


void CompMomSimple(TIPO ***momentos,TIPO ***mom_base,int tamano,
		   TIPO *scores)
{
  int num_mom,i,k;
  TIPO num,den;

  for (num_mom=0; num_mom<3; num_mom++)
  {
    for (i=0; i<tamano-1; i++)
    {
      for (k=0; k<2; k++)
      {
	if ((momentos[num_mom][i][k] != 0) &&
	    (mom_base[num_mom][i][k] != 0))
        {
	  num=fabs(momentos[num_mom][i][k]-mom_base[num_mom][i][k]);
	  den=max(fabs(momentos[num_mom][i][k]),
		  fabs(mom_base[num_mom][i][k]));
	  *scores += (num/den);

	  /*
	  *scores+=(fabs(momentos[num_mom][i][k]-
			 mom_base[num_mom][i][k])/
		    max(fabs(momentos[num_mom][i][k]),
			fabs(mom_base[num_mom][i][k])));
	  */
	}
      } /* for k */  
    }/* for i */
  } /* for num_mom */
} /* CompMomSimple */


void CompMomPesos(TIPO ***momentos,TIPO ***mom_base,int tamano,
		  TIPO *scores)
{
  int num_mom,i,k;
  TIPO norma=0,num,den,prod;

  for (num_mom=0; num_mom<3; num_mom++)
  {
    /* CALCULO DE LAS NORMAS DEL PLANO */
    norma=0;
    for (i=2; i<tamano-2; i++)
      for (k=0; k<2; k++)
	norma+=momentos[num_mom][i][k]*momentos[num_mom][i][k];
    
    for (i=2; i<tamano-2; i++)
    {
      for (k=0; k<2; k++)
      {
	if ((momentos[num_mom][i][k] != 0) &&
	    (mom_base[num_mom][i][k] != 0))
        {
	  num=fabs(momentos[num_mom][i][k]-mom_base[num_mom][i][k]);
	  
	  den=max(fabs(momentos[num_mom][i][k]),
		  fabs(mom_base[num_mom][i][k]));
		 
	  
	  prod=((momentos[num_mom][i][k]*momentos[num_mom][i][k])/
		norma);
	  
	  *scores+=(num/den)*prod;
	  
	}
      } /* for k */  
    }/* for i */
  } /* for num_mom */
} /* CompMomPesos */


TIPO MomEscalar(TIPO ***momentos,TIPO ***mom_base,int tamano)
{
  int num_mom,i,k;
  TIPO prod=0;

  for (num_mom=0; num_mom<3; num_mom++)
  {
    for (i=0; i<tamano-1; i++)
    {
      for (k=0; k<2; k++)
      {
	prod+=momentos[num_mom][i][k]*mom_base[num_mom][i][k];
      } /* for k */  
    }/* for i */
  } /* for num_mom */
  return (prod);
} /* MomEscalar */

void SemejanzaMom(TIPO ***momentos,TIPO ***mom_base,int tamano,
		  TIPO *scores)
{
  TIPO num,den;

  num=MomEscalar(momentos,mom_base,tamano);
  den=(MomEscalar(momentos,momentos,tamano)+
       MomEscalar(mom_base,mom_base,tamano)-num);

  *scores=num/den;
  *scores=1-(*scores);
} /* SemejanzaMom */


void CorrNormMom(TIPO ***momentos,TIPO ***mom_base,int tamano,
		 TIPO *scores)
{
  TIPO num,den,parcial;

  num=MomEscalar(momentos,mom_base,tamano);
  den=MomEscalar(momentos,momentos,tamano);

  parcial=num/sqrt(den);

  den=MomEscalar(mom_base,mom_base,tamano);

  *scores=parcial/sqrt(den);
  *scores=1-(*scores);
} /* CorrNormMom */


int ScoreQueryMom (TIPO **img,int filas, int columnas, int hay_e_umb, 
		   TIPO e_umbral, int distancia)
{
  TIPO scores;
  FILE *lista;
  char nombre[128];
  int retonno=333, tam_unico, lineas, cols;
  TIPO *vec[3], **momentos[3];
  TIPO  ***mom_base, tonta;
  int tamano, auxiliar,seguir,ret;
  FILE *et=NULL, *en=NULL;
  TIPO **vecpesos=NULL;


  lista = fopen("firmas.m2t", "rb");
  if (lista == NULL)
  {
    perror("Error al abrir firmas.m2t");
    return(-1);
  }
  retonno = fscanf(lista, "%s %d", nombre, &tamano);
  if ((retonno != 2) || (retonno == EOF))
  {
    perror("Formato incorrecto en firmas.m2t");
    return(-1);
  }
  /* Determinacion de la voxelizacion */
  tam_unico = DeterminarTamano(filas,columnas);
  if (tam_unico)
  {
    printf("\nLa imagen debe ser cuadrada y de dimensiones potencia"
                   " de 2\n");
  }
  else
  {
    vec[0] = (TIPO *)malloc (filas*columnas*sizeof(TIPO));
    memcpy (vec[0],img[0],filas*columnas*sizeof(TIPO));
    vec[1] = (TIPO *)malloc (filas*columnas*sizeof(TIPO));
    memcpy (vec[1],img[1],filas*columnas*sizeof(TIPO));
    vec[2] = (TIPO *)malloc (filas*columnas*sizeof(TIPO));
    memcpy (vec[2],img[2],filas*columnas*sizeof(TIPO));

    lineas=filas;
    cols=columnas;
  }
  
  tonta= (TIPO)(log(lineas)/log(2.0));
  auxiliar = tonta;
  if (tamano != auxiliar)
  {
    printf("\n tamano=%d y el de la img es %d\n", tamano, auxiliar);
    printf("\nImagenes de distinto tamano: imposible comparacion\n");
    return(0);
  }
  

  momentos[0]=DescYMom1_2(vec[0],lineas,e_umbral);
  momentos[1]=DescYMom1_2(vec[1],lineas,e_umbral);  
  momentos[2]=DescYMom1_2(vec[2],lineas,e_umbral);

  
  /* Liberamos memoria */
  free(vec[0]);
  vec[0]=NULL;
  free(vec[1]);
  vec[1]=NULL;
  free(vec[2]);
  vec[2]=NULL;

  seguir=1;

  if (distancia == DPESOS)
  {
    if ((!et) && (!en))
    {
      ret=AbrirFicheros("firmas.et","firmas.enr",&et,&en);
      if (ret)
        seguir=0;
    }
  }

  while ((retonno != EOF) && seguir)
  {
    scores=0;
    if ((retonno != 2) && (retonno != EOF))
    {
      printf("\nError raro leyendo firmas.m3s\n");
      fclose(lista);
      seguir=0;
    }
    else if (retonno == 2)
    {
      mom_base = LeerMomentos(nombre, tamano);
      
      if (mom_base)
      {
	/* Comparamos los vectores de momentos */

	if (distancia == DSIMPLE)
	  CompMomSimple(momentos,mom_base,tamano,&scores);
	
	else if (distancia == DVALUADA)
	  CompMomPesos(momentos,mom_base,tamano,&scores);
	
	else if (distancia == SEMEJANZA)
	  SemejanzaMom(momentos,mom_base,tamano,&scores);

	else if (distancia == CORRELACION)
	  CorrNormMom(momentos,mom_base,tamano,&scores);
	else /* if (distancia == DPESOS) */
	{
          vecpesos=CalcularPesos(et,en);
          if (vecpesos)
          {
	    DPesosMom(momentos,mom_base,tamano,&scores,vecpesos);
            LiberarPesos(vecpesos,tamano);
            vecpesos=NULL;
          }
          else
            seguir=0;
        } /* else => if distancia == DPESOS */

	if (seguir)  
	  printf("Semejanza con %s: %.12f\n",nombre,scores);

	LiberarMomentosTres(mom_base,tamano);
	free(mom_base);
	mom_base=NULL;
      } /* if mom_base */
    } /* retonno == 2 */
    retonno = fscanf(lista, "%s %d", nombre, &tamano);
  } /* while */
  fclose(lista);
  LiberarMomentosTres(momentos,tamano);
  return(0);
} /* ScoreQueryMom */



int ScoreQueryMomAD (TIPO **img,int filas, int columnas, int hay_e_umb, 
		     TIPO e_umbral, int distancia)
{
  TIPO scores;
  FILE *lista;
  char nombre[128];
  int retonno=333, tam_unico, lineas, cols;
  TIPO *vec[3], **momentos[3];
  TIPO  ***mom_base, tonta;
  int tamano, auxiliar,seguir,ret;
  FILE *et=NULL, *en=NULL;
  TIPO **vecpesos=NULL;


  lista = fopen("firmas.m2a", "rb");
  if (lista == NULL)
  {
    perror("Error al abrir firmas.m2a");
    return(-1);
  }
  retonno = fscanf(lista, "%s %d", nombre, &tamano);
  if ((retonno != 2) || (retonno == EOF))
  {
    perror("Formato incorrecto en firmas.m2a");
    return(-1);
  }
  /* Determinacion de la voxelizacion */
  tam_unico = DeterminarTamano(filas,columnas);
  if (tam_unico)
  {
    printf("\nLa imagen debe ser cuadrada y de dimensiones potencia"
                   " de 2\n");
  }
  else
  {
    vec[0] = (TIPO *)malloc (filas*columnas*sizeof(TIPO));
    memcpy (vec[0],img[0],filas*columnas*sizeof(TIPO));
    vec[1] = (TIPO *)malloc (filas*columnas*sizeof(TIPO));
    memcpy (vec[1],img[1],filas*columnas*sizeof(TIPO));
    vec[2] = (TIPO *)malloc (filas*columnas*sizeof(TIPO));
    memcpy (vec[2],img[2],filas*columnas*sizeof(TIPO));

    lineas=filas;
    cols=columnas;
  }
  
  tonta= (TIPO)(log(lineas)/log(2.0));
  auxiliar = tonta;
  if (tamano != auxiliar)
  {
    printf("\n tamano=%d y el de la img es %d\n", tamano, auxiliar);
    printf("\nImagenes de distinto tamano: imposible comparacion\n");
    return(0);
  }
  

  momentos[0]=DescYMom2AD(vec[0],lineas,hay_e_umb,e_umbral,NEQ);
  momentos[1]=DescYMom2AD(vec[1],lineas,hay_e_umb,e_umbral,NEQ);  
  momentos[2]=DescYMom2AD(vec[2],lineas,hay_e_umb,e_umbral,NEQ);

  
  /* Liberamos memoria */
  free(vec[0]);
  vec[0]=NULL;
  free(vec[1]);
  vec[1]=NULL;
  free(vec[2]);
  vec[2]=NULL;

  seguir=1;

  if (distancia == DPESOS)
  {
    if ((!et) && (!en))
    {
      ret=AbrirFicheros("firmas.et","firmas.enr",&et,&en);
      if (ret)
        seguir=0;
    }
  }

  while ((retonno != EOF) && seguir)
  {
    scores=0;
    if ((retonno != 2) && (retonno != EOF))
    {
      printf("\nError raro leyendo firmas.m3s\n");
      fclose(lista);
      seguir=0;
    }
    else if (retonno == 2)
    {
      mom_base = LeerMomentos(nombre, tamano);
      
      if (mom_base)
      {
	/* Comparamos los vectores de momentos */

	if (distancia == DSIMPLE)
	  CompMomSimple(momentos,mom_base,tamano,&scores);
	
	else if (distancia == DVALUADA)
	  CompMomPesos(momentos,mom_base,tamano,&scores);
	
	else if (distancia == SEMEJANZA)
	  SemejanzaMom(momentos,mom_base,tamano,&scores);

	else if (distancia == CORRELACION)
	  CorrNormMom(momentos,mom_base,tamano,&scores);
	else /* if (distancia == DPESOS) */
	{
          vecpesos=CalcularPesos(et,en);
          if (vecpesos)
          {
	    DPesosMom(momentos,mom_base,tamano,&scores,vecpesos);
            LiberarPesos(vecpesos,tamano);
            vecpesos=NULL;
          }
          else
            seguir=0;
        } /* else => if distancia == DPESOS */

	if (seguir)  
	  printf("Semejanza con %s: %.12f\n",nombre,scores);

	LiberarMomentosTres(mom_base,tamano);
	free(mom_base);
	mom_base=NULL;
      } /* if mom_base */
    } /* retonno == 2 */
    retonno = fscanf(lista, "%s %d", nombre, &tamano);
  } /* while */
  fclose(lista);
  if ((distancia == DPESOS) && et && en)
  {
    fclose(et);
    fclose(en);
  }
  LiberarMomentosTres(momentos,tamano);
  return(0);
} /* ScoreQueryMomAD */


/**************************************************************************
* Momentos de ordenes 1, 2 y 3 en los coeficientes de analisis y de       *
*detalle considerandolos como una sola region.                            *
**************************************************************************/
void DPesosMomTres(TIPO ***momentos,TIPO ***mom_base,int tamano,
		   TIPO *scores, TIPO **vecpesos)
{
  int plano,i,k;
  TIPO num,den;

  for (plano=0; plano<3; plano++)
  {
    for (i=0; i<tamano-1; i++)
    {
      for (k=0; k<7; k++)
      {
	if ((momentos[plano][i][k] != 0) && 
	    (mom_base[plano][i][k] != 0))
	{
	  num=fabs(momentos[plano][i][k]-mom_base[plano][i][k]);
	  den=max(fabs(momentos[plano][i][k]),fabs(mom_base[plano][i][k]));

	  *scores += (num/den)*vecpesos[plano][i];
	  
	  /*
	  *scores+=((fabs(momentos[plano][i][k]-mom_base[plano][i][k])/
	  max(fabs(momentos[plano][i][k]),fabs(mom_base[plano][i][k])))*
		    vecpesos[plano][i]);
	  */
	}
      } /* for k */
    } /* for i */
  } /* for plano */
} /* DPesosMomTres */


void CompMomTresSimple(TIPO ***momentos,TIPO ***mom_base,int tamano,
		       TIPO *scores)
{
  int num_mom, i, k;
  TIPO num,den;

  for (num_mom=0; num_mom<3; num_mom++)
  {
    for (i=0; i<tamano-1; i++)
    {
      for (k=0; k<7; k++)
      {
	if ((momentos[num_mom][i][k] != 0) && 
	    (mom_base[num_mom][i][k] != 0))
	{
	  num=fabs(momentos[num_mom][i][k]-mom_base[num_mom][i][k]);
	  den=max(fabs(momentos[num_mom][i][k]),fabs(mom_base[num_mom][i][k]));

	  *scores+=num/den;

	  /*
	  *scores+=(fabs(momentos[num_mom][i][k]-mom_base[num_mom][i][k])/
		    max(fabs(momentos[num_mom][i][k]),
			fabs(mom_base[num_mom][i][k])));
	  */
	}
      } /* for k */  
    }/* for i */
  } /* for num_mom */
} /* CompMomTresSimple */


void CompMomTresPesos(TIPO ***momentos,TIPO ***mom_base,int tamano,
		      TIPO *scores)
{
  int num_mom, i, k;
  TIPO norma,num,den,prod;

  for (num_mom=0; num_mom<3; num_mom++)
  {
    norma=0;
    for (i=2; i<tamano-2; i++)
      for (k=0; k<7; k++)
	norma+=momentos[num_mom][i][k]*momentos[num_mom][i][k];

    for (i=2; i<tamano-2; i++)
    {
      for (k=0; k<7; k++)
      {
	if ((momentos[num_mom][i][k] != 0) && 
	    (mom_base[num_mom][i][k] != 0))
	{
	  num=fabs(momentos[num_mom][i][k]-mom_base[num_mom][i][k]);
	  den=max(fabs(momentos[num_mom][i][k]),fabs(mom_base[num_mom][i][k]));
	  prod=(momentos[num_mom][i][k]*momentos[num_mom][i][k])/norma;

	  *scores+=(num/den)*prod;
	}
      } /* for k */  
    }/* for i */
  } /* for num_mom */
} /* CompMomTresPesos */

TIPO MomTresEscalar (TIPO ***momentos,TIPO ***mom_base,int tamano)
{
  int num_mom, i, k;
  TIPO prod=0;

  for (num_mom=0; num_mom<3; num_mom++)
  {
    for (i=0; i<tamano-1; i++)
    {
      for (k=0; k<7; k++)
      {
	prod+=momentos[num_mom][i][k]*mom_base[num_mom][i][k];
      } /* for k */  
    }/* for i */
  } /* for num_mom */
  return (prod);
} /* MomTresEscalar */


void SemejanzaMomTres(TIPO ***momentos,TIPO ***mom_base,int tamano,
		      TIPO *scores)
{
  TIPO num,den;

  num=MomEscalar(momentos,mom_base,tamano);
  den=(MomEscalar(momentos,momentos,tamano)+
       MomEscalar(mom_base,mom_base,tamano)-num);

  *scores=num/den;
  *scores=1-(*scores);
} /* SemejanzaMomTres */


void CorrNormMomTres(TIPO ***momentos,TIPO ***mom_base,int tamano,
		     TIPO *scores)
{
  TIPO num,den,parcial;

  num=MomEscalar(momentos,mom_base,tamano);
  den=MomEscalar(momentos,momentos,tamano);

  parcial=num/sqrt(den);

  den=MomEscalar(mom_base,mom_base,tamano);

  *scores=parcial/sqrt(den);
  *scores=1-(*scores);
} /* CorrNormMomTres */


int ScoreQueryMom3AD (TIPO **img,int filas,int columnas, int hay_e_umb, 
		      TIPO e_umbral, int distancia)
{
  TIPO scores;
  FILE *lista;
  char nombre[128];
  int retonno=333, tam_unico, lineas, cols, ret;
  TIPO *vec[3], **momentos[3];
  TIPO  ***mom_base, tonta;
  int tamano, auxiliar;
  int resolucion,seguir;
  FILE *et=NULL, *en=NULL;
  TIPO **vecpesos=NULL;

  
  lista = fopen("firmas.m3a", "rb");
  if (lista == NULL)
  {
    perror("Error al abrir firmas.m3a");
    return(-1);
  }
  retonno = fscanf(lista, "%s %d", nombre, &tamano);
  if ((retonno != 2) || (retonno == EOF))
  {
    perror("Formato incorrecto en firmas.m3a");
    return(-1);
  }
  /* Determinacion de la voxelizacion */
  tam_unico = DeterminarTamano(filas,columnas);
  if (tam_unico)
  {
    printf("\nLa imagen debe ser cuadrada y de dimensiones potencia"
                   " de 2\n");
  }
  else
  {
    vec[0] = (TIPO *)malloc (filas*columnas*sizeof(TIPO));
    memcpy (vec[0],img[0],filas*columnas*sizeof(TIPO));
    vec[1] = (TIPO *)malloc (filas*columnas*sizeof(TIPO));
    memcpy (vec[1],img[1],filas*columnas*sizeof(TIPO));
    vec[2] = (TIPO *)malloc (filas*columnas*sizeof(TIPO));
    memcpy (vec[2],img[2],filas*columnas*sizeof(TIPO));

    lineas=filas;
    cols=columnas;
  }
  
  tonta= (TIPO)(log(lineas)/log(2.0));
  auxiliar = tonta;
  if (tamano != auxiliar)
  {
    printf("\n tamano=%d y el de la img es %d\n", tamano, auxiliar);
    printf("\nImagenes de distinto tamano: imposible comparacion\n");
    return(0);
  }
  resolucion=tonta;


  momentos[0]=DescYMom3AD(vec[0],lineas,hay_e_umb,e_umbral,NEQ);
  momentos[1]=DescYMom3AD(vec[1],lineas,hay_e_umb,e_umbral,NEQ);  
  momentos[2]=DescYMom3AD(vec[2],lineas,hay_e_umb,e_umbral,NEQ);

  
  /* Liberamos memoria */
  free(vec[0]);
  vec[0]=NULL;
  free(vec[1]);
  vec[1]=NULL;
  free(vec[2]);
  vec[2]=NULL;

  seguir=1;

  if (distancia == DPESOS)
  {
    if ((!et) && (!en))
    {
      ret=AbrirFicheros("firmas.et","firmas.enr",&et,&en);
      if (ret)
	seguir=0;
    }
  }

  while ((retonno != EOF) && seguir)
  {
    scores=0;
    if ((retonno != 2) && (retonno != EOF))
    {
      printf("\nError raro leyendo firmas.m3t\n");
      fclose(lista);
      seguir=0;
    }
    else if (retonno == 2)
    {
      mom_base = LeerMomentosTres(nombre, tamano);
      
      if (mom_base)
      {
	/* Comparamos los vectores de momentos */

	if (distancia == DSIMPLE)
	  CompMomTresSimple(momentos,mom_base,tamano,&scores);
		
	else if (distancia == DVALUADA)
	  CompMomTresPesos(momentos,mom_base,tamano,&scores);
        
	else if (distancia == SEMEJANZA)
	  SemejanzaMomTres(momentos,mom_base,tamano,&scores);
	
	else if (distancia == CORRELACION) 
	  CorrNormMomTres(momentos,mom_base,tamano,&scores);

	else /* if (distancia == DPESOS) */
	{
	  vecpesos=CalcularPesos(et,en);
	  if (vecpesos)
	  {
	    DPesosMomTres(momentos,mom_base,tamano,&scores,vecpesos);
	    LiberarPesos(vecpesos,tamano);
	    vecpesos=NULL;
	  }
	  else
	    seguir=0;
	} /* else => if distancia == DPESOS */
	
	if (seguir)
	  printf("Semejanza con %s: %.12f\n",nombre,scores);

	LiberarMomentosTres(mom_base,tamano);
	free(mom_base);
	mom_base=NULL;
      } /* if mom_base */
    } /* retonno == 2 */
    retonno = fscanf(lista, "%s %d", nombre, &tamano);
  } /* while */
  fclose(lista);
  if ((distancia == DPESOS) && et && en)
  {
    fclose(et);
    fclose(en);
  }
  LiberarMomentosTres(momentos,tamano);
  return(0);
} /* ScoreQueryMom3AD */









/**************************************************************************
* Momentos de ordenes 1 y 2 para los coeficientes de analisis y de        *
* detalle del cuadrante diagonal de cada nivel de resolucion.             *
**************************************************************************/
void CompMom2DGrisesSimple(TIPO ***momentos,TIPO ***mom_base,
			  int tamano, TIPO *scores)
{
  int i,j,k;

  for (i=0; i<tamano-1; i++)
  {
    for (j=0; j<2; j++)
    {
      for (k=0; k<2; k++)
      {
	if ((momentos[i][j][k] != 0) &&
	    (mom_base[i][j][k] != 0))
	  *scores+=(fabs(momentos[i][j][k]-
			 mom_base[i][j][k])/
		    max(fabs(momentos[i][j][k]),
			fabs(mom_base[i][j][k])));
      } /* for k */  
    } /* for j */
  }/* for i */
} /* CompMom2DGrisesSimple */

void CompMom2DGrisesPesos (TIPO ***momentos,TIPO ***mom_base,
			   int tamano,TIPO *scores)
{
  int i,j,k;
  TIPO norma[2]={0,0},num,den,prod;

  /* CALCULO DE LAS NORMAS DEL PLANO */
  for (j=0; j<2; j++)
  {
    norma[j]=0;
    for (i=2; i<tamano-2; i++)
      for (k=0; k<2; k++)
      {
	norma[j]+=momentos[i][j][k]*momentos[i][j][k];
      }
  } /* for j */
  

  for (i=2; i<tamano-2; i++)
  {
    for (j=0; j<2; j++)
    {
      for (k=0; k<2; k++)
      {
	if ((momentos[i][j][k] != 0) &&
	    (mom_base[i][j][k] != 0))
	{
	  num=fabs(momentos[i][j][k]-mom_base[i][j][k]);
	  den=max(fabs(momentos[i][j][k]),
		  fabs(mom_base[i][j][k]));
	  prod=((momentos[i][j][k]*momentos[i][j][k])/
		norma[j]);
	  
	  *scores+=(num/den)*prod;
	}
      } /* for k */  
    } /* for j */
  }/* for i */
} /* CompMom2DGrisesPesos */

TIPO Mom2DGrisesEscalar(TIPO ***momentos,TIPO ***mom_base,
			int tamano)
{
  int i,j,k;
  TIPO prod=0;

  for (i=0; i<tamano-1; i++)
  {
    for (j=0; j<2; j++)
    {
      for (k=0; k<2; k++)
      {
	prod+=momentos[i][j][k]*mom_base[i][j][k];
      } /* for k */  
    } /* for j */
  }/* for i */
  return(prod);
} /* Mom2DGrisesEscalar */

void SemejanzaMom2DGrises (TIPO ***momentos,TIPO ***mom_base,
			   int tamano,TIPO *scores)
{
  TIPO num,den;

  num=Mom2DGrisesEscalar(momentos,mom_base,tamano);
  den=(Mom2DGrisesEscalar(momentos,momentos,tamano)+
       Mom2DGrisesEscalar(mom_base,mom_base,tamano)-num);

  *scores=num/den;
  *scores=1-(*scores);
} /* SemejanzaMom2DGrises */


void CorrNormMom2DGrises (TIPO ***momentos,TIPO ***mom_base,
			   int tamano,TIPO *scores)
{
  TIPO num,den,parcial;

  num=Mom2DGrisesEscalar(momentos,mom_base,tamano);
  den=Mom2DGrisesEscalar(momentos,momentos,tamano);

  parcial=num/sqrt(den);

  den=Mom2DGrisesEscalar(mom_base,mom_base,tamano);

  *scores=parcial/sqrt(den);
  *scores=1-(*scores);
} /* CorrNormMom2DGrises */


int ScoreQueryMom2DGrises (TIPO **img,int filas,int columnas,int hay_e_umb,
			   TIPO e_umbral,int distancia)
{
  TIPO scores;
  FILE *lista;
  char nombre[128];
  int retonno=333, tam_unico, lineas, cols;
  TIPO *vec, ***momentos;
  TIPO  ***mom_base, tonta;
  int tamano, auxiliar;
  int resolucion,seguir;
  
  lista = fopen("firmas.g2d", "rb");
  if (lista == NULL)
  {
    perror("Error al abrir firmas.g2d");
    return(-1);
  }
  retonno = fscanf(lista, "%s %d", nombre, &tamano);
  if ((retonno != 2) || (retonno == EOF))
  {
    perror("Formato incorrecto en firmas.g2d");
    return(-1);
  }
  /* Determinacion de la voxelizacion */
  tam_unico = DeterminarTamano(filas,columnas);
  if (tam_unico)
  {
    printf("\nLa imagen debe ser cuadrada y de dimensiones potencia"
                   " de 2\n");
  }
  else
  {
    lineas=filas;
    cols=columnas;

    vec=ToMonocromo(img,lineas);
  }
  
  tonta= (TIPO)(log(lineas)/log(2.0));
  auxiliar = tonta;
  if (tamano != auxiliar)
  {
    printf("\n tamano=%d y el de la img es %d\n", tamano, auxiliar);
    printf("\nImagenes de distinto tamano: imposible comparacion\n");
    return(0);
  }
  resolucion=tonta;


  momentos=DescYMom1_2D(vec,lineas,hay_e_umb,e_umbral,NEQ);
  
  /* Liberamos memoria */
  free(vec);
  vec=NULL;

  seguir=1;
  while ((retonno != EOF) && seguir)
  {
    scores=0;
    if ((retonno != 2) && (retonno != EOF))
    {
      printf("\nError raro leyendo firmas.m3s\n");
      fclose(lista);
      seguir=0;
    }
    else if (retonno == 2)
    {
      mom_base = LeerMomentos2DGrises(nombre, tamano);
      
      if (mom_base)
      {
	/* Comparamos los vectores de momentos */

	if (distancia == DSIMPLE)
	  CompMom2DGrisesSimple(momentos,mom_base,tamano,&scores);
		
	else if (distancia == DVALUADA)
	  CompMom2DGrisesPesos(momentos,mom_base,tamano,&scores);
	
	else if (distancia == SEMEJANZA)
	  SemejanzaMom2DGrises(momentos,mom_base,tamano,&scores);

	else /* if (distancia == CORRELACION) */
	  CorrNormMom2DGrises(momentos,mom_base,tamano,&scores);
	
	printf("Semejanza con %s: %.12f\n",nombre,scores);
	LiberarMomentosTDGrises(&mom_base,tamano);
	mom_base=NULL;
      } /* if mom_base */
    } /* retonno == 2 */
    retonno = fscanf(lista, "%s %d", nombre, &tamano);
  } /* while */
  fclose(lista);
  LiberarMomentosTDGrises(&momentos,tamano);
  return(0);
} /* ScoreQueryMom2DGrises */


/**************************************************************************
* Momentos de ordenes 1 y 2  con umbralizacion por posiciones             *
*equivalentes.        ###########MONOCROMO############                    *
**************************************************************************/
int ScoreQueryMom2EqGrises (TIPO **img,int filas,int columnas,int hay_e_umb,
			    TIPO e_umbral,int distancia)
{
  TIPO scores;
  FILE *lista;
  char nombre[128];
  int retonno=333, tam_unico, lineas, cols;
  TIPO *vec, ***momentos;
  TIPO  ***mom_base, tonta;
  int tamano, auxiliar;
  int resolucion,seguir;
  
  lista = fopen("firmas.g2q", "rb");
  if (lista == NULL)
  {
    perror("Error al abrir firmas.g2q");
    return(-1);
  }
  retonno = fscanf(lista, "%s %d", nombre, &tamano);
  if ((retonno != 2) || (retonno == EOF))
  {
    perror("Formato incorrecto en firmas.g2q");
    return(-1);
  }
  /* Determinacion de la voxelizacion */
  tam_unico = DeterminarTamano(filas,columnas);
  if (tam_unico)
  {
    printf("\nLa imagen debe ser cuadrada y de dimensiones potencia"
                   " de 2\n");
  }
  else
  {
    lineas=filas;
    cols=columnas;

    vec=ToMonocromo(img,lineas);
  }
  
  tonta= (TIPO)(log(lineas)/log(2.0));
  auxiliar = tonta;
  if (tamano != auxiliar)
  {
    printf("\n tamano=%d y el de la img es %d\n", tamano, auxiliar);
    printf("\nImagenes de distinto tamano: imposible comparacion\n");
    return(0);
  }
  resolucion=tonta;


  momentos=DescYMom1_2D(vec,lineas,hay_e_umb,e_umbral,EQ);
  
  /* Liberamos memoria */
  free(vec);
  vec=NULL;

  seguir=1;
  while ((retonno != EOF) && seguir)
  {
    scores=0;
    if ((retonno != 2) && (retonno != EOF))
    {
      printf("\nError raro leyendo firmas.m3s\n");
      fclose(lista);
      seguir=0;
    }
    else if (retonno == 2)
    {
      mom_base = LeerMomentos2DGrises(nombre, tamano);
      
      if (mom_base)
      {
	/* Comparamos los vectores de momentos */

	if (distancia == DSIMPLE)
	  CompMom2DGrisesSimple(momentos,mom_base,tamano,&scores);
		
	else if (distancia == DVALUADA)
	  CompMom2DGrisesPesos(momentos,mom_base,tamano,&scores);
        
	else if (distancia == SEMEJANZA)
	  SemejanzaMom2DGrises(momentos,mom_base,tamano,&scores);

	else /* if (distancia == CORRELACION) */
	  CorrNormMom2DGrises(momentos,mom_base,tamano,&scores);
	
	printf("Semejanza con %s: %.12f\n",nombre,scores);
	LiberarMomentosTDGrises(&mom_base,tamano);
	mom_base=NULL;
      } /* if mom_base */
    } /* retonno == 2 */
    retonno = fscanf(lista, "%s %d", nombre, &tamano);
  } /* while */
  fclose(lista);
  LiberarMomentosTDGrises(&momentos,tamano);
  return(0);
} /* ScoreQueryMom2EqGrises */


int ScoreQueryE_Total (TIPO **img,int filas, int columnas)
{
  TIPO scores;
  FILE *lista;
  char nombre[128];
  int retonno=333, tam_unico, lineas, cols;
  TIPO etotal0,etotal1,etotal2;
  TIPO e_base0,e_base1,e_base2;
  TIPO *vec[3];
  
  lista = fopen("firmas.et", "rb");
  if (lista == NULL)
  {
    perror("Error al abrir firmas.et");
    return(-1);
  }
  retonno = fscanf(lista, "%s", nombre);
  if ((retonno != 1) || (retonno == EOF))
  {
    perror("Formato incorrecto en firmas.et");
    return(-1);
  }
  /* Determinacion de la voxelizacion */
  tam_unico = DeterminarTamano(filas,columnas);
  if (tam_unico)
  {
    Cambiar_Tamano (filas, columnas, img[0], tam_unico, &vec[0]);
    Cambiar_Tamano (filas, columnas, img[1], tam_unico, &vec[1]);
    Cambiar_Tamano (filas, columnas, img[2], tam_unico, &vec[2]);

    lineas=tam_unico;
    cols=tam_unico;
  }
  else
  {
    vec[0] = (TIPO *)malloc (filas*columnas*sizeof(TIPO));
    memcpy (vec[0],img[0],filas*columnas*sizeof(TIPO));
    vec[1] = (TIPO *)malloc (filas*columnas*sizeof(TIPO));
    memcpy (vec[1],img[1],filas*columnas*sizeof(TIPO));
    vec[2] = (TIPO *)malloc (filas*columnas*sizeof(TIPO));
    memcpy (vec[2],img[2],filas*columnas*sizeof(TIPO));

    lineas=filas;
    cols=columnas;
  }
  
  DescomponerTres (vec, lineas, cols, 0, 0); 

  CalcularEnergiaTotal(vec[0],lineas,cols,&etotal0);
  CalcularEnergiaTotal(vec[1],lineas,cols,&etotal1);
  CalcularEnergiaTotal(vec[2],lineas,cols,&etotal2);


  /* Liberamos memoria */
  free(vec[0]);
  vec[0]=NULL;
  free(vec[1]);
  vec[1]=NULL;
  free(vec[2]);
  vec[2]=NULL;
    
  while (retonno != EOF)
  {
    scores=0;
    if ((retonno != 1) && (retonno != EOF))
    {
      printf("\nError raro leyendo firmas.mom\n");
      fclose(lista);
    }
    else if (retonno == 1)
    {
      retonno = LeerE_Total(nombre, &e_base0, &e_base1, &e_base2);
	
      if (!retonno)
      {
	/* Comparamos las energias totales */
	if ((etotal0 != 0 ) && (e_base0 != 0))
	  scores+=(fabs(etotal0-e_base0)/fabs(max(etotal0,e_base0)));
	if ((etotal1 != 0 ) && (e_base1 != 0))
	  scores+=(fabs(etotal1-e_base1)/fabs(max(etotal1,e_base1)));
	if ((etotal2 != 0 ) && (e_base2 != 0))
	  scores+=(fabs(etotal2-e_base2)/fabs(max(etotal2,e_base2)));

	printf("Semejanza con %s: %.12f\n",nombre,scores);

      } /* if !retonno */
    } /* retonno == 2 */
    retonno = fscanf(lista, "%s", nombre);
  } /* while */
  fclose(lista);
  return(0);
} /* ScoreQueryE_Total */





/*************************** NUEVA TECNICA ********************************
**************************************************************************/

/**************************************************************************
** Calculo de los momentos de orden 2 o 3 sobre los cuadrantes diagonal  **
** y horizontal como si fueran una sola region, ademas de los de         **
** analisis y diagonales como si fueran una sola region                  **
**************************************************************************/
void DPesosMomTodos(int orden, TIPO ****momentos,TIPO ****mom_base,
		    int tamano,TIPO *scores,TIPO **vecpesos)
{
  int plano,i,j,k,limite_k;
  TIPO num,den;

  if (orden == 2)
    limite_k = 2;
  else /* (orden == 3) */
    limite_k = 7;

  for (plano=0; plano<3; plano++)
  {
    for (i=0; i<tamano-1; i++)
    {
      for (j=0; j<2; j++)
      {
	for (k=0; k<limite_k; k++)
	{
	  if ((momentos[plano][i][j][k] != 0) &&
	      (mom_base[plano][i][j][k] != 0))
	  {
	    num=fabs(momentos[plano][i][j][k]-mom_base[plano][i][j][k]);
	    den=max(fabs(momentos[plano][i][j][k]),
		    fabs(mom_base[plano][i][j][k]));

	    *scores += (num/den) * vecpesos[plano][i];

	    /*
	    *scores+=((fabs(momentos[plano][i][j][k]-
			    mom_base[plano][i][j][k])/
		       max(fabs(momentos[plano][i][j][k]),
			   fabs(mom_base[plano][i][j][k])))*
		      vecpesos[plano][i]);
	    */
	  }
	} /* for k */  
      } /* for j */
    }/* for i */
  } /* for plano */
} /* DPesosMomTodos */

void CompMomTodosSimple(int orden, TIPO ****momentos,TIPO ****mom_base,
			int tamano, TIPO *scores)
{
  int num_mom,i,j,k,limite_k;
  TIPO num,den;

  if (orden == 2)
    limite_k = 2;
  else /* (orden == 3) */
    limite_k = 7;

  for (num_mom=0; num_mom<3; num_mom++)
  {
    for (i=0; i<tamano-1; i++)
    {
      for (j=0; j<2; j++)
      {
	for (k=0; k<limite_k; k++)
	{
	  if ((momentos[num_mom][i][j][k] >= FIRMA_UMBRAL) &&
	      (mom_base[num_mom][i][j][k] >= FIRMA_UMBRAL))
	  {
	    num = fabs(momentos[num_mom][i][j][k]-
		       mom_base[num_mom][i][j][k]);

	    den = max(fabs(momentos[num_mom][i][j][k]),
		      fabs(mom_base[num_mom][i][j][k]));

	    *scores += num/den;

	    /*
	    *scores+=(fabs(momentos[num_mom][i][j][k]-
			   mom_base[num_mom][i][j][k])/
		      max(fabs(momentos[num_mom][i][j][k]),
			  fabs(mom_base[num_mom][i][j][k])));
	    */
	  } /* if momentos */
	} /* for k */  
      } /* for j */
    }/* for i */
  } /* for num_mom */
} /* CompMomTodosSimple */

void CompMomTodosPesos (int orden, TIPO ****momentos,TIPO ****mom_base,
			int tamano,TIPO *scores)
{
  int num_mom,i,j,k,limite_k;
  TIPO norma[2]={0,0},num,den,prod;

  if (orden == 2)
    limite_k = 2;
  else /* (orden == 3) */
    limite_k = 7;

  for (num_mom=0; num_mom<3; num_mom++)
  {
    /* CALCULO DE LAS NORMAS DEL PLANO */
    for (j=0; j<2; j++)
    {
      norma[j]=0;
      for (i=2; i<tamano-2; i++)
	for (k=0; k<limite_k; k++)
	{
	  norma[j]+=momentos[num_mom][i][j][k]*momentos[num_mom][i][j][k];
	}
    } /* for j */


    for (i=2; i<tamano-2; i++)
    {
      for (j=0; j<2; j++)
      {
	for (k=0; k<limite_k; k++)
	{
	  if ((momentos[num_mom][i][j][k] != 0) &&
	      (mom_base[num_mom][i][j][k] != 0))
	  {
	    num=fabs(momentos[num_mom][i][j][k]-mom_base[num_mom][i][j][k]);
	    den=max(fabs(momentos[num_mom][i][j][k]),
		    fabs(mom_base[num_mom][i][j][k]));
	    prod=((momentos[num_mom][i][j][k]*momentos[num_mom][i][j][k])/
		  norma[j]);

	    *scores+=(num/den)*prod;
	  }
	} /* for k */  
      } /* for j */
    }/* for i */
  } /* for num_mom */
} /* CompMomTodosPesos */

TIPO MomTodosEscalar (int orden,TIPO ****momentos,TIPO ****mom_base,
		      int tamano)
{
  int num_mom,i,j,k,limite_k;
  TIPO prod=0;

  if (orden == 2)
    limite_k = 2;
  else /* (orden == 3) */
    limite_k = 7;

  for (num_mom=0; num_mom<3; num_mom++)
  {
    for (i=0; i<tamano-1; i++)
    {
      for (j=0; j<2; j++)
      {
	for (k=0; k<limite_k; k++)
	{
	  prod+=momentos[num_mom][i][j][k]*mom_base[num_mom][i][j][k];
	} /* for k */  
      } /* for j */
    }/* for i */
  } /* for num_mom */
  return (prod);
} /* MomTodosEscalar */

void SemejanzaMomTodos (int orden,TIPO ****momentos,TIPO ****mom_base,
			int tamano,TIPO *scores)
{
  TIPO num,den;

  num=MomTodosEscalar(orden,momentos,mom_base,tamano);
  den=(MomTodosEscalar(orden,momentos,momentos,tamano)+
       MomTodosEscalar(orden,mom_base,mom_base,tamano)-num);

  *scores=num/den;
  *scores=1-(*scores);
} /* SemejanzaMomTodos */


void CorrNormMomTodos (int orden,TIPO ****momentos,TIPO ****mom_base,
		       int tamano,TIPO *scores)
{
  TIPO num,den,parcial;

  num=MomTodosEscalar(orden,momentos,mom_base,tamano);
  den=MomTodosEscalar(orden,momentos,momentos,tamano);

  parcial=num/sqrt(den);

  den=MomTodosEscalar(orden,mom_base,mom_base,tamano);

  *scores=parcial/sqrt(den);
  *scores=1-(*scores);
} /* CorrNormMomAnalDet */


int ScoreQueryMomTodos (TIPO **img,int filas,int columnas, int hay_e_umb,
			TIPO e_umbral, int distancia, int orden,
			int combinacion)
{
  TIPO scores;
  FILE *lista;
  char nombre[128], *f_firmas;
  char firmas2u[15]="firmas.m2u", firmas3u[15]="firmas.m3u",
       firmas2c[15]="firmas.m2c", firmas3c[15]="firmas.m3c";
  int retonno=333, tam_unico, lineas, cols;
  TIPO *vec[3], ***momentos[3];
  TIPO  ****mom_base, tonta;
  int tamano, auxiliar;
  int resolucion,seguir,ret;
  FILE *et=NULL, *en=NULL;
  TIPO **vecpesos=NULL;

  if (orden == 2)
  {
    if (combinacion == U)
      f_firmas = firmas2u;
    else /* (combinacion == C) */
      f_firmas = firmas2c;
  }
  else /* (orden == 3) */
  {
    if (combinacion == U)
      f_firmas = firmas3u;
    else /* (combinacion == C) */
      f_firmas = firmas3c;
  }


  lista = fopen(f_firmas, "rb");
  if (lista == NULL)
  {
    perror("");
    printf("Error al abrir %s", f_firmas);
    return(-1);
  }
  retonno = fscanf(lista, "%s %d", nombre, &tamano);
  if ((retonno != 2) || (retonno == EOF))
  {
    perror("");
    printf("Formato incorrecto en %s", f_firmas);
    return(-1);
  }
  /* Determinacion de la voxelizacion */
  tam_unico = DeterminarTamano(filas,columnas);
  if (tam_unico)
  {
    printf("\nLa imagen debe ser cuadrada y de dimensiones potencia"
                   " de 2\n");
  }
  else
  {
    vec[0] = (TIPO *)malloc (filas*columnas*sizeof(TIPO));
    memcpy (vec[0],img[0],filas*columnas*sizeof(TIPO));
    vec[1] = (TIPO *)malloc (filas*columnas*sizeof(TIPO));
    memcpy (vec[1],img[1],filas*columnas*sizeof(TIPO));
    vec[2] = (TIPO *)malloc (filas*columnas*sizeof(TIPO));
    memcpy (vec[2],img[2],filas*columnas*sizeof(TIPO));

    lineas=filas;
    cols=columnas;
  }
  
  tonta= (TIPO)(log(lineas)/log(2.0));
  auxiliar = tonta;
  if (tamano != auxiliar)
  {
    printf("\n tamano=%d y el de la img es %d\n", tamano, auxiliar);
    printf("\nImagenes de distinto tamano: imposible comparacion\n");
    return(0);
  }
  resolucion=tonta;


  momentos[0]=DescYMomTodos(vec[0],lineas,orden,hay_e_umb,e_umbral,
			    combinacion);
  momentos[1]=DescYMomTodos(vec[1],lineas,orden,hay_e_umb,e_umbral,
			    combinacion);  
  momentos[2]=DescYMomTodos(vec[2],lineas,orden,hay_e_umb,e_umbral,
			    combinacion);

  /* Liberamos memoria */
  free(vec[0]);
  vec[0]=NULL;
  free(vec[1]);
  vec[1]=NULL;
  free(vec[2]);
  vec[2]=NULL;

  seguir=1;

  if (distancia == DPESOS)
  {
    if ((!et) && (!en))
    {
      ret=AbrirFicheros("firmas.et","firmas.enr",&et,&en);
      if (ret)
        seguir=0;
    }
  }

  while ((retonno != EOF) && seguir)
  {
    scores=0;
    if ((retonno != 2) && (retonno != EOF))
    {
      printf("\nError raro leyendo firmas.m3s\n");
      fclose(lista);
      seguir=0;
    }
    else if (retonno == 2)
    {
      mom_base = LeerMomTodos(nombre, tamano, orden);
      
      if (mom_base)
      {
	/* Comparamos los vectores de momentos */

	if (distancia == DSIMPLE)
	  CompMomTodosSimple(orden,momentos,mom_base,tamano,&scores);
		
	else if (distancia == DVALUADA)
	  CompMomTodosPesos(orden,momentos,mom_base,tamano,&scores);
	
	else if (distancia == SEMEJANZA)
	  SemejanzaMomTodos(orden,momentos,mom_base,tamano,&scores);

	else if (distancia == CORRELACION)
	  CorrNormMomTodos(orden,momentos,mom_base,tamano,&scores);
	
	else /* if (distancia == DPESOS) */
	{
          vecpesos=CalcularPesos(et,en);
          if (vecpesos)
          {
            DPesosMomTodos(orden,momentos,mom_base,tamano,&scores,vecpesos);
            LiberarPesos(vecpesos,tamano);
            vecpesos=NULL;
          }
          else
            seguir=0;
        } /* else => if distancia == DPESOS */
        
        if (seguir)
	  printf("Semejanza con %s: %.12f\n",nombre,scores);

	LiberarMomAnalDet(mom_base,tamano);
	free(mom_base);
	mom_base=NULL;
      } /* if mom_base */
    } /* retonno == 2 */
    retonno = fscanf(lista, "%s %d", nombre, &tamano);
  } /* while */
  fclose(lista);
  if ((distancia == DPESOS) && et && en)
  {
    fclose(et);
    fclose(en);
  }
  LiberarMomAnalDet(momentos,tamano);
  return(0);
} /* ScoreQueryMomTodos */


/**************************************************************************
*Energias (SIN CORRELACIONES) en coefs de analisis y de detalle y momentos*
* de orden 2 en los coeficientes de analisis.                             *
**************************************************************************/
int DPesosEnMom(int orden, TIPO ***corr,TIPO ****mom,TIPO ***c_base,
		TIPO ****m_base, int tamano,TIPO *scores, FILE *et, 
		FILE *en)
{
  int plano,i,j,k,limite_k,retonno,seguir=1, res;
  TIPO d_energ=0, d_mom=0,num,den,*pesos_e=NULL,**pesos_m=NULL;
  TIPO etotal[3],total, ***correl,en_acumulada,en_nivel;
  char nombre[128];

  retonno = fscanf(et, "%s", nombre);
  if ((retonno != 1) || (retonno == EOF))
  {
    perror("Formato incorrecto en firmas.et");    
  }
  else
  {
    retonno = LeerE_Total(nombre, &etotal[0], &etotal[1], &etotal[2]);
    total=etotal[0]+etotal[1]+etotal[2];
    if (!retonno)
    {
      retonno = fscanf(en, "%s %d", nombre, &i);
      if ((retonno != 2) || (retonno == EOF))
      {
	perror("Formato incorrecto en firmas.et");   
	seguir=0;
      }
      else
      {
	correl = LeerCorrelaciones (nombre, tamano);
        if (correl)
        {
	  /* Primero las energias */
	  
	  pesos_e=(TIPO *)calloc(tamano,sizeof(TIPO));
	  if (pesos_e)
	  {
	    en_acumulada=0;
	    for (i=0; i<tamano;i++)
            {
	      for (j=0; j<3; j++)
	      {
		pesos_e[i] += (correl[i][j][0] + correl[i][j][3] +
                            correl[i][j][5]);
	      } /* for j */
	      en_acumulada += pesos_e[i];
	      pesos_e[i] = pesos_e[i]/total;
	    } /* for i */
	    

	    /* Despues los momentos */
	    pesos_m=(TIPO **)calloc(3,sizeof(TIPO *));
	    if (pesos_m)
            {
	      seguir=1;
	      for (i=0; (i<3) && (seguir); i++)
	      {
		/*
		  Aqui reservamos tamano+1 porque tambien se calculara, por
		  si acaso, el peso que corresponde al coeficiente de analisis.
		*/
		pesos_m[i]=(TIPO *)calloc(tamano+1, sizeof(TIPO));
		seguir = (pesos_m[i] != NULL);
	      }
	      if (seguir)
              {
		en_nivel=0;
		en_acumulada=0;
		for (i=0; i<3; i++)
		{
		  if (i == 0)
		    k=0;
		  else if (i == 1)
		    k=3;
		  else
		    k=5;
                
		  for (res=0; res < tamano; res++)
                  {
		    for (j=0; j<3; j++)
		      en_nivel+=correl[res][j][k];
                  
		    pesos_m[i][res]=en_nivel/etotal[i];
		    en_acumulada+=en_nivel;
		    en_nivel=0;
		  }
                
		  pesos_m[i][tamano]=(etotal[i]-en_acumulada)/etotal[i];
		 
		} /* for i */
	      } /* if (seguir) */
	      else
	      {
		perror("Insuficiente memoria para el vector de pesos.");
		seguir=0;
	      }
	    } /* if (pesos_m) */
	    else
	    {
	      perror("Insuficiente memoria para el vector de pesos.");
	      seguir=0;
	    }
	  } /* if (pesos_e) */
	  else
	    seguir=0;
	} /* if correl */
	else
	  seguir=0;
      } /* if (!retonno) */
    } /* if (!retonno) de e_total */
  } /* if (!retonno) de fscanf et */

  
  /* Primero las energias sin correlaciones*/

  if (seguir)
  {
    for (i=0; i<tamano; i++)
    {
      for (j=0; j<2; j++)
      {
	for (k=0; k<6; k++)
        {
	  if ((corr[i][j][0] != 0) && (c_base[i][j][0] != 0))
	  {
	    num=fabs(corr[i][j][0]-c_base[i][j][0]);
	    den=max(fabs(corr[i][j][0]),fabs(c_base[i][j][0]));
	    
	    d_energ += (num/den)*pesos_e[i];
	  }
	  if ((corr[i][j][3] != 0) && (c_base[i][j][3] != 0))
	  {
	    num=fabs(corr[i][j][3]-c_base[i][j][3]);
	    den=max(fabs(corr[i][j][3]),fabs(c_base[i][j][3]));
	    
	    d_energ += (num/den)*pesos_e[i];
	  }
	  if ((corr[i][j][5] != 0) && (c_base[i][j][5] != 0))
	  {
	    num=fabs(corr[i][j][5]-c_base[i][j][5]);
	    den=max(fabs(corr[i][j][5]),fabs(c_base[i][j][5]));
	    
	    d_energ += (num/den)*pesos_e[i];
	  }
	} /* for k */
      } /* for j */
    }/* for i */


    /* Despues los momentos */

    if (orden == 2)
      limite_k = 2;
    else /* (orden == 3) */
      limite_k = 7;


    for (plano=0; plano<3; plano++)
    {
      for (i=0; i<tamano-1; i++)
      {
	for (j=0; j<2; j++)
	{
	  for (k=0; k<limite_k; k++)
          {
	    if ((mom[plano][i][j][k] != 0) &&
	      (m_base[plano][i][j][k] != 0))
	    {
	      num=fabs(mom[plano][i][j][k]-m_base[plano][i][j][k]);
	      den=max(fabs(mom[plano][i][j][k]),fabs(m_base[plano][i][j][k]));

	      d_mom += (num/den)*pesos_m[plano][i];
	    }
	  } /* for k */
	} /* for j */
      } /* for i */
    } /* for plano */

    *scores=d_energ+d_mom;
  } /* if seguir */

  LiberarPesos(pesos_m,tamano);
  pesos_m=NULL;
  free(pesos_e);
  pesos_e=NULL;
  return (!seguir);
} /* DPesosEnMom */



void CompEnMomSimple(int orden,TIPO ***corr,TIPO ****mom,TIPO ***c_base,
		     TIPO ****m_base,int hasta,TIPO *scores)
{
  TIPO d_energ=0,d_mom=0;
  
  /* Primero las energias */
  CompA2SimpleSC(corr,c_base,hasta,&d_energ);

  /* Despues los momentos */
  CompMomTodosSimple(orden,mom,m_base,hasta,&d_mom);

  *scores=d_energ+d_mom;

} /* CompEnMomSimple */


void CompEnMomPesos(int orden, TIPO ***corr,TIPO ****mom,TIPO ***c_base,
		    TIPO ****m_base,int hasta,TIPO *scores)
{
  TIPO d_energ=0,d_mom=0;

  /* Primero las energias */
  CompA2PesosSC(corr,c_base,hasta,&d_energ);
  
  /* Despues los momentos */
  CompMomTodosPesos(orden,mom,m_base,hasta,&d_mom);

  *scores=d_energ+d_mom;
  
} /* CompEnMomPesos */



void SemejanzaEnMom(int orden, TIPO ***corr,TIPO ****mom,TIPO ***c_base,
		    TIPO ****m_base,int hasta,TIPO *scores)
{
  TIPO num,den;
  TIPO energ=0, d_mom=0;

  /* Primero las energias */
  num=EscalarA2SC(corr,c_base,hasta);
  den=(EscalarA2SC(corr,corr,hasta)+
       EscalarA2SC(c_base,c_base,hasta)-num);
  
  energ=num/den;

  /* Despues los momentos */
  num=MomTodosEscalar(orden,mom,m_base,hasta);
  den=(MomTodosEscalar(orden,mom,mom,hasta)+
       MomTodosEscalar(orden,m_base,m_base,hasta)-num);

  d_mom=num/den;

  *scores=2-energ-d_mom;

} /* SemejanzaEnMom */


void CorrNormEnMom(int orden, TIPO ***corr,TIPO ****mom,TIPO ***c_base,
		   TIPO ****m_base,int hasta,TIPO *scores)
{
  TIPO num,den,parcial;
  TIPO energ=0, dmom=0;

  /* Primero las energias */
  num=EscalarA2SC(corr,c_base,hasta);
  den=EscalarA2SC(corr,corr,hasta);

  parcial=num/sqrt(den);

  den=EscalarA2SC(c_base,c_base,hasta);

  energ=parcial/sqrt(den);

  /* Despues los momentos */
  num=MomTodosEscalar(orden,mom,m_base,hasta);
  den=MomTodosEscalar(orden,mom,mom,hasta);

  parcial=num/sqrt(den);

  den=MomTodosEscalar(orden,m_base,m_base,hasta);
  
  dmom=parcial/sqrt(den);

  *scores=2-energ-dmom;

} /* CorrNormEnMom */


int ScoreQueryEn_Mom(TIPO **img,int filas,int columnas, int hay_e_umb, 
		     TIPO e_umbral, int distancia, int orden, int combinacion)
{

  TIPO scores;
  FILE *lis_en, *lis_m;
  char nom_en[128],nom_m[128];
  int retonno=333, tam_unico, lineas, cols, i, j;
  TIPO *vec[3], ***energia, ***momentos[3],tonta, *vec_aux[3];
  TIPO ***c_base, ****m_base, ***cov_anal=NULL, ***corr_anal=NULL;
  int tamano, auxiliar,ret;
  int resolucion,seguir;
  FILE *et=NULL, *en=NULL;
  char *f_firmas;
  char firmas2u[15]="firmas.m2u", firmas3u[15]="firmas.m3u",
       firmas2c[15]="firmas.m2c", firmas3c[15]="firmas.m3c";


  
  /* Lectura fichero firmas energias */
  lis_en = fopen("/var/tmp/distribuidoDiego/exe/firmas.en2", "r");
  if (lis_en == NULL)
  {
    perror("Error al abrir firmas.en2");
    return(-1);
  }

  /* 
     NOTA: AMBAS FIRMAS GUARDAN UN 9 AL FINAL. SI ESTO CAMBIA,
     LA VARIABLE tamano DEBE DUPLICARSE.
  */
  
  retonno = fscanf(lis_en, "%s %d", nom_en, &tamano);
  if ((retonno != 2) || (retonno == EOF))
  {
    perror("Formato incorrecto en firmas.en2");
    return(-1);
  }

  /* Lectura fichero firmas momentos */

  if (orden == 2)
  {
    if (combinacion == U)
      f_firmas = firmas2u;
    else /* (combinacion == C) */
      f_firmas = firmas2c;
  }
  else /* (orden == 3) */
  {
    if (combinacion == U)
      f_firmas = firmas3u;
    else /* (combinacion == C) */
      f_firmas = firmas3c;
  }

  lis_m = fopen(f_firmas, "rb");
  if (lis_m == NULL)
  {
    printf("Error al abrir %s", f_firmas);
    perror("");
    return(-1);
  }
  retonno = fscanf(lis_m, "%s %d", nom_m, &tamano);
  if ((retonno != 2) || (retonno == EOF))
  {
    printf("Formato incorrecto en %s", f_firmas);
    return(-1);
  }

  /* Determinacion de la voxelizacion */
  tam_unico = DeterminarTamano(filas,columnas);
  if (tam_unico)
  {
    printf("\nLa imagen debe ser cuadrada y de dimensiones potencia"
                   " de 2\n");
  }
  else
  {
    vec[0] = (TIPO *)malloc (filas*columnas*sizeof(TIPO));
    memcpy (vec[0],img[0],filas*columnas*sizeof(TIPO));
    vec[1] = (TIPO *)malloc (filas*columnas*sizeof(TIPO));
    memcpy (vec[1],img[1],filas*columnas*sizeof(TIPO));
    vec[2] = (TIPO *)malloc (filas*columnas*sizeof(TIPO));
    memcpy (vec[2],img[2],filas*columnas*sizeof(TIPO));

    vec_aux[0] = (TIPO *)malloc (filas*columnas*sizeof(TIPO));
    memcpy (vec_aux[0],img[0],filas*columnas*sizeof(TIPO));
    vec_aux[1] = (TIPO *)malloc (filas*columnas*sizeof(TIPO));
    memcpy (vec_aux[1],img[1],filas*columnas*sizeof(TIPO));
    vec_aux[2] = (TIPO *)malloc (filas*columnas*sizeof(TIPO));
    memcpy (vec_aux[2],img[2],filas*columnas*sizeof(TIPO));


    lineas=filas;
    cols=columnas;
  }
  
  tonta= (TIPO)(log(lineas)/log(2.0));
  auxiliar = tonta;
  if (tamano != auxiliar)
  {
    printf("\n tamano=%d y el de la img es %d\n", tamano, auxiliar);
    printf("\nImagenes de distinto tamano: imposible comparacion\n");
    return(0);
  }
  resolucion=tonta;

  /* Reserva de energia para las covarianzas */
  cov_anal=(TIPO ***)calloc(resolucion, sizeof(TIPO **));
  if (cov_anal)
  {
    seguir=1;
    for (i=0; (i<resolucion) && (seguir); i++)
    {
      cov_anal[i]=(TIPO **)calloc(2,sizeof(TIPO *));
      seguir=(cov_anal[i] != NULL);
      for (j=0; j<2; j++)
      {
	cov_anal[i][j]=(TIPO *)calloc(3,sizeof(TIPO));
	seguir=(cov_anal[i][j] != NULL);
      } /* for j */
    } /* for i */
  }
  if (!seguir)
  {
    perror("No se pudo reservar memoria para calcular "
	   "covarianzas");
    Tiempos ();
    exit(1);
  }

  energia=DescYEnerg2 (vec[0],vec[1],vec[2],lineas, &cov_anal);


  momentos[0]=DescYMomTodos(vec_aux[0],lineas,orden,hay_e_umb,e_umbral,
			    combinacion);
  momentos[1]=DescYMomTodos(vec_aux[1],lineas,orden,hay_e_umb,e_umbral,
			    combinacion);  
  momentos[2]=DescYMomTodos(vec_aux[2],lineas,orden,hay_e_umb,e_umbral,
			    combinacion);


  /* Liberamos memoria */
  free(vec[0]);
  vec[0]=NULL;
  free(vec[1]);
  vec[1]=NULL;
  free(vec[2]);
  vec[2]=NULL;

  free(vec_aux[0]);
  vec_aux[0]=NULL;
  free(vec_aux[1]);
  vec_aux[1]=NULL;
  free(vec_aux[2]);
  vec_aux[2]=NULL;
  
  /* Normalizamos y conseguimos los coefs. de correlacion */
  /*printf("\nCorrelaciones: \n");*/
  corr_anal=NormalizarCovA_2(energia, &cov_anal, resolucion);

  
  /* Se supone que se ha liberado la memoria que ocupaban las 
     covarianzas */


  seguir=1;
  if (distancia == DPESOS)
  {
    ret=AbrirFicheros("firmas.et","firmas.enr",&et,&en);
    if (ret)
    {
      seguir=0;
    }
  }    

  while ((retonno != EOF) && seguir)
  {
    scores=0;
    if ((retonno != 2) && (retonno != EOF))
    {
      printf("\nError raro leyendo firmas.m2t\n");
      fclose(lis_m);
      seguir=0;
    }
    else if (retonno == 2)
    {
      m_base = LeerMomTodos(nom_m, tamano, orden);

      c_base = LeerCorrA_2(nom_en, tamano);
      
      if (m_base && c_base)
      {
	/* Comparamos los vectores de momentos */
	
	/*
	  Siempre se elige combinar los resultados de energias y momentos,
	  nunca utilizar el mejor de los dos resultados.
	*/
	
	
	if (distancia == DSIMPLE)
	  CompEnMomSimple(orden,corr_anal,momentos,c_base,m_base,tamano,
			  &scores);
	
	else if (distancia == DVALUADA)
	  CompEnMomPesos(orden,corr_anal,momentos,c_base,m_base,tamano,
			 &scores);
	
	else if (distancia == SEMEJANZA)
	  SemejanzaEnMom(orden,corr_anal,momentos,c_base,m_base,tamano,
			 &scores);

	else if (distancia == CORRELACION)
	  CorrNormEnMom(orden,corr_anal,momentos,c_base,m_base,tamano,
			&scores);

	else /* if (distancia == DPESOS) */
        {
	  ret = DPesosEnMom(orden,corr_anal,momentos,c_base,m_base,tamano,
			    &scores, et,en);
	  seguir=(ret == 0);
	
        } /* else => if distancia == DPESOS */

	if (seguir)
	  printf("Semejanza con %s: %.12f\n",nom_en,scores);
	
	LiberarCorrA_2(&c_base,tamano);
	LiberarMomAnalDet(m_base,tamano);
	free(m_base);
	c_base=NULL;
	m_base=NULL;
      } /* if em_base */
    } /* retonno == 2 */
    retonno = fscanf(lis_en, "%s %d", nom_en, &tamano);
    if ((retonno != 2) && (retonno != EOF))
    {
      printf("\nError raro leyendo firmas.m2t\n");
      fclose(lis_en);
      lis_en=NULL;
      seguir=0;
    }
    else
      retonno = fscanf(lis_m, "%s %d", nom_m, &tamano);
  } /* while */
  if (lis_en)
    fclose(lis_en);
  fclose(lis_m);
  /* LiberarEn_Mom(&em,tamano);*/
  return(0);
} /* ScoreQueryEnMom */





void Formato (char *nome)
{
  printf("\nSINTAXIS: %s -en_analisis2 -tipo_dist", nome);
  printf("\n          %s fich_ent -exact",nome);
  printf("\n          %s fich_ent -jacobs",nome);
  printf("\n          %s fich_ent -umbral valor_umbral", nome);
  printf("\n          %s fich_ent -vecin distancia", nome);
  printf("\n          %s fich_ent -umbral valor -vecin distancia", nome);
  printf("\n          %s fich_ent -wouwer -tipo_dist", nome);
  printf("\n          %s fich_ent -en_analisis -nivel nivel -tipo_dist", nome);
  printf("\n          %s fich_ent -e_total", nome);
  printf("\n          %s fich_ent -mom_2_T -u factor_umbral -tipo_dist", nome);
  printf("\n          %s fich_ent -mom_2_AD -u factor_umbral -tipo_dist", 
	 nome);
  printf("\n          %s fich_ent -mom_2_U -u factor_umbral -tipo_dist", 
	 nome);
  printf("\n          %s fich_ent -mom_2_C -u factor_umbral -tipo_dist", 
	 nome);
  printf("\n          %s fich_ent -mom_3_AD -u factor_umbral -tipo_dist", 
	 nome);
  printf("\n          %s fich_ent -mom_3_U -u factor_umbral -tipo_dist", 
	 nome);
  printf("\n          %s fich_ent -mom_3_C -u factor_umbral -tipo_dist", 
	 nome);
  printf("\n          %s fich_ent -en_mom -u factor_umbral -tipo_dist", nome);
  printf("\n\n tipo_dist debe tomar uno de los siguientes valores: dsimple, "
	 "dvaluada,\nsemejanza, correlacion, dpesos (distancia simple con "
	 "pesos calculados a partir\nde las energias.");
  printf("\n OJO: la opcion dpesos solo se permite con los metodos que "
	 "unicamente\ntrabajan con momentos.\n");
   
} /* Formato */

int Tiempos ()
{
	FILE *fd;
	double tsys, tcpu;
	
	times (&tend);
	
	printf ("Ejecuto la funcion tiempos\n");
	if ((fd = fopen ("/var/tmp/distribuidoDiego/exe/tiempos", "w")) == NULL) 
	{
		printf ("Error: no puedo abrir el fichero **tiempos**\n");
		exit (-1);
	}
	printf ("SCORE: Despus de abrir el fichero\n");
	tcpu = (double) ((tend.tms_utime - tini.tms_utime) + (tend.tms_cutime - tini.tms_cutime)) / (double) CLK_TCK;
	tsys = (double) ((tend.tms_stime - tini.tms_stime) + (tend.tms_cstime - tini.tms_cstime)) / (double) CLK_TCK;
	fprintf (fd, "%.2f %.2f\n", tcpu, tsys);
	fclose (fd);
	return (0);
}
    
void main (int argc, char *argv[])
{
  int alto,ancho,i,dist_vecin,salir=0,exacto=0,por_umbral=0,por_vecinos=0;
  int energias=0,mom2_t=0, e_total=0, por_e_umb=0;
  int en_anal=0, en_anal2=0, hasta=0,en_mom=0,
      jacobs=0,mom2_ad=0,mom3_ad=0,mom2_u=0,mom3_u=0,mom2_c=0,mom3_c=0;
  TIPO e_umbral,umbral;
  char *index;
  int distancia=0;


/* 
 * Modificacin de J. L. Bosque para medir tiempos de sistema y cpu en el solver * Fecha: 29 - 2 - 00.
 */

  times (&tini);
/*
 * Fin de modificacion. (Hay otra al final del programa)
 */
 
  if ((argc > 2) && (argc <= 7))
  {
    i=1;
    /* OJO: PARCHEADO SOLO PARA EL CASO DE EN_ANALISIS 2
       HABRIA QUE ADAPTAR LOS DEMAS
    */
    index=*(argv+i);
    while ((index) && (!salir))
    {
      if (strcmp(index,"-exact") == 0)
      {
        exacto=1;
      }
      else if (strcmp(index,"-jacobs") == 0)
      {
        jacobs=1;
      }
      else if (strcmp(index,"-wouwer") == 0)
      {
        energias=1;
      }
      else if (strcmp(index,"-en_analisis") == 0)
      {
        en_anal=1;
      }
      else if (strcmp(index,"-nivel") == 0)
      {
	i++;
        if (sscanf(*(argv+i),"%d",&hasta) != 1)
        {
           en_anal=0;
        }
      }
      else if (strcmp(index,"-en_analisis2") == 0)
      {
        en_anal2=1;
      }
      else if (strcmp(index,"-e_total") == 0)
      {
        e_total=1;
      }
      else if (strcmp(index,"-mom_2_T") == 0)
      {
	mom2_t=1;
      }
      else if (strcmp(index,"-mom_2_AD") == 0)
      {
	mom2_ad=1;
      }
      else if (strcmp(index,"-mom_2_U") == 0)
      {
	mom2_u=1;
      }
      else if (strcmp(index,"-mom_3_U") == 0)
      {
	mom3_u=1;
      }
      else if (strcmp(index,"-mom_2_C") == 0)
      {
	mom2_c=1;
      }
      else if (strcmp(index,"-mom_3_C") == 0)
      {
	mom3_c=1;
      }
      else if (strcmp(index,"-mom_3_AD") == 0)
      {
	mom3_ad=1;
      }
      else if (strcmp(index,"-en_mom") == 0)
      {
	en_mom=1;
      }
      else if (strcmp(index,"-u")==0)
      {
        i++;
        if (sscanf(*(argv+i),"%f",&e_umbral) == 1)
        {  
          por_e_umb=1;
        }
      }
      else if (strcmp(index,"-umbral")==0)
      {
        i++;
        if (sscanf(*(argv+i),"%f",&umbral) == 1)
        {  
          por_umbral=1;
        }
      }
      else if (strcmp(index,"-vecin")==0)
      {
        i++;
        if (sscanf(*(argv+i),"%d",&dist_vecin) == 1)
        {
          por_vecinos=1;
        }
      }
      else if (strcmp(index,"-dsimple")==0)
      {
	distancia=DSIMPLE;
      }
      else if (strcmp(index,"-dvaluada")==0)
      {
	distancia=DVALUADA;
      }
      else if (strcmp(index,"-semejanza")==0)
      {
	distancia=SEMEJANZA;
      }
      else if (strcmp(index,"-correlacion")==0)
      {
	distancia=CORRELACION;
      }
      else if (strcmp(index,"-dpesos")==0)
      {
	distancia=DPESOS;
      }
      else
      {
        Formato(argv[0]);
        salir=1;
      }
      i++;
      index=*(argv+i);
    } /* while */
    
    if ((distancia == DPESOS) && (mom2_t == 0) && (energias ==0) && 
	(en_mom == 0) && (en_anal == 0) && (en_anal2 == 0) && 
	(mom2_ad == 0) && (mom3_ad == 0) && (mom2_u == 0) && (mom3_u == 0) && 
	(mom2_u == 0) && (mom3_u == 0))
      salir=1;

    if (!salir)
    {
      if (argc == 3)
      {
	if (exacto)
	{   
	  Lee_pnm_TIPO(&alto, &ancho, argv[1], &t[0], &t[1], &t[2]);
	  if (t[0] && t[1] && t[2])
	    ScoreQuery2DUmbral (t,alto,ancho,0);
	}
	else if (jacobs)
	{
	  Lee_pnm_TIPO(&alto, &ancho, argv[1], &w[0], &w[1], &w[2]);
	  if (w[0] && w[1] && w[2])
	  {
	    ToYIQ(alto, ancho, w, &t[0], &t[1], &t[2]);
	    free(w[0]);
	    w[0]=NULL;
	    free(w[1]);
	    w[1]=NULL;
	    free(w[2]);
	    w[2]=NULL;
	    
	    ScoreQueryJacobs (t,alto, ancho);
	  }
	}
	else if (e_total)
        {
	  Lee_pnm_TIPO(&alto, &ancho, argv[1], &t[0], &t[1], &t[2]);
	  if (t[0] && t[1] && t[2])
	    ScoreQueryE_Total (t, alto, ancho);
	} 
	else if (en_anal2)
        {
	    ScoreQueryEnerg_A2 (distancia);
	    system ("sort -t: -n -k 2,2 </var/tmp/distribuidoDiego/exe/solver.out >/var/tmp/distribuidoDiego/exe/solver.ord");
	}

	else
	  Formato (argv[0]);

      } /* if (argc == 3) */
      else if (argc == 4)
      {
	if (por_umbral)
        {
	  Lee_pnm_TIPO(&alto, &ancho, argv[1], &t[0], &t[1], &t[2]);
	  if (t[0] && t[1] && t[2])
	    ScoreQuery2DUmbral (t,alto,ancho,umbral);
	}      
	else if (por_vecinos)
        {
	  Lee_pnm_TIPO(&alto, &ancho, argv[1], &t[0], &t[1], &t[2]);
	  if (t[0] && t[1] && t[2])
	    ScoreQuery2DVecinos (t,alto,ancho,0,dist_vecin);
	}
	else if (energias)
	{
	  Lee_pnm_TIPO(&alto, &ancho, argv[1], &t[0], &t[1], &t[2]);
	  if (t[0] && t[1] && t[2])
	    ScoreQueryEnerg (t, alto, ancho, distancia);
	}
	else if (en_anal)
        {
	  Lee_pnm_TIPO(&alto, &ancho, argv[1], &t[0], &t[1], &t[2]);
	  if (t[0] && t[1] && t[2])
	    ScoreQueryEnerg_A (t, alto, ancho, hasta, distancia);
	}
	else if (mom2_t)
        {
	  Lee_pnm_TIPO(&alto, &ancho, argv[1], &t[0], &t[1], &t[2]);
	  if (t[0] && t[1] && t[2])
	    ScoreQueryMom (t, alto, ancho, 0, 0, distancia);
	}
	else if (mom2_ad)
        {
	  Lee_pnm_TIPO(&alto, &ancho, argv[1], &t[0], &t[1], &t[2]);
	  if (t[0] && t[1] && t[2])
	    ScoreQueryMomAD (t, alto, ancho, 0, 0, distancia);
	}
	else if (mom2_u)
        {
	  Lee_pnm_TIPO(&alto, &ancho, argv[1], &t[0], &t[1], &t[2]);
	  if (t[0] && t[1] && t[2])
	    ScoreQueryMomTodos (t, alto, ancho, 0, 0, distancia, 2, U);
	}
	else if (mom3_u)
        {
	  Lee_pnm_TIPO(&alto, &ancho, argv[1], &t[0], &t[1], &t[2]);
	  if (t[0] && t[1] && t[2])
	    ScoreQueryMomTodos (t, alto, ancho, 0, 0, distancia, 3, U);
	}
	else if (mom2_c)
        {
	  Lee_pnm_TIPO(&alto, &ancho, argv[1], &t[0], &t[1], &t[2]);
	  if (t[0] && t[1] && t[2])
	    ScoreQueryMomTodos (t, alto, ancho, 0, 0, distancia, 2, C);
	}
	else if (mom3_c)
        {
	  Lee_pnm_TIPO(&alto, &ancho, argv[1], &t[0], &t[1], &t[2]);
	  if (t[0] && t[1] && t[2])
	    ScoreQueryMomTodos (t, alto, ancho, 0, 0, distancia, 3, C);
	}
	else if (mom3_ad)
        {
	  Lee_pnm_TIPO(&alto, &ancho, argv[1], &t[0], &t[1], &t[2]);
	  if (t[0] && t[1] && t[2])
	    ScoreQueryMom3AD (t, alto, ancho, 0, 0, distancia);
	}
	else if (en_mom)
        {
	  Lee_pnm_TIPO(&alto, &ancho, argv[1], &t[0], &t[1], &t[2]);
	  if (t[0] && t[1] && t[2])
	    ScoreQueryEn_Mom(t, alto, ancho, 0, 0, distancia, 3, U);
	}
	else
	  Formato(argv[0]);

      } /* else => if (argc == 4) */
      else if (argc == 6)
      {
	if (en_anal)
        {
	  Lee_pnm_TIPO(&alto, &ancho, argv[1], &t[0], &t[1], &t[2]);
	  if (t[0] && t[1] && t[2])
	    ScoreQueryEnerg_A (t, alto, ancho, hasta, distancia);
	}
	else if ((mom2_t) && (por_e_umb))
	{
	  Lee_pnm_TIPO(&alto, &ancho, argv[1], &t[0], &t[1], &t[2]);
	  if (t[0] && t[1] && t[2])
	    ScoreQueryMom (t, alto, ancho, 1, e_umbral, distancia);
	}
	else if ((mom2_ad) && (por_e_umb))
	{
	  Lee_pnm_TIPO(&alto, &ancho, argv[1], &t[0], &t[1], &t[2]);
	  if (t[0] && t[1] && t[2])
	    ScoreQueryMomAD (t, alto, ancho, 1, e_umbral, distancia);
	}
	else if ((mom2_u) && (por_e_umb))
	{
	  Lee_pnm_TIPO(&alto, &ancho, argv[1], &t[0], &t[1], &t[2]);
	  if (t[0] && t[1] && t[2])
	    ScoreQueryMomTodos (t, alto, ancho, 1, e_umbral, distancia,2,U);
	}
	else if ((mom2_c) && (por_e_umb))
	{
	  Lee_pnm_TIPO(&alto, &ancho, argv[1], &t[0], &t[1], &t[2]);
	  if (t[0] && t[1] && t[2])
	    ScoreQueryMomTodos (t, alto, ancho, 1, e_umbral, distancia,2,C);
	}
	else if ((mom3_ad) && (por_e_umb))
	{
	  Lee_pnm_TIPO(&alto, &ancho, argv[1], &t[0], &t[1], &t[2]);
	  if (t[0] && t[1] && t[2])
	    ScoreQueryMom3AD (t, alto, ancho, 1, e_umbral, distancia);
	}
	else if ((mom3_u) && (por_e_umb))
	{
	  Lee_pnm_TIPO(&alto, &ancho, argv[1], &t[0], &t[1], &t[2]);
	  if (t[0] && t[1] && t[2])
	    ScoreQueryMomTodos (t, alto, ancho, 1, e_umbral, distancia, 3, U);
	}
	else if ((mom3_c) && (por_e_umb))
	{
	  Lee_pnm_TIPO(&alto, &ancho, argv[1], &t[0], &t[1], &t[2]);
	  if (t[0] && t[1] && t[2])
	    ScoreQueryMomTodos (t, alto, ancho, 1, e_umbral, distancia, 3, C);
	}
	else if ((en_mom) && (por_e_umb))
	{
	  Lee_pnm_TIPO(&alto, &ancho, argv[1], &t[0], &t[1], &t[2]);
	  if (t[0] && t[1] && t[2])
	    ScoreQueryEn_Mom (t, alto, ancho, 1, e_umbral, distancia,3,U);
	}
	else if ((por_umbral) && (por_vecinos))
        {
	  Lee_pnm_TIPO(&alto, &ancho, argv[1], &t[0], &t[1], &t[2]);
	  if (t[0] && t[1] && t[2])
	    ScoreQuery2DVecinos (t,alto,ancho,umbral,dist_vecin);
	}
	else
	  Formato(argv[0]);

      } /* else if (argc == 6) */
      else
      {
	Formato(argv[0]);
	Tiempos ();
	exit(0);
      }
    } /* if !salir */
    else
    {
      Formato(argv[0]);
      Tiempos ();
      exit(0);
    }
  }
  else /* ((argc < 2) && (argc > 7)) */
  {
    Formato(argv[0]);
    Tiempos ();
    exit(0);
  }
  Tiempos ();
} /* main */
