#include "../include/querying2D.h"
#define NORMALIZAR



/* El fichero de prueba es "vertebra.128x128.dtf" y su tamayo
   es 128x128x114, pero lo almacenamos en un voxel 128x128x128 */

TIPO *u[3], *v[3];
Celda *vector[3];

void Formato (char *nome)
{
   printf("\nSINTAXIS: %s imagen fich_sal -sort num_coefs "
	   "n_pasos_fila n_pasos_col", nome);
   printf("\n          %s imagen fich_sal -jacobs", nome);
   printf("\n          %s imagen fich_sal -wouwer", nome);
   printf("\n          %s imagen fich_sal -en_analisis", nome);
   printf("\n          %s imagen fich_sal -en_analisis2", nome);
   printf("\n          %s imagen fich_sal -e_total", nome);
   printf("\n          %s imagen fich_sal -mom_2_T -u umbral", nome);
   printf("\n          %s imagen fich_sal -mom_2_AD -u umbral", nome);
   printf("\n          %s imagen fich_sal -mom_2_U -u umbral", nome);
   printf("\n          %s imagen fich_sal -mom_2_C -u umbral", nome);
   printf("\n          %s imagen fich_sal -mom_3_U -u umbral", nome);
   printf("\n          %s imagen fich_sal -mom_3_C -u umbral", nome);
   printf("\n          %s imagen fich_sal -mom_3_AD -u umbral", nome);
   printf("\n  Con -sort se opta por utilizar los coefs. de mayor magnitud.\n"
	  "  num_coefs indica el numero de coefs. que se conservan.\n"
	  "  n_pasos indica el numero de pasos de la descomposicion que"
	  "se quieren aplicar.\n"
	  "  n_pasos_col=n_pasos_fila=0 significa maxima descomposicion.\n"
	  "  Con -wouwer se escoge ese tipo concreto de firma.\n"
	  "  Con -en_analisis se calculan energias correladas para los "
	  "coeficientes de\nanalisis de la transformada.\n"
	  "  Con -en_analisis2 se calculan energias correladas para los "
	  "coeficientes de\nanalisis de la transformada y los coeficientes "
	  "de detalle de cada cuadrante\ndiagonal.\n"
	  "  La opcion -mom_2_T selecciona firma por momentos de ordenes "
	  "1 y 2 en los\ncoeficientes de analisis.\n"
	  "  La opcion -mom_2_AD selecciona firma por momentos de ordenes "
	  "1 y 2 en los\ncoeficientes de analisis y de detalle considerandolos"
	  " como una sola region.\n"
	  "  La opcion -mom_2_U selecciona firma por momentos de orden 2 "
	  "como en\nmom_2_AD anadiendo los cuadrantes vertical y horizontal "
	  "considerandolos como\nuna sola region.\n"
	  "  La opcion -mom_2_C selecciona firma por momentos de orden 2 "
	  "como en\nmom_2_AD anadiendo los cuadrantes vertical y horizontal "
	  "combinados en base a\nla sqrt. de la suma de los cuadrados.\n"
	  "  La opcion -mom_3_AD selecciona firma por momentos de ordenes "
	  "1, 2 y 3 en los\ncoeficientes de analisis y de detalle "
	  "considerandolos como una sola region.\n"
	  "  La opcion -mom_3_U selecciona firma por momentos de orden 3 "
	  "como en\nmom_3_AD anadiendo los cuadrantes vertical y horizontal "
	  "considerandolos como\nuna sola region.\n"
	  "  La opcion -mom_3_C selecciona firma por momentos de orden 3 "
	  "como en\nmom_3_AD anadiendo los cuadrantes vertical y horizontal "
	  "combinados en base a\nla sqrt. de la suma de los cuadrados.\n"
	  "  Con -en_mom se calculan energias para coeficientes de analisis "
	  "y momentos de\nordenes 1,2 y 3 para los coeficientes del cuadrante "
	  "diagonal.\n");
}
void main(int argc, char *argv[])
{
  FILE *lista, *ffsal;
  int tam_x, tam_y, tam_unico, tamano;
  int energias,mom2_t,e_total,umb,en_analisis,
      en_analisis2,en_mom,jacobs,
      mom2_ad,mom3_ad,mom2_u,mom3_u,mom2_c,mom3_c;
  int retonno,i,j, resolucion, seguir,orden;
  TIPO umbral, tonta;

  TIPO **energias1, **energias2, **energias3,**energia,***energa_2;
  TIPO ***covarianzas, ***correlaciones, **cov_anal=NULL, **corr_anal=NULL;
  TIPO ***momentos[3],**momentosTres[3],etotal0,etotal1,etotal2;
  TIPO **em[4];

  TIPO *mono=NULL;

  if ((argc != 7) && (argc != 4) && (argc != 6))
  {
    Formato(argv[0]);
  }
  else if (argc == 4)
  {
    energias=(strcmp(argv[3], "-wouwer"));
    en_analisis=(strcmp(argv[3], "-en_analisis"));
    en_analisis2=(strcmp(argv[3], "-en_analisis2"));
    mom2_t=(strcmp(argv[3], "-mom_2_T"));
    mom2_ad=(strcmp(argv[3], "-mom_2_AD"));
    mom3_ad=(strcmp(argv[3], "-mom_3_AD"));
    mom2_u=(strcmp(argv[3], "-mom_2_U"));
    mom3_u=(strcmp(argv[3], "-mom_3_U"));
    mom2_c=(strcmp(argv[3], "-mom_2_C"));
    mom3_c=(strcmp(argv[3], "-mom_3_C"));
    e_total=(strcmp(argv[3], "-e_total"));
    en_mom=(strcmp(argv[3], "-en_mom"));
    jacobs=(strcmp(argv[3], "-jacobs"));
    if ((energias != 0) && (mom2_t != 0) && (e_total != 0) &&
	(en_analisis != 0) && (en_analisis2 != 0) && 
	(en_mom != 0) && (jacobs != 0) &&
	(mom2_ad != 0) && (mom3_ad != 0) && (mom2_u != 0) && (mom3_u != 0) &&
	(mom2_c != 0) && (mom3_c != 0))
      Formato(argv[0]);
    else if (jacobs == 0)
    {
      lista = fopen("firmas.jac", "ab");

      if (!lista)
      {
	perror("Error al abrir firmas.jac");
      }
      else
      {
	/* Nos situamos al final del fichero */
	retonno = fseek (lista,0, SEEK_END);
	if (!retonno)
        {
	  /* Leemos la imagen*/
	  Lee_pnm_TIPO(&tam_x, &tam_y, argv[1], &u[0], &u[1], &u[2]);
	  
	  ToYIQ(tam_x, tam_y, u, &v[0], &v[1], &v[2]);

	  free(u[0]);
	  free(u[1]);
	  free(u[2]);
	  u[0]=NULL;
	  u[1]=NULL;
	  u[2]=NULL;

	  tam_unico = DeterminarTamano(tam_x, tam_y);
	  if (tam_unico)
          {
	    printf("\nLa imagen debe ser cuadrada y de dimensiones potencia"
		   " de 2\n");
	  } /* if tam_unico */
	  else
	  {
	    if (tam_x != tam_y)
	    {	    
	      printf("\nSe requiere que la imagen sea cuadrada.\n");
	    }
	    else
	    { 
	      DescomponerTres(v,tam_x,tam_y,atoi(argv[5]),atoi(argv[6]));
	    
	    
	      ffsal=fopen(argv[2],"wb");
	      if (ffsal == NULL) 
              { 
		printf("Error en la creacion de %s\n",argv[2]);
		printf("Error:     %d %s \n",errno,strerror(errno));
	      }
	      else
              {
		tamano=pow(2,(NIVEL-1));
		CortarYConvertir2D(v[0], &vector[0],tamano);
		free(v[0]);
		v[0]=NULL;
		CortarYConvertir2D(v[1], &vector[1],tamano);
		free(v[1]);
		v[1]=NULL;
		CortarYConvertir2D(v[2], &vector[2],tamano);
		free(v[2]);
		v[2]=NULL;

		/* Escribimos el primer valor */
		retonno = EscribirTres(vector,1,ffsal,argv[2]);
		if (!retonno)
                {
		  vector[0] = vector[0]+1;
		  vector[1] = vector[1]+1;
		  vector[2] = vector[2]+1;
 
		  /*printf("\nObteniendo los els. mayores\n");*/
		  SelectMayores(30,tamano-1, &vector[0]);
		  SelectMayores(30,tamano-1, &vector[1]);
		  SelectMayores(30,tamano-1, &vector[2]);
		  
		  /*printf("Escribiendo los mayores\n");*/
		  /* Escribimos los coefs mas positivos */
		  retonno = EscribirTres(vector,30,ffsal,argv[2]);
		  if (!retonno)
                  {
		    /* Escribimos los coefs mas negativos */
		    vector[0]=vector[0]+30;
		    vector[1]=vector[1]+30;
		    vector[2]=vector[2]+30;
		    /*printf("\nObteniendo los menores\n");*/
		    SelectMenores(30, tamano-1-30,&vector[0]);
		    SelectMenores(30, tamano-1-30,&vector[1]);
		    SelectMenores(30, tamano-1-30,&vector[2]);

		    /*printf("Escribiendo los menores\n");*/
		    retonno = EscribirTres(vector,30,ffsal,argv[2]);
		    if (!retonno)
		    {
		      vector[0] = vector[0]-30-1;
		      vector[1] = vector[1]-30-1;
		      vector[2] = vector[2]-30-1;
		      free(vector[0]);
		      vector[0]=NULL;
		      free(vector[1]);
		      vector[1]=NULL;
		      free(vector[2]);
		      vector[2]=NULL;
		      fclose(ffsal);

		      fprintf(lista, "%s %d 1 %d %d\n",argv[2],60+1,
			      atoi(argv[5]),atoi(argv[6]));
		    } /* if !retonno de escribir los ma's negativos */
                       
		  }/* if !retonno de escribir los ma's positivos */
                    
		}/* if !retonno de escribir el primer valor */
		
	      } /* else de la apertura del fichero */
	    } /* else => tam_x == tam_y */
	  } /* else => if tam_unico */
	} /* if !(retonno) */
      } /* else => if (!lista) */
    } /* if jacobs */
    else if (e_total == 0)
    {
      lista = fopen("firmas.et", "ab");

      if (!lista)
      {
	perror("Error al abrir firmas.et");
      }
      else
      {
	/* Nos situamos al final del fichero */
	retonno = fseek (lista,0, SEEK_END);
	if (!retonno)
        {
	  /* Leemos la imagen*/
	  Lee_pnm_TIPO(&tam_x, &tam_y, argv[1], &v[0], &v[1], &v[2]);
	  
	  tam_unico = DeterminarTamano(tam_x, tam_y);
	  if (tam_unico)
          {
	    Cambiar_Tamano (tam_x, tam_y, v[0], tam_unico, &u[0]);
	    Cambiar_Tamano (tam_x, tam_y, v[1], tam_unico, &u[1]);
	    Cambiar_Tamano (tam_x, tam_y, v[2], tam_unico, &u[2]);
	    
	    	
	    DescomponerTres (u,tam_unico,tam_unico, 0, 0);
	    
	    CalcularEnergiaTotal(u[0],tam_unico,tam_unico,&etotal0);
	    CalcularEnergiaTotal(u[1],tam_unico,tam_unico,&etotal1);
	    CalcularEnergiaTotal(u[2],tam_unico,tam_unico,&etotal2);

	    
	    /* Escribimos la energia total (la firma) en fichero */
	    retonno=EscribirE_Total (etotal0,etotal1,etotal2,argv[2]);
	    if (retonno != -1)
	      fprintf(lista, "%s\n", argv[2]);
	  } /* if tam_unico */
	  else
	  {
	    if (tam_x != tam_y)
	    {
	      printf("\nPara trabajar con momentos se requiere que la imagen"
		     "\nsea cuadrada.\n");
	    }
	    else
	    {
	      
	      DescomponerTres(v,tam_x,tam_y,0,0);

	      CalcularEnergiaTotal(v[0],tam_y,tam_x,&etotal0);
	      
	      /*
	      printf("E. TOTAL: %g\n", etotal0);
	      exit(0);
	      */

	      CalcularEnergiaTotal(v[1],tam_y,tam_x,&etotal1);
	      CalcularEnergiaTotal(v[2],tam_y,tam_x,&etotal2);

	      /* Liberamos memoria */
	      free(v[0]);
	      v[0]=NULL;
	      free(v[1]);
	      v[1]=NULL;
	      free(v[2]);
	      v[2]=NULL;
	    
	      /* Escribimos los momentos (la firma) en fichero */
	      retonno=EscribirE_Total(etotal0,etotal1,etotal2,argv[2]);
	      if (retonno != -1)
		fprintf(lista, "%s\n", argv[2]);
	 
	    } /* else => if tam_x != tam_y */
	  } /* else => if tam_unico */
	} /* if !retonno  */
      } /* else => if !lista */
    } /* else => if e_total == 0 */
    else if (mom2_t == 0)
    {
      lista = fopen("firmas.m2t", "ab");

      if (!lista)
      {
	perror("Error al abrir firmas.m2t");
      }
      else
      {
	/* Nos situamos al final del fichero */
	retonno = fseek (lista,0, SEEK_END);
	if (!retonno)
        {
	  /* Leemos la imagen*/
	  Lee_pnm_TIPO(&tam_x, &tam_y, argv[1], &v[0], &v[1], &v[2]);
	  
	  tam_unico = DeterminarTamano(tam_x, tam_y);
	  if (tam_unico)
          {
	    printf("\nLa imagen debe ser cuadrada y de dimensiones potencia"
		   " de 2\n");
	  } /* if tam_unico */
	  else
	  {
	    if (tam_x != tam_y)
	    {	    
	      printf("\nSe requiere que la imagen sea cuadrada.\n");
	    }
	    else
	    {      		
	      momentosTres[0]=DescYMom1_2(v[0],tam_y,0);
	      momentosTres[1]=DescYMom1_2(v[1],tam_y,0);
	      momentosTres[2]=DescYMom1_2(v[2],tam_y,0);

		
	      /* Liberamos memoria */
	      free(v[0]);
	      v[0]=NULL;
	      free(v[1]);
	      v[1]=NULL;
	      free(v[2]);
	      v[2]=NULL;
	      
	      /* Escribimos los momentos (la firma) en fichero */
	      retonno=EscribirMomentos(momentosTres,tam_y,tam_x,argv[2]);
	      if (retonno != -1)
		fprintf(lista, "%s %d\n", argv[2], retonno);
	    } /* else => if tam_x != tam_y */
	  } /* else => if tam_unico */
	} /* if !retonno  */
      } /* else => if !lista */
    } /* else => if mom2_t == 0 */
    else if (mom2_ad == 0)
    {
      lista = fopen("firmas.m2a", "ab");

      if (!lista)
      {
	perror("Error al abrir firmas.m2a");
      }
      else
      {
	/* Nos situamos al final del fichero */
	retonno = fseek (lista,0, SEEK_END);
	if (!retonno)
        {
	  /* Leemos la imagen*/
	  Lee_pnm_TIPO(&tam_x, &tam_y, argv[1], &v[0], &v[1], &v[2]);
	  
	  tam_unico = DeterminarTamano(tam_x, tam_y);
	  if (tam_unico)
          {
	    printf("\nLa imagen debe ser cuadrada y de dimensiones potencia"
		   " de 2\n");
	  } /* if tam_unico */
	  else
	  {
	    if (tam_x != tam_y)
	    {	    
	      printf("\nSe requiere que la imagen sea cuadrada.\n");
	    }
	    else
	    {      		
	      momentosTres[0]=DescYMom2AD(v[0],tam_y,0,0,NEQ);
	      momentosTres[1]=DescYMom2AD(v[1],tam_y,0,0,NEQ);
	      momentosTres[2]=DescYMom2AD(v[2],tam_y,0,0,NEQ);

		
	      /* Liberamos memoria */
	      free(v[0]);
	      v[0]=NULL;
	      free(v[1]);
	      v[1]=NULL;
	      free(v[2]);
	      v[2]=NULL;
	      
	      /* Escribimos los momentos (la firma) en fichero */
	      retonno=EscribirMomentos(momentosTres,tam_y,tam_x,argv[2]);
	      if (retonno != -1)
		fprintf(lista, "%s %d\n", argv[2], retonno);
	    } /* else => if tam_x != tam_y */
	  } /* else => if tam_unico */
	} /* if !retonno  */
      } /* else => if !lista */
    } /* else => if mom2_ad == 0 */
    else if (mom2_u == 0)
    {
      orden=2;
      lista = fopen("firmas.m2u", "ab");

      if (!lista)
      {
	perror("Error al abrir firmas.m2u");
      }
      else
      {
	/* Nos situamos al final del fichero */
	retonno = fseek (lista,0, SEEK_END);
	if (!retonno)
        {
	  /* Leemos la imagen*/
	  Lee_pnm_TIPO(&tam_x, &tam_y, argv[1], &v[0], &v[1], &v[2]);
	  
	  tam_unico = DeterminarTamano(tam_x, tam_y);
	  if (tam_unico)
          {
	    printf("\nLa imagen debe ser cuadrada y de dimensiones potencia"
		   " de 2\n");
	  } /* if tam_unico */
	  else
	  {
	    if (tam_x != tam_y)
	    {	    
	      printf("\nSe requiere que la imagen sea cuadrada.\n");
	    }
	    else
	    {      		
	      momentos[0]=DescYMomTodos(v[0],tam_y,orden,0,0,U);
	      momentos[1]=DescYMomTodos(v[1],tam_y,orden,0,0,U);
	      momentos[2]=DescYMomTodos(v[2],tam_y,orden,0,0,U);

		
	      /* Liberamos memoria */
	      free(v[0]);
	      v[0]=NULL;
	      free(v[1]);
	      v[1]=NULL;
	      free(v[2]);
	      v[2]=NULL;
	      
	      /* Escribimos los momentos (la firma) en fichero */
	      retonno=EscribirMomTodos(momentos,tam_y,tam_x,argv[2],orden);
	      if (retonno != -1)
		fprintf(lista, "%s %d\n", argv[2], retonno);
	    } /* else => if tam_x != tam_y */
	  } /* else => if tam_unico */
	} /* if !retonno  */
      } /* else => if !lista */
    } /* else => if mom2_u == 0 */
    else if (mom2_c == 0)
    {
      orden=2;
      lista = fopen("firmas.m2c", "ab");

      if (!lista)
      {
	perror("Error al abrir firmas.m2c");
      }
      else
      {
	/* Nos situamos al final del fichero */
	retonno = fseek (lista,0, SEEK_END);
	if (!retonno)
        {
	  /* Leemos la imagen*/
	  Lee_pnm_TIPO(&tam_x, &tam_y, argv[1], &v[0], &v[1], &v[2]);
	  
	  tam_unico = DeterminarTamano(tam_x, tam_y);
	  if (tam_unico)
          {
	    printf("\nLa imagen debe ser cuadrada y de dimensiones potencia"
		   " de 2\n");
	  } /* if tam_unico */
	  else
	  {
	    if (tam_x != tam_y)
	    {	    
	      printf("\nSe requiere que la imagen sea cuadrada.\n");
	    }
	    else
	    {      		
	      momentos[0]=DescYMomTodos(v[0],tam_y,orden,0,0,C);
	      momentos[1]=DescYMomTodos(v[1],tam_y,orden,0,0,C);
	      momentos[2]=DescYMomTodos(v[2],tam_y,orden,0,0,C);

		
	      /* Liberamos memoria */
	      free(v[0]);
	      v[0]=NULL;
	      free(v[1]);
	      v[1]=NULL;
	      free(v[2]);
	      v[2]=NULL;
	      
	      /* Escribimos los momentos (la firma) en fichero */
	      retonno=EscribirMomTodos(momentos,tam_y,tam_x,argv[2],orden);
	      if (retonno != -1)
		fprintf(lista, "%s %d\n", argv[2], retonno);
	    } /* else => if tam_x != tam_y */
	  } /* else => if tam_unico */
	} /* if !retonno  */
      } /* else => if !lista */
    } /* else => if mom2_c == 0 */
    else if (mom3_u == 0)
    {
      orden=3;
      lista = fopen("firmas.m3u", "ab");

      if (!lista)
      {
	perror("Error al abrir firmas.m3u");
      }
      else
      {
	/* Nos situamos al final del fichero */
	retonno = fseek (lista,0, SEEK_END);
	if (!retonno)
        {
	  /* Leemos la imagen*/
	  Lee_pnm_TIPO(&tam_x, &tam_y, argv[1], &v[0], &v[1], &v[2]);
	  
	  tam_unico = DeterminarTamano(tam_x, tam_y);
	  if (tam_unico)
          {
	    printf("\nLa imagen debe ser cuadrada y de dimensiones potencia"
		   " de 2\n");
	  } /* if tam_unico */
	  else
	  {
	    if (tam_x != tam_y)
	    {	    
	      printf("\nSe requiere que la imagen sea cuadrada.\n");
	    }
	    else
	    {      		
	      momentos[0]=DescYMomTodos(v[0],tam_y,orden,0,0,U);
	      momentos[1]=DescYMomTodos(v[1],tam_y,orden,0,0,U);
	      momentos[2]=DescYMomTodos(v[2],tam_y,orden,0,0,U);

		
	      /* Liberamos memoria */
	      free(v[0]);
	      v[0]=NULL;
	      free(v[1]);
	      v[1]=NULL;
	      free(v[2]);
	      v[2]=NULL;
	      
	      /* Escribimos los momentos (la firma) en fichero */
	      retonno=EscribirMomTodos(momentos,tam_y,tam_x,argv[2],orden);
	      if (retonno != -1)
		fprintf(lista, "%s %d\n", argv[2], retonno);
	    } /* else => if tam_x != tam_y */
	  } /* else => if tam_unico */
	} /* if !retonno  */
      } /* else => if !lista */
    } /* else => if mom3_u == 0 */
    else if (mom3_c == 0)
    {
      orden=3;
      lista = fopen("firmas.m3c", "ab");

      if (!lista)
      {
	perror("Error al abrir firmas.m3c");
      }
      else
      {
	/* Nos situamos al final del fichero */
	retonno = fseek (lista,0, SEEK_END);
	if (!retonno)
        {
	  /* Leemos la imagen*/
	  Lee_pnm_TIPO(&tam_x, &tam_y, argv[1], &v[0], &v[1], &v[2]);
	  
	  tam_unico = DeterminarTamano(tam_x, tam_y);
	  if (tam_unico)
          {
	    printf("\nLa imagen debe ser cuadrada y de dimensiones potencia"
		   " de 2\n");
	  } /* if tam_unico */
	  else
	  {
	    if (tam_x != tam_y)
	    {	    
	      printf("\nSe requiere que la imagen sea cuadrada.\n");
	    }
	    else
	    {      		
	      momentos[0]=DescYMomTodos(v[0],tam_y,orden,0,0,C);
	      momentos[1]=DescYMomTodos(v[1],tam_y,orden,0,0,C);
	      momentos[2]=DescYMomTodos(v[2],tam_y,orden,0,0,C);

		
	      /* Liberamos memoria */
	      free(v[0]);
	      v[0]=NULL;
	      free(v[1]);
	      v[1]=NULL;
	      free(v[2]);
	      v[2]=NULL;
	      
	      /* Escribimos los momentos (la firma) en fichero */
	      retonno=EscribirMomTodos(momentos,tam_y,tam_x,argv[2],orden);
	      if (retonno != -1)
		fprintf(lista, "%s %d\n", argv[2], retonno);
	    } /* else => if tam_x != tam_y */
	  } /* else => if tam_unico */
	} /* if !retonno  */
      } /* else => if !lista */
    } /* else => if mom3_c == 0 */
    else if (mom3_ad == 0)
    {
      lista = fopen("firmas.m3a", "ab");

      if (!lista)
      {
	perror("Error al abrir firmas.m3a");
      }
      else
      {
	/* Nos situamos al final del fichero */
	retonno = fseek (lista,0, SEEK_END);
	if (!retonno)
        {
	  /* Leemos la imagen*/
	  Lee_pnm_TIPO(&tam_x, &tam_y, argv[1], &v[0], &v[1], &v[2]);
	  
	  tam_unico = DeterminarTamano(tam_x, tam_y);
	  if (tam_unico)
          {
	    printf("\nLa imagen debe ser cuadrada y de dimensiones potencia"
		   " de 2\n");
	  } /* if tam_unico */
	  else
	  {
	    if (tam_x != tam_y)
	    {	    
	      printf("\nSe requiere que la imagen sea cuadrada.\n");
	    }
	    else
	    {      		
	      momentosTres[0]=DescYMom3AD(v[0],tam_y,0,0,NEQ);
	      momentosTres[1]=DescYMom3AD(v[1],tam_y,0,0,NEQ);
	      momentosTres[2]=DescYMom3AD(v[2],tam_y,0,0,NEQ);

		
	      /* Liberamos memoria */
	      free(v[0]);
	      v[0]=NULL;
	      free(v[1]);
	      v[1]=NULL;
	      free(v[2]);
	      v[2]=NULL;
	      
	      /* Escribimos los momentos (la firma) en fichero */
	      retonno=EscribirMomentosTres(momentosTres,tam_y,tam_x,argv[2]);
	      if (retonno != -1)
		fprintf(lista, "%s %d\n", argv[2], retonno);
	    } /* else => if tam_x != tam_y */
	  } /* else => if tam_unico */
	} /* if !retonno  */
      } /* else => if !lista */
    } /* else => if mom3_ad == 0 */
    else if (energias == 0)
    {
      lista = fopen("firmas.enr", "ab");

      if (!lista)
      {
	perror("Error al abrir firmas.enr");
      }
      else
      {
	/* Nos situamos al final del fichero */
	retonno = fseek (lista,0, SEEK_END);
	if (!retonno)
        {
	  /* Leemos la imagen*/
	  Lee_pnm_TIPO(&tam_x, &tam_y, argv[1], &v[0], &v[1], &v[2]);
	  
	  tam_unico = DeterminarTamano(tam_x, tam_y);
	  if (tam_unico)
          {
	    /*
            printf("\nComienza cambio de tamano\n");
	    */
	    Cambiar_Tamano (tam_x, tam_y, v[0], tam_unico, &u[0]);
	    Cambiar_Tamano (tam_x, tam_y, v[1], tam_unico, &u[1]);
	    Cambiar_Tamano (tam_x, tam_y, v[2], tam_unico, &u[2]);
	  
	
	    /*
            printf("Descomposicion standar al maximo\n");
            */
	    DescomponerTres (u,tam_unico,tam_unico, 0, 0);
	    
	    /* Calculo de las energias */
	    
	    
	    energias1=CalcularEnergias(u[0],tam_unico,tam_unico);

	    /*printf("\nEnergias2: \n");*/
	    energias2=CalcularEnergias(u[1],tam_unico,tam_unico);

	    /*printf("\nEnergias3: \n");*/
	    energias3=CalcularEnergias(u[2],tam_unico,tam_unico);
	    
	    /* Calculo de los coefs. de covarianza */
	    /*printf("\nCovarianzas: \n");*/
	    covarianzas=CalcularCovarianzas(u[0], u[1], u[2],
					    tam_unico, tam_unico);
	    
	    /* Liberamos memoria */
	    free(u[0]);
	    u[0]=NULL;
	    free(u[1]);
	    u[1]=NULL;
	    free(u[2]);
	    u[2]=NULL;
	    
	    /* Normalizamos y conseguimos los coefs. de correlacion */
	    /*printf("\nCorrelaciones: \n");*/
	    correlaciones=NormalizarCov(energias1, energias2, energias3,
					&covarianzas, tam_unico, tam_unico);

	    /* Se supone que se ha liberado la memoria que ocupaban las 
	       covarianzas */

	    retonno=EscribirCorrelaciones(correlaciones,tam_unico, tam_unico, 
					  argv[2]);
	    if (retonno != -1)
	      fprintf(lista, "%s %d\n", argv[2], retonno);
	  } /* if tam_unico */
	  else
	  {
	    if (tam_x != tam_y)
	    {
	      printf("\nPara trabajar con energias se requiere que la imagen"
		     "\nsea cuadrada.\n");
	    }
	    else
	    {
	      
	      DescomponerTres(v,tam_x,tam_y,0,0);
	   
	      /* Calculo de las energias */
	      
	      energias1=CalcularEnergias(v[0],tam_y,tam_x);
	      
	      /*
	      etotal0=0.0;
	      for (i=0; i<9; i++)
	      {
		  printf("%g\t%g\t%g\n",energias1[i][0],energias1[i][1],
			 energias1[i][2]);
		  etotal0+=(energias1[i][0]+energias1[i][1]+energias1[i][2]);
	      }
	      printf("Suma de las anteriores: %g\n",etotal0);
	      printf("Energia del pixel 00: %g\n", v[0][0]*v[0][0]);
	      printf("Total=%g\n",etotal0+(v[0][0]*v[0][0]));
	      exit(0);
	      */

	      /*printf("\nEnergias1 GREEN: \n");*/
	      energias2=CalcularEnergias(v[1],tam_y,tam_x);
	      
	      /*printf("\nEnergias3 BLUE: \n");*/
	      energias3=CalcularEnergias(v[2],tam_y,tam_x);
	    
	      /* Calculo de los coefs. de covarianza */
	      /*printf("\nCovarianzas: \n");*/
	      covarianzas=CalcularCovarianzas(v[0], v[1], v[2],tam_y, tam_x);
	    
	      /* Liberamos memoria */
	      free(v[0]);
	      v[0]=NULL;
	      free(v[1]);
	      v[1]=NULL;
	      free(v[2]);
	      v[2]=NULL;
	    
	      /* Normalizamos y conseguimos los coefs. de correlacion */
	      /*printf("\nCorrelaciones: \n");*/
	      correlaciones=NormalizarCov(energias1, energias2, energias3,
					  &covarianzas, tam_y, tam_x);

	      /* Se supone que se ha liberado la memoria que ocupaban las 
		 covarianzas */

	      retonno=EscribirCorrelaciones(correlaciones, tam_y, tam_x, 
					    argv[2]);
	      if (retonno != -1)
		fprintf(lista, "%s %d\n", argv[2], retonno);
	 
	    } /* else => if tam_x != tam_y */
	  } /* else => if tam_unico */
	} /* if !retonno  */
      } /* else => if !lista */
    } /* else => if (energias == 0) */
    else if (en_analisis == 0)
    {
      lista = fopen("firmas.ena", "ab");

      if (!lista)
      {
	perror("Error al abrir firmas.ena");
      }
      else
      {
	/* Nos situamos al final del fichero */
	retonno = fseek (lista,0, SEEK_END);
	if (!retonno)
        {
	  /* Leemos la imagen*/
	  Lee_pnm_TIPO(&tam_x, &tam_y, argv[1], &v[0], &v[1], &v[2]);
	  
	  tam_unico = DeterminarTamano(tam_x, tam_y);
	  if (tam_unico)
          {
	     printf("\nLa imagen debe ser cuadrada y de dimensiones potencia"
                   " de 2\n");
          } /* if tam_unico */
	  else
	  {
	    if (tam_x != tam_y)
	    {
	      printf("\nSe requiere que la imagen sea cuadrada.\n");
	    }
	    else
	    {
	      tonta=(TIPO)(log((TIPO)tam_x)/log(2.0));
	      resolucion=tonta;

	       /* Reserva de energia para las covarianzas */
	      cov_anal=(TIPO **)calloc(resolucion, sizeof(TIPO *));
	      if (cov_anal)
	      {
		seguir=1;
		for (i=0; (i<resolucion) && (seguir); i++)
		{
		  cov_anal[i]=(TIPO *)calloc(3,sizeof(TIPO));
		  seguir=(cov_anal[i] != NULL);
		} /* for i */
	      }
	      if (!seguir)
	      {
		perror("No se pudo reservar memoria para calcular "
		       "covarianzas");
		exit(1);
	      }

	      energia=DescYEnerg (v[0],v[1],v[2],tam_y, &cov_anal);
	   
	      /* Liberamos memoria */
	      free(v[0]);
	      v[0]=NULL;
	      free(v[1]);
	      v[1]=NULL;
	      free(v[2]);
	      v[2]=NULL;
	    
	      /* Normalizamos y conseguimos los coefs. de correlacion */
	      /*printf("\nCorrelaciones: \n");*/
	      corr_anal=NormalizarCovAnal(energia, &cov_anal, resolucion);

	      /* Se supone que se ha liberado la memoria que ocupaban las 
		 covarianzas */

	      retonno=EscribirCorrAnal(corr_anal, resolucion, argv[2]);
	      if (retonno != -1)
		fprintf(lista, "%s %d\n", argv[2], retonno);
	 
	    } /* else => if tam_x != tam_y */
	  } /* else => if tam_unico */
	} /* if !retonno  */
      } /* else => if !lista */
    } /* else => if (en_analisis == 0) */
    else if (en_analisis2 == 0)
    {
      lista = fopen("/var/tmp/distribuido/exe/firmas.en2", "ab");

      if (!lista)
      {
	perror("Error al abrir firmas.en2");
      }
      else
      {
	/* Nos situamos al final del fichero */
	retonno = fseek (lista,0, SEEK_END);
	if (!retonno)
        {
	  /* Leemos la imagen*/
	  Lee_pnm_TIPO(&tam_x, &tam_y, argv[1], &v[0], &v[1], &v[2]);
	  
	  tam_unico = DeterminarTamano(tam_x, tam_y);
	  if (tam_unico)
          {
	     printf("\nLa imagen debe ser cuadrada y de dimensiones potencia"
                   " de 2\n");
          } /* if tam_unico */
	  else
	  {
	    if (tam_x != tam_y)
	    {
	      printf("\nSe requiere que la imagen sea cuadrada.\n");
	    }
	    else
	    {
	      tonta=(TIPO)(log((TIPO)tam_x)/log(2.0));
	      resolucion=tonta;

	       /* Reserva de energia para las covarianzas */
	      covarianzas=(TIPO ***)calloc(resolucion, sizeof(TIPO **));
	      if (covarianzas)
	      {
		seguir=1;
		for (i=0; (i<resolucion) && (seguir); i++)
		{
		  covarianzas[i]=(TIPO **)calloc(2,sizeof(TIPO *));
		  seguir=(covarianzas[i] != NULL);
		  for (j=0; j<2; j++)
		  {
		    covarianzas[i][j]=(TIPO *)calloc(3,sizeof(TIPO));
		    seguir=(covarianzas[i][j] != NULL);
		  } /* for j */
		} /* for i */
	      }
	      if (!seguir)
	      {
		perror("No se pudo reservar memoria para calcular "
		       "covarianzas");
		exit(1);
	      }

	      energa_2=DescYEnerg2 (v[0],v[1],v[2],tam_y, &covarianzas);
	   
	      /* Liberamos memoria */
	      free(v[0]);
	      v[0]=NULL;
	      free(v[1]);
	      v[1]=NULL;
	      free(v[2]);
	      v[2]=NULL;
	    
	      /* Normalizamos y conseguimos los coefs. de correlacion */
	      /*printf("\nCorrelaciones: \n");*/
	      correlaciones=NormalizarCovA_2(energa_2, &covarianzas, 
					     resolucion);

	      /* Se supone que se ha liberado la memoria que ocupaban las 
		 covarianzas */

	      retonno=EscribirCorrA_2(correlaciones, resolucion, argv[2]);
	      if (retonno != -1)
		fprintf(lista, "%s %d\n", argv[2], retonno);
	 
	    } /* else => if tam_x != tam_y */
	  } /* else => if tam_unico */
	} /* if !retonno  */
      } /* else => if !lista */
    } /* else => if (en_analisis2 == 0) */
    else if (en_mom == 0)
    {
      lista = fopen("firmas.e_m", "ab");

      if (!lista)
      {
	perror("Error al abrir firmas.e_m");
      }
      else
      {
	/* Nos situamos al final del fichero */
	retonno = fseek (lista,0, SEEK_END);
	if (!retonno)
        {
	  /* Leemos la imagen*/
	  Lee_pnm_TIPO(&tam_x, &tam_y, argv[1], &v[0], &v[1], &v[2]);
	  
	  tam_unico = DeterminarTamano(tam_x, tam_y);
	  if (tam_unico)
          {
	     printf("\nLa imagen debe ser cuadrada y de dimensiones potencia"
                   " de 2\n");
          } /* if tam_unico */
	  else
	  {
	    if (tam_x != tam_y)
	    {
	      printf("\nSe requiere que la imagen sea cuadrada.\n");
	    }
	    else
	    {
	      tonta=(TIPO)(log((TIPO)tam_x)/log(2.0));
	      resolucion=tonta;

	       /* Reserva de energia para las covarianzas */
	      cov_anal=(TIPO **)calloc(resolucion, sizeof(TIPO *));
	      if (cov_anal)
	      {
		seguir=1;
		for (i=0; (i<resolucion) && (seguir); i++)
		{
		  cov_anal[i]=(TIPO *)calloc(3,sizeof(TIPO));
		  seguir=(cov_anal[i] != NULL);
		} /* for i */
	      }
	      if (!seguir)
	      {
		perror("No se pudo reservar memoria para calcular "
		       "covarianzas");
		exit(1);
	      }

	      energia=DescYEnerg (v[0],v[1],v[2],tam_y, &cov_anal);
	   

	      Umbralizar(&v[0],tam_y,tam_x,VARIANZA);
	      Umbralizar(&v[1],tam_y,tam_x,VARIANZA);
	      Umbralizar(&v[2],tam_y,tam_x,VARIANZA);


	      em[1]=CalcularMomTres_D(v[0],tam_y,tam_y);
	      em[2]=CalcularMomTres_D(v[1],tam_y,tam_y);
	      em[3]=CalcularMomTres_D(v[2],tam_y,tam_y);	      

	      /* Liberamos memoria */
	      free(v[0]);
	      v[0]=NULL;
	      free(v[1]);
	      v[1]=NULL;
	      free(v[2]);
	      v[2]=NULL;
	    
	      /* Normalizamos y conseguimos los coefs. de correlacion */
	      /*printf("\nCorrelaciones: \n");*/
	      em[0]=NormalizarCovAnal(energia, &cov_anal, resolucion);

	      /* Se supone que se ha liberado la memoria que ocupaban las 
		 covarianzas */

	      retonno=EscribirEn_Mom(em, resolucion, argv[2]);
	      if (retonno != -1)
		fprintf(lista, "%s %d\n", argv[2], retonno);
	 
	    } /* else => if tam_x != tam_y */
	  } /* else => if tam_unico */
	} /* if !retonno  */
      } /* else => if !lista */
    } /* else => if (en_mom == 0) */

  } /* else if argc == 4 */

  /* argc=6 debe ser momen o momtres con umbral por linea de comando */

  else if (argc==6)
  {
    energias=(strcmp(argv[3], "-wouwer"));
    mom2_t=(strcmp(argv[3], "-mom_2_T"));
    mom2_ad=(strcmp(argv[3], "-mom_2_AD"));
    mom3_ad=(strcmp(argv[3], "-mom_3_AD"));
    mom2_u=(strcmp(argv[3], "-mom_2_U"));
    mom3_u=(strcmp(argv[3], "-mom_3_U"));
    mom2_c=(strcmp(argv[3], "-mom_2_C"));
    mom3_c=(strcmp(argv[3], "-mom_3_C"));
    e_total=(strcmp(argv[3], "-e_total"));
    en_mom=(strcmp(argv[3], "-en_mom"));
    umb=(strcmp(argv[4], "-u"));
    if ((energias != 0) && (mom2_t != 0) && (e_total != 0) &&
	(en_mom != 0) && (mom2_ad != 0) &&
	(mom3_ad != 0) && (mom2_u != 0) && (mom3_u != 0) && (mom2_c != 0) && 
	(mom3_c != 0))
      Formato(argv[0]);
    else if ((mom2_t == 0) && (umb == 0))
    {
      if (sscanf(argv[5],"%f",&umbral) != 1)
	Formato(argv[0]);
      else
      {
	lista = fopen("firmas.m2t", "ab");

	if (!lista)
        {
	  perror("Error al abrir firmas.m2t");
	}
	else
        {
	  /* Nos situamos al final del fichero */
	  retonno = fseek (lista,0, SEEK_END);
	  if (!retonno)
          { 
	    /* Leemos la imagen*/
	    Lee_pnm_TIPO(&tam_x, &tam_y, argv[1], &v[0], &v[1], &v[2]);
	  
	    tam_unico = DeterminarTamano(tam_x, tam_y);
	    if (tam_unico)
	    {
	      printf("\nLa imagen debe ser cuadrada y de dimensiones potencia"
		     " de 2\n");
	    } /* if tam_unico */
	    else
	    {
	      if (tam_x != tam_y)
	      {	    
		printf("\nSe requiere que la imagen sea cuadrada.\n");
	      }
	      else
	      {      		
		momentosTres[0]=DescYMom1_2(v[0],tam_y,umbral);
		momentosTres[1]=DescYMom1_2(v[1],tam_y,umbral);
		momentosTres[2]=DescYMom1_2(v[2],tam_y,umbral);

		
		/* Liberamos memoria */
		free(v[0]);
		v[0]=NULL;
		free(v[1]);
		v[1]=NULL;
		free(v[2]);
		v[2]=NULL;
		
		/* Escribimos los momentos (la firma) en fichero */
		retonno=EscribirMomentos(momentosTres,tam_y,tam_x,argv[2]);
		if (retonno != -1)
		  fprintf(lista, "%s %d\n", argv[2], retonno);
	      } /* else => if tam_x != tam_y */
	    } /* else => if tam_unico */
	  } /* if !retonno  */
	} /* else => if !lista */
      } /* else if sscanf != 1 */
    } /* else => if mom2_t == 0 */
    else if ((mom2_ad == 0) && (umb == 0))
    {
      if (sscanf(argv[5],"%f",&umbral) != 1)
	Formato(argv[0]);
      else
      {
	lista = fopen("firmas.m2a", "ab");

	if (!lista)
        {
	  perror("Error al abrir firmas.m2a");
	}
	else
        {
	  /* Nos situamos al final del fichero */
	  retonno = fseek (lista,0, SEEK_END);
	  if (!retonno)
          { 
	    /* Leemos la imagen*/
	    Lee_pnm_TIPO(&tam_x, &tam_y, argv[1], &v[0], &v[1], &v[2]);
	  
	    tam_unico = DeterminarTamano(tam_x, tam_y);
	    if (tam_unico)
	    {
	      printf("\nLa imagen debe ser cuadrada y de dimensiones potencia"
		     " de 2\n");
	    } /* if tam_unico */
	    else
	    {
	      if (tam_x != tam_y)
	      {	    
		printf("\nSe requiere que la imagen sea cuadrada.\n");
	      }
	      else
	      {      		
		momentosTres[0]=DescYMom2AD(v[0],tam_y,1,umbral,NEQ);
		momentosTres[1]=DescYMom2AD(v[1],tam_y,1,umbral,NEQ);
		momentosTres[2]=DescYMom2AD(v[2],tam_y,1,umbral,NEQ);

		
		/* Liberamos memoria */
		free(v[0]);
		v[0]=NULL;
		free(v[1]);
		v[1]=NULL;
		free(v[2]);
		v[2]=NULL;
		
		/* Escribimos los momentos (la firma) en fichero */
		retonno=EscribirMomentos(momentosTres,tam_y,tam_x,argv[2]);
		if (retonno != -1)
		  fprintf(lista, "%s %d\n", argv[2], retonno);
	      } /* else => if tam_x != tam_y */
	    } /* else => if tam_unico */
	  } /* if !retonno  */
	} /* else => if !lista */
      } /* else if sscanf != 1 */
    } /* else => if mom2_ad == 0 */
    else if ((mom2_u == 0) && (umb == 0))
    {
      orden=2;

      if (sscanf(argv[5],"%f",&umbral) != 1)
	Formato(argv[0]);
      else
      {
	lista = fopen("firmas.m2u", "ab");

	if (!lista)
	{
	  perror("Error al abrir firmas.m2u");
	}
	else
        {
	  /* Nos situamos al final del fichero */
	  retonno = fseek (lista,0, SEEK_END);
	  if (!retonno)
          {
	    /* Leemos la imagen*/
	    Lee_pnm_TIPO(&tam_x, &tam_y, argv[1], &v[0], &v[1], &v[2]);
	  
	    tam_unico = DeterminarTamano(tam_x, tam_y);
	    if (tam_unico)
            {
	      printf("\nLa imagen debe ser cuadrada y de dimensiones potencia"
		     " de 2\n");
	    } /* if tam_unico */
	    else
	    {
	      if (tam_x != tam_y)
	      {	    
		printf("\nSe requiere que la imagen sea cuadrada.\n");
	      }
	      else
	      {      		
		momentos[0]=DescYMomTodos(v[0],tam_y,orden,1,umbral,U);
		momentos[1]=DescYMomTodos(v[1],tam_y,orden,1,umbral,U);
		momentos[2]=DescYMomTodos(v[2],tam_y,orden,1,umbral,U);

		
		/* Liberamos memoria */
		free(v[0]);
		v[0]=NULL;
		free(v[1]);
		v[1]=NULL;
		free(v[2]);
		v[2]=NULL;
	      
		/* Escribimos los momentos (la firma) en fichero */
		retonno=EscribirMomTodos(momentos,tam_y,tam_x,argv[2],orden);
		if (retonno != -1)
		  fprintf(lista, "%s %d\n", argv[2], retonno);
	      } /* else => if tam_x != tam_y */
	    } /* else => if tam_unico */
	  } /* if !retonno  */
	} /* else => if !lista */
      } /* else if sscanf != 1 */
    } /* else => if mom2_u == 0 */
    else if ((mom2_c == 0) && (umb == 0))
    {
      orden=2;

      if (sscanf(argv[5],"%f",&umbral) != 1)
	Formato(argv[0]);
      else
      {
	lista = fopen("firmas.m2c", "ab");

	if (!lista)
	{
	  perror("Error al abrir firmas.m2c");
	}
	else
        {
	  /* Nos situamos al final del fichero */
	  retonno = fseek (lista,0, SEEK_END);
	  if (!retonno)
          {
	    /* Leemos la imagen*/
	    Lee_pnm_TIPO(&tam_x, &tam_y, argv[1], &v[0], &v[1], &v[2]);
	  
	    tam_unico = DeterminarTamano(tam_x, tam_y);
	    if (tam_unico)
            {
	      printf("\nLa imagen debe ser cuadrada y de dimensiones potencia"
		     " de 2\n");
	    } /* if tam_unico */
	    else
	    {
	      if (tam_x != tam_y)
	      {	    
		printf("\nSe requiere que la imagen sea cuadrada.\n");
	      }
	      else
	      {      		
		momentos[0]=DescYMomTodos(v[0],tam_y,orden,1,umbral,C);
		momentos[1]=DescYMomTodos(v[1],tam_y,orden,1,umbral,C);
		momentos[2]=DescYMomTodos(v[2],tam_y,orden,1,umbral,C);

		
		/* Liberamos memoria */
		free(v[0]);
		v[0]=NULL;
		free(v[1]);
		v[1]=NULL;
		free(v[2]);
		v[2]=NULL;
	      
		/* Escribimos los momentos (la firma) en fichero */
		retonno=EscribirMomTodos(momentos,tam_y,tam_x,argv[2],orden);
		if (retonno != -1)
		  fprintf(lista, "%s %d\n", argv[2], retonno);
	      } /* else => if tam_x != tam_y */
	    } /* else => if tam_unico */
	  } /* if !retonno  */
	} /* else => if !lista */
      } /* else if sscanf != 1 */
    } /* else => if mom2_c == 0 */
    else if ((mom3_u == 0) && (umb == 0))
    {
      orden=3;

      if (sscanf(argv[5],"%f",&umbral) != 1)
	Formato(argv[0]);
      else
      {
	lista = fopen("firmas.m3u", "ab");

        if (!lista)
        {
	  perror("Error al abrir firmas.m3u");
        }
        else
        {
	  /* Nos situamos al final del fichero */
	  retonno = fseek (lista,0, SEEK_END);
	  if (!retonno)
          {
	    /* Leemos la imagen*/
	    Lee_pnm_TIPO(&tam_x, &tam_y, argv[1], &v[0], &v[1], &v[2]);
	  
	    tam_unico = DeterminarTamano(tam_x, tam_y);
	    if (tam_unico)
            {
	      printf("\nLa imagen debe ser cuadrada y de dimensiones potencia"
		     " de 2\n");
	    } /* if tam_unico */
	    else
	    {
	      if (tam_x != tam_y)
	      {	    
		printf("\nSe requiere que la imagen sea cuadrada.\n");
	      }
	      else
	      {      		
		momentos[0]=DescYMomTodos(v[0],tam_y,orden,1,umbral,U);
		momentos[1]=DescYMomTodos(v[1],tam_y,orden,1,umbral,U);
		momentos[2]=DescYMomTodos(v[2],tam_y,orden,1,umbral,U);

		
		/* Liberamos memoria */
		free(v[0]);
		v[0]=NULL;
		free(v[1]);
		v[1]=NULL;
		free(v[2]);
		v[2]=NULL;
	      
		/* Escribimos los momentos (la firma) en fichero */
		retonno=EscribirMomTodos(momentos,tam_y,tam_x,argv[2],orden);
		if (retonno != -1)
		  fprintf(lista, "%s %d\n", argv[2], retonno);
	      } /* else => if tam_x != tam_y */
	    } /* else => if tam_unico */
	  } /* if !retonno  */
	} /* else => if !lista */
      } /* else if sscanf != 1 */
    } /* else => if mom3_u == 0 */
    else if ((mom3_c == 0) && (umb == 0))
    {
      orden=3;

      if (sscanf(argv[5],"%f",&umbral) != 1)
	Formato(argv[0]);
      else
      {
	lista = fopen("firmas.m3c", "ab");

        if (!lista)
        {
	  perror("Error al abrir firmas.m3c");
        }
        else
        {
	  /* Nos situamos al final del fichero */
	  retonno = fseek (lista,0, SEEK_END);
	  if (!retonno)
          {
	    /* Leemos la imagen*/
	    Lee_pnm_TIPO(&tam_x, &tam_y, argv[1], &v[0], &v[1], &v[2]);
	  
	    tam_unico = DeterminarTamano(tam_x, tam_y);
	    if (tam_unico)
            {
	      printf("\nLa imagen debe ser cuadrada y de dimensiones potencia"
		     " de 2\n");
	    } /* if tam_unico */
	    else
	    {
	      if (tam_x != tam_y)
	      {	    
		printf("\nSe requiere que la imagen sea cuadrada.\n");
	      }
	      else
	      {      		
		momentos[0]=DescYMomTodos(v[0],tam_y,orden,1,umbral,C);
		momentos[1]=DescYMomTodos(v[1],tam_y,orden,1,umbral,C);
		momentos[2]=DescYMomTodos(v[2],tam_y,orden,1,umbral,C);

		
		/* Liberamos memoria */
		free(v[0]);
		v[0]=NULL;
		free(v[1]);
		v[1]=NULL;
		free(v[2]);
		v[2]=NULL;
	      
		/* Escribimos los momentos (la firma) en fichero */
		retonno=EscribirMomTodos(momentos,tam_y,tam_x,argv[2],orden);
		if (retonno != -1)
		  fprintf(lista, "%s %d\n", argv[2], retonno);
	      } /* else => if tam_x != tam_y */
	    } /* else => if tam_unico */
	  } /* if !retonno  */
	} /* else => if !lista */
      } /* else if sscanf != 1 */
    } /* else => if mom3_c == 0 */
    else if ((mom3_ad == 0) && (umb == 0))
    {
      if (sscanf(argv[5],"%f",&umbral) != 1)
	Formato(argv[0]);
      else
      {
	lista = fopen("firmas.m3a", "ab");

	if (!lista)
        {
	  perror("Error al abrir firmas.m3a");
	}
	else
        {
	  /* Nos situamos al final del fichero */
	  retonno = fseek (lista,0, SEEK_END);
	  if (!retonno)
          { 
	    /* Leemos la imagen*/
	    Lee_pnm_TIPO(&tam_x, &tam_y, argv[1], &v[0], &v[1], &v[2]);
	  
	    tam_unico = DeterminarTamano(tam_x, tam_y);
	    if (tam_unico)
	    {
	      printf("\nLa imagen debe ser cuadrada y de dimensiones potencia"
		     " de 2\n");
	    } /* if tam_unico */
	    else
	    {
	      if (tam_x != tam_y)
	      {	    
		printf("\nSe requiere que la imagen sea cuadrada.\n");
	      }
	      else
	      {      		
		momentosTres[0]=DescYMom3AD(v[0],tam_y,1,umbral,NEQ);
		momentosTres[1]=DescYMom3AD(v[1],tam_y,1,umbral,NEQ);
		momentosTres[2]=DescYMom3AD(v[2],tam_y,1,umbral,NEQ);

		
		/* Liberamos memoria */
		free(v[0]);
		v[0]=NULL;
		free(v[1]);
		v[1]=NULL;
		free(v[2]);
		v[2]=NULL;
		
		/* Escribimos los momentos (la firma) en fichero */
		retonno=EscribirMomentosTres(momentosTres,tam_y,tam_x,argv[2]);
		if (retonno != -1)
		  fprintf(lista, "%s %d\n", argv[2], retonno);
	      } /* else => if tam_x != tam_y */
	    } /* else => if tam_unico */
	  } /* if !retonno  */
	} /* else => if !lista */
      } /* else if sscanf != 1 */
    } /* else => if mom3_ad == 0 */
    else if ((en_mom == 0) && (umb == 0))
    {
      if (sscanf(argv[5],"%f",&umbral) != 1)
	Formato(argv[0]);
      else
      {
	lista = fopen("firmas.e_m", "ab");

	if (!lista)
	{
	  perror("Error al abrir firmas.e_m");
	}
	else
        {
	  /* Nos situamos al final del fichero */
	  retonno = fseek (lista,0, SEEK_END);
	  if (!retonno)
	  {
	    /* Leemos la imagen*/
	    Lee_pnm_TIPO(&tam_x, &tam_y, argv[1], &v[0], &v[1], &v[2]);
	  
	    tam_unico = DeterminarTamano(tam_x, tam_y);
	    if (tam_unico)
            {
	      printf("\nLa imagen debe ser cuadrada y de dimensiones potencia"
		     " de 2\n");
	    } /* if tam_unico */
	    else
	    {
	      if (tam_x != tam_y)
	      {
		printf("\nSe requiere que la imagen sea cuadrada.\n");
	      }
	      else
	      {
		tonta=(TIPO)(log((TIPO)tam_x)/log(2.0));
		resolucion=tonta;

		/* Reserva de energia para las covarianzas */
		cov_anal=(TIPO **)calloc(resolucion, sizeof(TIPO *));
		if (cov_anal)
	        {
		  seguir=1;
		  for (i=0; (i<resolucion) && (seguir); i++)
		  {
		    cov_anal[i]=(TIPO *)calloc(3,sizeof(TIPO));
		    seguir=(cov_anal[i] != NULL);
		  } /* for i */
		}
		if (!seguir)
	        {
		  perror("No se pudo reservar memoria para calcular "
			 "covarianzas");
		  exit(1);
		}

		energia=DescYEnerg (v[0],v[1],v[2],tam_y, &cov_anal);
	   

		UmbralizarUser(&v[0],tam_y,tam_x,umbral,VARIANZA);
		UmbralizarUser(&v[1],tam_y,tam_x,umbral,VARIANZA);
		UmbralizarUser(&v[2],tam_y,tam_x,umbral,VARIANZA);


		em[1]=CalcularMomTres_D(v[0],tam_y,tam_y);
		em[2]=CalcularMomTres_D(v[1],tam_y,tam_y);
		em[3]=CalcularMomTres_D(v[2],tam_y,tam_y);	      
		
		/* Liberamos memoria */
		free(v[0]);
		v[0]=NULL;
		free(v[1]);
		v[1]=NULL;
		free(v[2]);
		v[2]=NULL;
	    
		/* Normalizamos y conseguimos los coefs. de correlacion */
		/*printf("\nCorrelaciones: \n");*/
		em[0]=NormalizarCovAnal(energia, &cov_anal, resolucion);

		/* Se supone que se ha liberado la memoria que ocupaban las 
		   covarianzas */
		
		retonno=EscribirEn_Mom(em,resolucion,argv[2]);
		if (retonno != -1)
		  fprintf(lista, "%s %d\n", argv[2], retonno);
		
	      } /* else => if tam_x != tam_y */
	    } /* else => if tam_unico */
	  } /* if !retonno  */
	} /* else => if !lista */
      } /* else => if sscanf */
    } /* else => if (en_mom == 0) */

    else
      Formato(argv[0]);
  } /* else if argc == 6 */
  else /* argc == 7 */ 
  {
    if (strcmp(argv[3],"-sort")!=0)
    {
      Formato(argv[0]);
    }
    else
    {
   
      lista = fopen("transformadas2D.sort", "ab");

      if (!lista)
      {
	perror("Error al abrir transformadas2D.sort");
      }
      else
      {
	/* Nos situamos al final del fichero */
	retonno = fseek (lista,0, SEEK_END);
	if (!retonno)
        {
	  /* Leemos la imagen*/
	  Lee_pnm_TIPO(&tam_x, &tam_y, argv[1], &v[0], &v[1], &v[2]);
	  
	  tam_unico = DeterminarTamano(tam_x, tam_y);
	  if (tam_unico)
          {
	    /*printf("\nComienza cambio de tamano\n");*/
	    Cambiar_Tamano (tam_x, tam_y, v[0], tam_unico, &u[0]);
	    Cambiar_Tamano (tam_x, tam_y, v[1], tam_unico, &u[1]);
	    Cambiar_Tamano (tam_x, tam_y, v[2], tam_unico, &u[2]);
	  
	
	    
	    DescomponerTres (u,tam_unico,tam_unico,atoi(argv[5]),
			     atoi(argv[6]));

	    /*
	      tamano=tam_unico*tam_unico;
	    */
	  
	    ffsal=fopen(argv[2],"wb");
	    if (ffsal == NULL) 
	    { 
	      printf("Error en la creacion de %s\n",argv[2]);
	      printf("Error:	 %d %s \n",errno,strerror(errno));
	    }
	    else
	    {
	      tamano=pow(2,(NIVEL-1));                
	      CortarYConvertir2D(u[0], &vector[0], tamano);
	      free(u[0]);
	      u[0]=NULL;
	      CortarYConvertir2D(u[1], &vector[1], tamano);
	      free(u[1]);
	      u[1]=NULL;
	      CortarYConvertir2D(u[2], &vector[2], tamano);
	      free(u[2]);
	      u[2]=NULL;
	    
	      /* Escribimos el primer valor */
	      retonno = EscribirTres(vector,1,ffsal,argv[2]);
	      if (!retonno)
	      {
		vector[0] = vector[0]+1;
		vector[1] = vector[1]+1;
		vector[2] = vector[2]+1;
	      
		/*printf("\nObteniendo los els. mayores\n");*/
		SelectMayores(atoi(argv[4])/2, tamano-1, &vector[0]);
		SelectMayores(atoi(argv[4])/2, tamano-1, &vector[1]);
		SelectMayores(atoi(argv[4])/2, tamano-1, &vector[2]);
	      
		/*printf("\nEscribiendo los mayores");*/
		/* Escribimos los coefs mas positivos */
		retonno = EscribirTres(vector,atoi(argv[4])/2,ffsal,argv[2]);
		if (!retonno)
	        {
		  /* Escribimos los coefs ma's negativos */
		  /*printf("\nObteniendo los els. menores\n");*/
		  vector[0]=vector[0]+atoi(argv[4])/2;
		  vector[1]=vector[1]+atoi(argv[4])/2;
		  vector[2]=vector[2]+atoi(argv[4])/2;
		  SelectMenores(atoi(argv[4])/2, tamano-1-atoi(argv[4])/2,
				&vector[0]);
		  SelectMenores(atoi(argv[4])/2, tamano-1-atoi(argv[4])/2,
				&vector[1]);
		  SelectMenores(atoi(argv[4])/2, tamano-1-atoi(argv[4])/2,
				&vector[2]);
		  /*printf("\nEscribiendo los menores\n");*/
		  retonno = EscribirTres(vector,atoi(argv[4])/2,ffsal,argv[2]);
		  if (!retonno)
		  {
		    vector[0] = vector[0]-atoi(argv[4])/2-1;
		    vector[1] = vector[1]-atoi(argv[4])/2-1;
		    vector[2] = vector[2]-atoi(argv[4])/2-1;
		    free(vector[0]);
		    vector[0]=NULL;
		    free(vector[1]);
		    vector[1]=NULL;
		    free(vector[2]);
		    vector[2]=NULL;

		    fclose(ffsal);
		    fprintf(lista, "%s %d 1 %d %d\n",argv[2],atoi(argv[4])+1,
			    atoi(argv[5]),atoi(argv[6]));
		  } /* if !retonno de escribir los ma's negativos */
		       
		}/* if !retonno de escribir los ma's positivos */
		    
	      }/* if !retonno de escribir el primer valor */
		  
	    } /* else de la apertura del fichero */
	 
	  }/* if tam_unico */
	  else
	  {
	    
	    DescomponerTres(v,tam_x,tam_y,atoi(argv[5]),atoi(argv[6]));
	    /*
	      tamano = tam_x*tam_y;
	    */
	    ffsal=fopen(argv[2],"wb");
	    if (ffsal == NULL) 
            { 
	      printf("Error en la creacion de %s\n",argv[2]);
	      printf("Error:     %d %s \n",errno,strerror(errno));
	    }
	    else
            {
	      tamano=pow(2,(NIVEL-1));
	      CortarYConvertir2D(v[0], &vector[0], tamano);
	      free(v[0]);
	      v[0]=NULL;
	      CortarYConvertir2D(v[1], &vector[1], tamano);
	      free(v[1]);
	      v[1]=NULL;
	      CortarYConvertir2D(v[2], &vector[2], tamano);
	      free(v[2]);
	      v[2]=NULL;

	      /* Escribimos el primer valor */
	      retonno = EscribirTres(vector,1,ffsal,argv[2]);
	      if (!retonno)
              {
		vector[0] = vector[0]+1;
		vector[1] = vector[1]+1;
		vector[2] = vector[2]+1;
 
		/*printf("\nObteniendo los els. mayores\n");*/
		SelectMayores(atoi(argv[4])/2,tamano-1, &vector[0]);
		SelectMayores(atoi(argv[4])/2,tamano-1, &vector[1]);
		SelectMayores(atoi(argv[4])/2,tamano-1, &vector[2]);

		/*printf("Escribiendo los mayores\n");*/
		/* Escribimos los coefs mas positivos */
		retonno = EscribirTres(vector,atoi(argv[4])/2,ffsal,argv[2]);
		if (!retonno)
                {
		  /* Escribimos los coefs mas negativos */
		  vector[0]=vector[0]+atoi(argv[4])/2;
		  vector[1]=vector[1]+atoi(argv[4])/2;
		  vector[2]=vector[2]+atoi(argv[4])/2;
		  /*printf("\nObteniendo los menores\n");*/
		  SelectMenores(atoi(argv[4])/2, tamano-1-atoi(argv[4])/2,
				&vector[0]);
		  SelectMenores(atoi(argv[4])/2, tamano-1-atoi(argv[4])/2,
				&vector[1]);
		  SelectMenores(atoi(argv[4])/2, tamano-1-atoi(argv[4])/2,
				&vector[2]);

		  /*printf("Escribiendo los menores\n");*/
		  retonno = EscribirTres(vector,atoi(argv[4])/2,ffsal,argv[2]);
		  if (!retonno)
		  {
		    vector[0] = vector[0]-atoi(argv[4])/2-1;
		    vector[1] = vector[1]-atoi(argv[4])/2-1;
		    vector[2] = vector[2]-atoi(argv[4])/2-1;
		    free(vector[0]);
		    vector[0]=NULL;
		    free(vector[1]);
		    vector[1]=NULL;
		    free(vector[2]);
		    vector[2]=NULL;
		    fclose(ffsal);

		    fprintf(lista, "%s %d 1 %d %d\n",argv[2],atoi(argv[4])+1,
			    atoi(argv[5]),atoi(argv[6]));
		  } /* if !retonno de escribir los ma's negativos */
                       
		}/* if !retonno de escribir los ma's positivos */
                    
	      }/* if !retonno de escribir el primer valor */
		  
	    } /* else de la apertura del fichero */
	  
	  } /* else => if tam_unico */
	} /* If !retonno */
	else /* retonno != 0 */
        {
	  perror("Fallo al hacer el fseek.");
	}
	fclose(lista);
      } /* else del if (!lista)*/
	   
    } /* else de if "-sort" */
  } /* else => argc == 7 */
}/* main */
